<?php
/*
Plugin Name: 1-Click Blog Post
Plugin URI: http://1clickblogpost.com
Description: Create blog posts from Youtube videos in just 1-Click
Author: Ankur Shukla
Version: 1.14
Author URI: https://ankurshukla.com
*/

if (!defined('ABSPATH')) exit;

// Constants
define( 'ONECLICKBP_VERSION', '1.14' );

define( 'ONECLICKBP_PLUGIN_NAME', dirname( plugin_basename( __FILE__ ) ) );
define( 'ONECLICKBP_DIR', plugin_dir_path( __FILE__ ) );
define( 'ONECLICKBP_URL', plugins_url( ONECLICKBP_PLUGIN_NAME ) );

require ONECLICKBP_DIR.'/lib/common.php';
if ( is_admin() ) {
    require ONECLICKBP_DIR.'/lib/ui.php';
    require ONECLICKBP_DIR.'/lib/utils.php';
    require ONECLICKBP_DIR.'/lib/settings.php';
    require ONECLICKBP_DIR.'/lib/help.php';
    require ONECLICKBP_DIR.'/lib/styles/dashboard.php';
    require ONECLICKBP_DIR.'/lib/styles/styles.php';
}
else {
    require ONECLICKBP_DIR.'/lib/frontend.php';
}
require ONECLICKBP_DIR.'/lib/youtube_fns.php';
require ONECLICKBP_DIR.'/lib/youtube_api.php';

add_action( 'wp_ajax_get_tube_data', 'oneclickbm_get_tube_data' );
add_action( 'wp_ajax_nopriv_get_tube_data', 'oneclickbm_get_tube_data' );
add_action( 'wp_ajax_oc_search_videos', 'oneclickbm_search_videos_ajax' );

/* Automatic Updates */
require ONECLICKBP_DIR.'/lib/plugin-updates/plugin-update-checker.php';
$puchcker = new Puc_v4p9_Plugin_UpdateChecker(
    ( oneclickbm_is_pro() ? 'https://knighterrant.s3.us-west-2.amazonaws.com/software/oneclickbp/2-pro/info_wpbp2.json' : 'https://knighterrant.s3.us-west-2.amazonaws.com/software/oneclickbp/1-std/info_wpbp1.json' ),
    ONECLICKBP_DIR.ONECLICKBP_PLUGIN_NAME.'.php'
);
?>