<?php
function oneclickbp_register_menu() {
    // delete_site_option( 'as_style1' );
    // delete_option( 'as_style1' );
    $style27 = ask32_lic_status();
    // var_dump($style27);
    if( oneclickbm_is_pro() ) {
	    $page1 = add_menu_page("1-Click Blog Post", "1-Click Blog Post", "manage_options", "oneclick-blog-post", ($style27 ? 'oneclickbm_settings' : 'ask32_settings') );
        if( $style27 ) {
            $page2 = add_submenu_page("oneclick-blog-post", "Create More", "Create More", "manage_options", "oneclick-blog-post", 'oneclickbm_settings' );
            add_action( "admin_print_scripts-$page2", 'oneclickbp_admin_scripts' );
            add_action( "admin_print_styles-$page2", 'oneclickbp_admin_style' );
        }
    }
    else {
        // var_dump($style27);
        $page1 = add_menu_page("1-Click Blog Post", "1-Click Blog Post", "manage_options", "oneclick-blog-post", ($style27 ? 'oneclickbm_screen_help' : 'ask32_settings') );
    }

    $page3 = add_submenu_page("oneclick-blog-post", "Help", "Help", "manage_options", "oneclick-blog-post-help", 'oneclickbm_screen_help' );

    add_action( "admin_print_scripts-$page1", 'oneclickbp_admin_scripts' );
    add_action( "admin_print_styles-$page1", 'oneclickbp_admin_style' );
    add_action( "admin_print_scripts-$page3", 'oneclickbp_admin_scripts' );
    add_action( "admin_print_styles-$page3", 'oneclickbp_admin_style' );
}

add_action( 'admin_menu', 'oneclickbp_register_menu' );


function oneclickbp_admin_scripts() {

}

function oneclickbp_admin_style() {
  wp_register_style('oneclickbp_font_awesome_css', 'https://use.fontawesome.com/releases/v5.11.2/css/all.css', array(), ONECLICKBP_VERSION);
  wp_enqueue_style('oneclickbp_font_awesome_css');
}


add_action('admin_enqueue_scripts', 'oneclickbp_add_admin_assets' );

function oneclickbp_add_admin_assets() {
    wp_register_style( 'custom_wp_admin_css', ONECLICKBP_URL.'/css/admin.css?t='.ONECLICKBP_VERSION, false, '1.0.0' );
    wp_enqueue_style( 'custom_wp_admin_css' );
    wp_enqueue_script( 'readutube-admin', ONECLICKBP_URL.'/js/admin.js?t='.ONECLICKBP_VERSION, array( 'jquery' ), '1.0.7' );
}

/* Meta Box */

add_action( 'add_meta_boxes', 'oneclickbp_box' );


function oneclickbp_box() {
    add_meta_box( 'oneclickbp_box', '1-Click Blog Post', 'oneclickbp_box_content' ) ;
}

function oneclickbp_box_content() {
    global $post;

    $url = get_post_meta( $post->ID, 'readutube_url', true);
    $readutube_video = get_post_meta( $post->ID, 'readutube_video', true);
    $timecode = get_post_meta( $post->ID, 'readutube_timecode', true);
    $img = get_post_meta( $post->ID, 'readutube_img', true);

?>
<table class="form-table">
<tbody>
    <tr>
        <th scope="row"><label for="readutube_url">Youtube URL</label></th>
        <td>
            <input type='url' id='readutube_url' class='large-text' name='readutube_url' placeholder='Enter the YouTube URL here' value='<?php echo $url;?>' />
            <p class="pexplain">Enter a Youtube video URL, for ex: https://www.youtube.com/watch?v=6Af6b_wyiwI</p>
        </td>
    </tr>
    <?php if( oneclickbm_is_pro() ) { ?>
    <tr>
        <th scope="row"><label for="readutube_video">Insert Video</label></th>
        <td>
            <input type='checkbox' id='readutube_video' name='readutube_video' <?php checked( $readutube_video, 1, true );?> />
            <p class="pexplain">If you check this box, the video will be embedded at the begining of the post.</p>
        </td>
    </tr>
    <tr>
        <th scope="row"><label for="readutube_timecode">Add Timecode</label></th>
        <td>
            <input type='checkbox' id='readutube_timecode' name='readutube_timecode' <?php checked( $timecode, 1, true );?> />
            <p class="pexplain">If you check this box, it will add the video/subtitles times to the post.</p>
        </td>
    </tr>
    <tr>
        <th scope="row"><label for="readutube_img">Set Video Image as Featured Image</label></th>
        <td>
            <input type='checkbox' id='readutube_img' name='readutube_img' <?php checked( $img, 1, true );?> />
            <p class="pexplain">If you check this box, the video image will be set as featured image for the post (note: you need to save the post first).</p>
        </td>
    </tr>
    <?php } ?>
    <tr>
        <th scope="row"><label for="">&nbsp;</label></th>
        <td>
            <a href='javascript: void(0);' class='button button-primary' id='ocget_tube_data' data-post-id="<?php echo $post->ID;?>">+ Insert Content</a> &nbsp; <a href='javascript: void(0);' class='button button-secondary' id='occlick_search'"><i class="fa fas fa-search"></i> Search Videos</a>
        </td>
    </tr>
</tbody>
</table>
<p>Note - This plugin can only pull content from videos with subtitles, if a video does not have them, please select another video on that topic by using the search option above. </p>
<?php
return;
    echo "
        <div class='readutube'>
            <div class='readutube_row'>
                <label for='readutube_url'>YouTube URL</label>
                <input type='url' id='readutube_url' class='regular-text' name='readutube_url' placeholder='Enter the YouTube URL here' value='".$url."' />
                
            </div>
            <div class='link_machine_row mt-0'>&nbsp;</div>

         <div class='readutube_row'>
                <label for='readutube_video'>Insert Video</label>
                <input type='checkbox' id='readutube_video' name='readutube_video' value='1' ".($readutube_video == '1' ? 'checked=checked' : '')." />
            </div>
            <div class='link_machine_row mt-0'>&nbsp;</div>

            <div class='readutube_row'>
                <label for='readutube_timecode'>Add Timecode</label>
                <input type='checkbox' id='readutube_timecode' name='readutube_timecode' value='1' ".($timecode == '1' ? 'checked=checked' : '')." />
            </div>
            <div class='link_machine_row mt-0'>&nbsp;</div>

            <div class='readutube_row'>
                <label for='readutube_timecode'>Set Video Image as Featured Image</label>
                <input type='checkbox' id='readutube_img' name='readutube_img' value='1' ".($img == '1' ? 'checked=checked' : '')." />
            </div>
            <div class='link_machine_row mt-0'>&nbsp;</div>

            <div class='readutube_row'>
                <label for='get_tube_data'> </label>
                <a href='javascript: void(0);' class='button button-primary' id='get_tube_data' onclick='insertData(".$post->ID.");'>Insert Content</a>
            </div>
            <div class='link_machine_row mt-0'>&nbsp;</div>
            <div class='clear'></div>
    ";
}

add_action( 'save_post', 'oneclickbp_save_post_data' );

function oneclickbp_save_post_data( $post_id ) {
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
        return;

    if( isset( $_POST['readutube_url'] ) ) {
        $vid = oneclickbm_get_youtubeID($_POST['readutube_url']);
        update_post_meta( $post_id, 'readutube_url', $_POST['readutube_url'] );
        update_post_meta( $post_id, 'readutube_id', $vid );
    }
    if( isset( $_POST['readutube_video'] ) )
        update_post_meta( $post_id, 'readutube_video', $_POST['readutube_video'] );
    if( isset( $_POST['readutube_img'] ) )
        update_post_meta( $post_id, 'readutube_img', $_POST['readutube_img']);
    if( isset( $_POST['readutube_timecode'] ) )
        update_post_meta( $post_id, 'readutube_timecode', $_POST['readutube_timecode'] );

    if (isset($_POST['readutube_img']) ) {
        oneclickbm_addThumbnail( $post_id, $vid );
    }
}
?>