<?php
function oneclickbm_endsWith($string, $endString) {
    // return false;
    $len = strlen( $endString );
    if ( $len == 0 ) {
        return true;
    }
    return (substr($string, -$len) === $endString);
}

function oneclickbm_array_to_csv_download($array, $filename = "export.csv", $delimiter=";") {
    $f = fopen('php://memory', 'w');
    foreach ($array as $line) {
        fputcsv($f, $line, $delimiter);
    }
    fseek($f, 0);
    header('Content-Type: application/csv');
    header('Content-Disposition: attachment; filename="'.$filename.'";');
    fpassthru($f);
}

function oneclickbm_array_key_last( $array ) {
    if (! function_exists("array_key_last")) {
            if (!is_array($array) || empty($array)) {
                return NULL;
            }
            return array_keys($array)[count($array)-1];
    }
    else {
        return array_key_last( $array );
    }
}

function oneclickbm_get_file_contents_proxy( $url )
{
    $proxy_url = oneclickbm_proxies();
    $proxy_url = $proxy_url.'?u='.urlencode( $url );
    $response = wp_remote_get( $proxy_url );
    if( is_wp_error( $response ) )
        return false;
    $responseBody = wp_remote_retrieve_body( $response );
    return $responseBody;
}

function oneclickbm_get_file_contents( $url )
{
    $response = file_get_contents ( $url );
    if( !empty( $response ) )
        return $response;
    $response = oneclick_get_curl( $url );
    if( !empty( $response ) )
        return $response;
    $response = wp_remote_get( $url );
    if( is_wp_error( $response ) ) {
        $proxy_url = oneclickbm_proxies();
        $proxy_url = $proxy_url.'?u='.urlencode( $url );
        $response = wp_remote_get( $proxy_url );
        if( is_wp_error( $response ) )
            return false;
    }
    $responseBody = wp_remote_retrieve_body( $response );
    if( $responseBody == false ) {
        $proxy_url = oneclickbm_proxies();
        $proxy_url = $proxy_url.'?u='.urlencode( $url );
        $response = wp_remote_get( $proxy_url );
        if( is_wp_error( $response ) )
            return false;
        $responseBody = wp_remote_retrieve_body( $response );
    }
    return $responseBody;
}

function oneclickbm_count_capitals( $string ) {
    $string = str_replace( 'I', 'i', $string );
    $lowerCase = mb_strtolower( $string );
    return strlen( $lowerCase ) - similar_text( $string, $lowerCase );
}

function oneclickbm_not_formatted( $ret ) {
    if( ( substr_count ( $ret, '.' ) < 5 ) || ( oneclickbm_count_capitals( $ret ) < 5 )  || ( substr_count ( $ret, "\n" ) < 4 ) )
        return true;
    return false;
}
function oneclickbm_proxies() {
    $proxies = array(
        // 'http://localhost/test/seo/fileget.php'
        'https://wpmoneymachine.com/leaderboard/fileget.php',
        'https://1website.in/yt/fileget.php',
        'https://qnote.in/yt/fileget.php',
        'https://formhelpr.com/yt/fileget.php',
        'https://maulshree.com/yt/fileget.php',
        'https://wpmoneymachine.com/leaderboard/fileget.php',
    );
    return $proxies[ array_rand( $proxies ) ];
}


function oneclick_get_rand_proxy() {
    $proxies = oneclickbm_get_proxiesl();
    return $proxies[ array_rand( $proxies ) ];
}

function oneclickbm_get_proxiesl() {
    $proxies = array();
    $handle = fopen(ONECLICKBP_DIR."/lib/proxies.txt", "r");
    if ($handle) {
        while (($line = fgets($handle)) !== false) {
            // process the line read.
            if( empty( $line ) )
                continue;
            $proxy = explode( ':', $line );
            $proxies[] = $proxy;
        }

        fclose($handle);
    } else {
        // error opening the file.
        return false;
    }
    return $proxies;
}

function oneclick_get_curl( $url, $use_proxy = false ) {
    $proxy = oneclick_get_rand_proxy();
    // var_dump($proxy);return;
    // $url = 'http://php.net';

    //The IP address of the proxy you want to send
    //your request through.
    $proxyIP = /*'1.2.3.4'*/$proxy[0];

    //The port that the proxy is listening on.
    $proxyPort = /*'1129'*/$proxy[1];

    //The username for authenticating with the proxy.
    $proxyUsername = /*'myusername'*/$proxy[2];

    //The password for authenticating with the proxy.
    $proxyPassword = /*'mypassword'*/$proxy[3];


    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL , 1);

    //Set the proxy IP.
    curl_setopt($ch, CURLOPT_PROXY, $proxyIP);

    //Set the port.
    curl_setopt($ch, CURLOPT_PROXYPORT, $proxyPort);

    //Specify the username and password.
    curl_setopt($ch, CURLOPT_PROXYUSERPWD, "$proxyUsername:$proxyPassword");

    //Execute the request.
    $output = curl_exec($ch);

    //Check for errors.
    if(curl_errno($ch)){
        throw new Exception(curl_error($ch));
    }

    //Print the output.
    return $output;
}
?>