<?php
function oneclickbm_get_tube_data() {
    if ( $_POST['url'] != "" ) {
    	$video_url = trim( $_POST['url'] );
    	$lang = isset( $_POST['lang'] ) ? $_POST['lang'] : false;
    	$has_timer = isset( $_POST['has_timer'] ) ? $_POST['has_timer'] : false;
    	if( empty( $lang ) ) {
    		$languages = oneclickbm_get_cc_languages( $video_url );
    		if( empty( $languages ) ) {
                // we try alternative method
                $ret = oneclickbm_getAltVideoDataFromURL( $video_url, false, false, $has_timer );
                if( empty( $ret ) )
    			 echo json_encode( array( 'error' => 1, 'reason' => 1 ) );
                else
                    echo $ret;
                    // var_dump($ret);
    			exit();
    		}
    		else if( count( $languages ) == 1 ) {
    			//only 1 language, go ahead
    			oneclickbm_getVideoDataFromURL( $video_url, false, false, $has_timer );
    		}
    		else {
    			echo json_encode( array( 'error' => 0, 'action' => 0, 'languages' => $languages ) );
    		}
    	}
    	else {
    		oneclickbm_getVideoDataFromURL( $video_url, false, $lang, $has_timer );
    	}
        exit();
    }
    return;
}

function oneclickbm_get_cc_languages( $video_url ) {
	$tube = oneclickbm_get_youtubeID( $video_url );
    $initial_data = oneclickbm_get_file_contents( "https://youtube.com/get_video_info?video_id=" . $tube );
    $decoded = urldecode( $initial_data );
    // var_dump($decoded);
    $languages = array();
// var_dump($decoded);
    if (strpos($decoded, "captionTracks") > 0) {
        $regex = '/({"captionTracks":.*isTranslatable":(true|false)}])/';
        preg_match($regex, $decoded, $tmp, PREG_OFFSET_CAPTURE);
        $json = $tmp[0][0] . '}';
        $json = json_decode($json, true);
// var_dump($json);

        $json = $json['captionTracks'];

        if ( count( $json ) > 0 ) {
            $scripts = array();
            foreach ( $json as $key => $value ) {
            	// var_dump($value);
            	$languages[] = array( 'id' => $value[ 'languageCode' ], 'name' => oneclickbm_language_name( $value[ 'languageCode' ] ) );
            }
        }
    }
    return $languages;
}

function oneclickbm_getVideoDataFromURL( $url, $return = false, $language = false, $has_timer = false ) {
    $tube = oneclickbm_get_youtubeID( $url );
    // $vtitle = explode( '</title>',explode('<title>',oneclickbm_get_file_contents("https://www.youtube.com/watch?v=" . $tube))[1])[0];
    $vtitle = oneclickbm_get_video_title( $tube );
    $dataArr = array(
        "id" => $tube,
        "title" => $vtitle,
        // "title" => str_replace( ' - YouTube', '', $vtitle ),
        "img" => "https://img.youtube.com/vi/".$tube."/default.jpg",
        "content" => array("0" => array("stamp" => "", "content" => "")),
        "leads" => array()
    );

    $initial_data = oneclickbm_get_file_contents( "https://youtube.com/get_video_info?video_id=" . $tube );
    $decoded = urldecode( $initial_data );
// var_dump($decoded);
    if (strpos($decoded, "captionTracks") > 0) {
        $regex = '/({"captionTracks":.*isTranslatable":(true|false)}])/';
        preg_match($regex, $decoded, $tmp, PREG_OFFSET_CAPTURE);
        $json = $tmp[0][0] . '}';
        $json = json_decode($json, true);
// var_dump($json);
        $json = $json['captionTracks'];
        if ( count( $json ) > 0 ) {
            // die( 'tracks' );
            $scripts = array();
            foreach ($json as $key => $value) {
                // var_dump(count($json));
                if ( empty( $language ) || ( $value['languageCode'] == /*'en'*/ $language ) || ( count( $json ) == 1 )/* && $value['isTranslatable']*/ ) {
                    $url = $value['baseUrl'];
                    // var_dump($url);
                    $data = oneclickbm_get_file_contents( $url );
                    $caps = simplexml_load_string($data);
                    foreach ($caps->children() as $node) {
                        $scripts[] = array(
                            "start" => (float)$node['start'],
                            "end" => (float)$node['start'] + $node['dur'],
                            "duration" => (float)$node['dur'],
                            "text" => (string)$node
                        );
                    }
                }
            }
// var_dump($scripts);
            if ( count( $scripts ) > 0 ) {
                $last_end = 0;
                // $prev_line = "";
                if( $has_timer && oneclickbm_should_fix_scripts( $scripts ) ) {
                    $scripts = oneclickbm_fix_scripts( $scripts );
                    foreach ( $scripts as $note ) {
                        $dataArr['content'][] = array(
                            "start" => $note['start'],
                            "stamp" => oneclickbm_hmi( $note['start'] ),
                            "content" => $note[ 'text' ]
                        );
                    }
                }
                else {
                    foreach ($scripts as $note) {

                        $note['text'] = trim( $note['text'] );
                        // var_dump($note['text']);
                        if ( $last_end == 0 ) {
                            $dataArr['content'][] = array(
                                "start" => $note['start'],
                                "stamp" => oneclickbm_hmi($note['start']),
                                "content" => $note['text']
                            );
                        }
                        else {
                            //Ongoing conversation
                            if ($prev_line != "" && oneclickbm_endsWith( $prev_line, "." ) ) {
                                if ( $note['end'] > $last_end + 3 ) {
                                    $dataArr['content'][] = array(
                                        "start" => $note['start'],
                                        "stamp" => oneclickbm_hmi( $note['start'] ),
                                        "content" => ""
                                    );
                                }
                            }
                            $dataArr['content'][ oneclickbm_array_key_last( $dataArr['content'] ) ][ 'content' ] .= " " . $note['text'];
                        }

                        $last_end = $note['end'];
                        $prev_line = $note['text'];
                    } // end foreach
                } // end else
// var_dump( $return );
                if ( !$return ) {
                    // var_dump($dataArr);
                	$dataArr[ 'content' ] = oneclickbm_fix_content( $dataArr[ 'content' ], $has_timer );
                	$ret = array( 'error' => 0, 'action' => 1, 'data' => $dataArr );
                    echo json_encode( $ret );
                    die();
                }
                else {
                    $dataArr[ 'content' ] = oneclickbm_fix_content( $dataArr[ 'content' ], $has_timer );
                    return json_encode( $dataArr );
                }

            } // if count scripts
        } // if( count ( json ))
        // else {
            // die( 'no tracks' );
        // }
    }  // if strpos
    // else {
    //     die( 'kkk' );
    // }
    return;
}

/// ALTERNATE METHOD

function oneclickbm_getAltVideoDataFromURL( $url, $return = false, $language = false, $has_timer = false ) {
    $tube = oneclickbm_get_youtubeID( $url );
    // $vtitle = explode( '</title>',explode('<title>',oneclickbm_get_file_contents("https://www.youtube.com/watch?v=" . $tube))[1])[0];
    $vtitle = oneclickbm_get_video_title( $tube );
    $dataArr = array(
        "id" => $tube,
        "title" => $vtitle,
        // "title" => str_replace( ' - YouTube', '', $vtitle ),
        "img" => "https://img.youtube.com/vi/".$tube."/default.jpg",
        "content" => array("0" => array("stamp" => "", "content" => "")),
        "leads" => array()
    );

    // $tube = 'Kt8RupLIkBQ';
    $initial_data = oneclickbm_get_file_contents( 'http://video.google.com/timedtext?type=track&v='.$tube.'&id=0&lang=en' );
    if( empty( $initial_data ) )
        return false;
    $xml = simplexml_load_string($initial_data, 'SimpleXMLElement');
    $ret = array();
    foreach ( $xml->text as $value ) {
        $attributes = $value->attributes();
        $start = isset( $attributes->start ) ? $attributes->start : 0;
        $dur = isset( $attributes->dur ) ? $attributes->dur : 0;
        $text = (string) $value;
        // if( empty( $text ) )
        //  continue;
        $fila = array(
            'start' => (string) $start,
            'dur' => (string) $dur,
            'text' => $text
        );
        $ret[] = $fila;
    }
    if( empty( $ret ) )
        return false;

        foreach ($ret as $node) {
            $scripts[] = array(
                "start" => (float)$node['start'],
                "end" => (float)$node['start'] + (float)$node['dur'],
                "duration" => (float)$node['dur'],
                "text" => (string)$node['text']
            );
        }

        if( $has_timer && oneclickbm_should_fix_scripts( $scripts ) ) {
            $scripts = oneclickbm_fix_scripts( $scripts );
            foreach ( $scripts as $note ) {
                $dataArr['content'][] = array(
                    "start" => $note['start'],
                    "stamp" => oneclickbm_hmi( $note['start'] ),
                    "content" => $note[ 'text' ]
                );
            }
        }
        else {
                foreach ($scripts as $note) {

                    $note['text'] = trim( $note['text'] );
                    // var_dump($note['text']);
                    if ( $last_end == 0 ) {
                        $dataArr['content'][] = array(
                            "start" => $note['start'],
                            "stamp" => oneclickbm_hmi($note['start']),
                            "content" => $note['text']
                        );
                    }
                    else {
                        //Ongoing conversation
                        if ($prev_line != "" && oneclickbm_endsWith( $prev_line, "." ) ) {
                            if ( $note['end'] > $last_end + 3 ) {
                                $dataArr['content'][] = array(
                                    "start" => $note['start'],
                                    "stamp" => oneclickbm_hmi( $note['start'] ),
                                    "content" => ""
                                );
                            }
                        }
                        $dataArr['content'][ oneclickbm_array_key_last( $dataArr['content'] ) ][ 'content' ] .= " " . $note['text'];
                    }

                    $last_end = $note['end'];
                    $prev_line = $note['text'];
                } // end foreach
            } // end else

        // $dataArr[ 'content' ] = oneclickbm_fix_content( $dataArr[ 'content' ], $has_timer );

        $dataArr[ 'content' ] = oneclickbm_fix_content( $dataArr[ 'content' ], $has_timer );
        $ret = array( 'error' => 0, 'action' => 1, 'data' => $dataArr );
        return json_encode( $ret );

   /*         if ( count( $scripts ) > 0 ) {
                $last_end = 0;
                // $prev_line = "";
                if( $has_timer && oneclickbm_should_fix_scripts( $scripts ) ) {
                    $scripts = oneclickbm_fix_scripts( $scripts );
                    foreach ( $scripts as $note ) {
                        $dataArr['content'][] = array(
                            "start" => $note['start'],
                            "stamp" => oneclickbm_hmi( $note['start'] ),
                            "content" => $note[ 'text' ]
                        );
                    }
                }
                else {
                    foreach ($scripts as $note) {

                        $note['text'] = trim( $note['text'] );
                        // var_dump($note['text']);
                        if ( $last_end == 0 ) {
                            $dataArr['content'][] = array(
                                "start" => $note['start'],
                                "stamp" => oneclickbm_hmi($note['start']),
                                "content" => $note['text']
                            );
                        }
                        else {
                            //Ongoing conversation
                            if ($prev_line != "" && oneclickbm_endsWith( $prev_line, "." ) ) {
                                if ( $note['end'] > $last_end + 3 ) {
                                    $dataArr['content'][] = array(
                                        "start" => $note['start'],
                                        "stamp" => oneclickbm_hmi( $note['start'] ),
                                        "content" => ""
                                    );
                                }
                            }
                            $dataArr['content'][ oneclickbm_array_key_last( $dataArr['content'] ) ][ 'content' ] .= " " . $note['text'];
                        }

                        $last_end = $note['end'];
                        $prev_line = $note['text'];
                    } // end foreach
                } // end else
// var_dump( $return );
                if ( !$return ) {
                    // var_dump($dataArr);
                    $dataArr[ 'content' ] = oneclickbm_fix_content( $dataArr[ 'content' ], $has_timer );
                    $ret = array( 'error' => 0, 'action' => 1, 'data' => $dataArr );
                    return json_encode( $ret );
                    die();
                }
                else {
                    return json_encode($dataArr);
                }

            } // if count scripts */
    // }
    return;
}

function oneclickbm_should_fix_scripts( $scripts ) {
    $punctuations = 0;
    foreach( $scripts as $script ) {
        if( oneclickbm_endsWith( $script[ 'text' ], '.' ) ) {
            $punctuations++;
        }
    }
    // var_dump($punctuations);
    if( $punctuations >= 2 ) {
        // ok, return as is
        return false;
    }
    return true;
}

function oneclickbm_fix_scripts( $scripts ) {
    $ret = array();
    $text = '';
    $start = '';
    $end = '';
    $current = array();
    $n = 0;
    $i = 0;
    foreach( $scripts as $script ) {
        if( $i == 0 ) {
            $script[ 'text' ] = trim( $script[ 'text' ] );
            $script[ 'text' ] = ucfirst( $script[ 'text' ] );
            $i++;
        }
        if( empty( $n ) )
            $start = $script[ 'start' ];
        $text = $text . ' '.$script[ 'text' ];
        // var_dump($i);
        // var_dump($text);

        $end = $script[ 'end' ];
        $n++;
        if( $n >= 3 ) {
            $current = array(
                'start' => $start,
                'end' => $end,
                'duration' => $end-$start,
                'text' => trim( $text )
            );
            $ret[] = $current;
            $current = array();
            $text = '';
            $n = 0;
        }
    }
    // var_dump($ret);
    return $ret;
}
// }

function oneclickbm_fix_content( $content, $has_timer = false ) {
	$ret = '';
	foreach( $content as $chunk ) {
        // var_dump($chunk);
		if( $has_timer ) {
            if( !empty( $chunk['start'] ) )
			$ret .= '<br/><a style="cursor: pointer;" data-seek="'.$chunk['start'].'" class="seek">'.$chunk['stamp'].'</a><br/>';
        }
		$ret .= $chunk['content'];
	}
    if( $has_timer )
        return $ret;
	// var_dump(substr_count ( $ret, '.' ));
    if( oneclickbm_not_formatted( $ret ) ) {
	// if( substr_count ( $ret, '.' ) < 5 ) {
		// no puntos
		$ret = oneclickbm_punctuate( $ret, false );
	}
	$paragraphs = oneclickbm_breakLongText( $ret );
	return oneclick_paragraphs( $paragraphs );
}

function oneclick_paragraphs( $ps ) {
	if( empty( $ps ) )
		return '';
	/*if( !is_array( $ps ) )
		return oneclickbm_punctuate( $ps, false ) ;
	$ret = '';
	if( count( $ps ) < 3 )
		return oneclickbm_punctuate( $ps, true );*/
    $ret = '';
	foreach( $ps as $p ) {
		$ret .= '<p>'.$p.'</p>';
	}
	return $ret;
}

function oneclickbm_punctuate( $ps, $is_array = false ) {
	return oneclick_punctuate_api( $ps );
	return $ps;
	if( !$is_array )
		$text = $ps;
	else
		$text = implode( '. ', $ps );
	$ret = oneclick_punctuate_api( $text );
	if( !empty( $ret ) )
		return $ret;
	return oneclickbm_breakLongText( $text );
}

function oneclick_punctuate_api( $text ) {
	// http://bark.phon.ioc.ee/punctuator
	// wp_remote_post(  );
	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL,'http://bark.phon.ioc.ee/punctuator');
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, "text=".urlencode( $text ) );

	// Receive server response ...
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

	$server_output = curl_exec($ch);
	$from = array( ' & # 39 ', 'gon na' );
	$to = array( "'", "gonna" );
	$ret = str_replace( $from, $to, $server_output );
	curl_close ($ch);
	return $ret;
}

function oneclickbm_breakLongText( $text, $length = 200, $maxLength = 500 ){
    // return $text;
 //Text length
 $textLength = strlen($text);

 //initialize empty array to store split text
 $splitText = array();

 //return without breaking if text is already short
 if (!($textLength > $maxLength)){
  $splitText[] = $text;
  return $splitText;
 }

 //Guess sentence completion
 $needle = '.';

 /*iterate over $text length
   as substr_replace deleting it*/
 while (strlen($text) > $length){

  $end = strpos($text, $needle, $length);

  if ($end === false){

   //Returns FALSE if the needle (in this case ".") was not found.
   $splitText[] = substr($text,0);
   $text = '';
   break;

  }

  $end++;
  $splitText[] = substr($text,0,$end);
  $text = substr_replace($text,'',0,$end);

 }

 if ($text){
  $splitText[] = substr($text,0);
 }

 return $splitText;

}


function oneclickbm_addThumbnail($post_id, $video_id) {
    $image_url = oneclickbm_get_thumbnail( $video_id );

    $upload_dir = wp_upload_dir();
    $image_data = oneclickbm_get_file_contents( $image_url );
    $filename = time() . '-' . basename($image_url);
    $file = (wp_mkdir_p($upload_dir['path'])) ? $upload_dir['path'] . '/' . $filename : $upload_dir['basedir'] . '/' . $filename;

    file_put_contents($file, $image_data);

    $wp_filetype = wp_check_filetype($filename, null );
    $attachment = array(
        'post_mime_type' => $wp_filetype['type'],
        'post_title' => sanitize_file_name($filename),
        'post_content' => '',
        'post_status' => 'inherit'
    );
    $attach_id = wp_insert_attachment( $attachment, $file, $post_id );
    require_once(ABSPATH . 'wp-admin/includes/image.php');
    $attach_data = wp_generate_attachment_metadata( $attach_id, $file );
    $res1= wp_update_attachment_metadata( $attach_id, $attach_data );
    $res2= set_post_thumbnail( $post_id, $attach_id );
    return;
}

function oneclickbm_footer_script() {
?>
    <!-- Login modal embedded in page -->
    <div id="oneclick-modal" class="ac-modal" style="display:none">
      <p>This Video contains multiple languages, please select the one you would like for the content:</p>
      <div style="margin-bottom: 15px;"><b>Language: </b> &nbsp; <select id="oc-video-lang"></select></div>
      <button id="ocdo-insert-language" class="button button-primary" style="margin-right:15px;">Select Language</button>
      <a href="#close" class="button button-secondary" rel="acmodal2:close">Cancel</a>
    </div>
    <div id="oneclick-modal-search" class="ac-modal ac-medium-modal" style="display:none">
      <p>Search for youtube videos with content:</p>
      <div style="margin-bottom: 15px;"><b>Keyword: </b> &nbsp; <input type="text"  class="medium-text" value="" id="oneclick-keyword" /></div>
      <div id="oneclick-results" style="display:none"></div>
      <button id="ocdo-search" class="button button-primary" style="margin-right:15px;">Search</button>
      <a href="#close" class="button button-secondary" rel="acmodal2:close">Cancel</a>
    </div>
<?php
}

/* All helper functions */
function oneclickbm_get_youtubeID( $url ) {
    if( empty( $url ) )
        return '';
    if (stristr($url,'youtu.be/')) {
        preg_match('/(https:|http:|)(\/\/www\.|\/\/|)(.*?)\/(.{11})/i', $url, $final_ID);
        return $final_ID[4];
    }
    else  {
        @preg_match('/(https:|http:|):(\/\/www\.|\/\/|)(.*?)\/(embed\/|watch.*?v=|)([a-z_A-Z0-9\-]{11})/i', $url, $IDD);
        return $IDD[5];
    }
}

function oneclickbm_hmi($seconds) {
    //return ''; //rmi353
    $t = round($seconds);
    return sprintf('%02d:%02d:%02d', ($t/3600),($t/60%60), $t%60);
}

add_action( "admin_footer", "oneclickbm_footer_script" );

function oneclickbm_language_name( $code ) {
    $codes = [
        'ab' => 'Abkhazian',
        'aa' => 'Afar',
        'af' => 'Afrikaans',
        'ak' => 'Akan',
        'sq' => 'Albanian',
        'am' => 'Amharic',
        'ar' => 'Arabic',
        'an' => 'Aragonese',
        'hy' => 'Armenian',
        'as' => 'Assamese',
        'av' => 'Avaric',
        'ae' => 'Avestan',
        'ay' => 'Aymara',
        'az' => 'Azerbaijani',
        'bm' => 'Bambara',
        'ba' => 'Bashkir',
        'eu' => 'Basque',
        'be' => 'Belarusian',
        'bn' => 'Bengali',
        'bh' => 'Bihari languages',
        'bi' => 'Bislama',
        'bs' => 'Bosnian',
        'br' => 'Breton',
        'bg' => 'Bulgarian',
        'my' => 'Burmese',
        'ca' => 'Catalan, Valencian',
        'km' => 'Central Khmer',
        'ch' => 'Chamorro',
        'ce' => 'Chechen',
        'ny' => 'Chichewa, Chewa, Nyanja',
        'zh' => 'Chinese',
        'cu' => 'Church Slavonic, Old Bulgarian, Old Church Slavonic',
        'cv' => 'Chuvash',
        'kw' => 'Cornish',
        'co' => 'Corsican',
        'cr' => 'Cree',
        'hr' => 'Croatian',
        'cs' => 'Czech',
        'da' => 'Danish',
        'dv' => 'Divehi, Dhivehi, Maldivian',
        'nl' => 'Dutch, Flemish',
        'dz' => 'Dzongkha',
        'en' => 'English',
        'en-US' => 'English (USA)',
        'eo' => 'Esperanto',
        'et' => 'Estonian',
        'ee' => 'Ewe',
        'fo' => 'Faroese',
        'fj' => 'Fijian',
        'fi' => 'Finnish',
        'fr' => 'French',
        'ff' => 'Fulah',
        'gd' => 'Gaelic, Scottish Gaelic',
        'gl' => 'Galician',
        'lg' => 'Ganda',
        'ka' => 'Georgian',
        'de' => 'German',
        'de-DE' => 'German',
        'ki' => 'Gikuyu, Kikuyu',
        'el' => 'Greek (Modern)',
        'kl' => 'Greenlandic, Kalaallisut',
        'gn' => 'Guarani',
        'gu' => 'Gujarati',
        'ht' => 'Haitian, Haitian Creole',
        'ha' => 'Hausa',
        'he' => 'Hebrew',
        'hz' => 'Herero',
        'hi' => 'Hindi',
        'ho' => 'Hiri Motu',
        'hu' => 'Hungarian',
        'is' => 'Icelandic',
        'io' => 'Ido',
        'ig' => 'Igbo',
        'id' => 'Indonesian',
        'ia' => 'Interlingua (International Auxiliary Language Association)',
        'ie' => 'Interlingue',
        'iu' => 'Inuktitut',
        'ik' => 'Inupiaq',
        'ga' => 'Irish',
        'it' => 'Italian',
        'ja' => 'Japanese',
        'jv' => 'Javanese',
        'kn' => 'Kannada',
        'kr' => 'Kanuri',
        'ks' => 'Kashmiri',
        'kk' => 'Kazakh',
        'rw' => 'Kinyarwanda',
        'kv' => 'Komi',
        'kg' => 'Kongo',
        'ko' => 'Korean',
        'kj' => 'Kwanyama, Kuanyama',
        'ku' => 'Kurdish',
        'ky' => 'Kyrgyz',
        'lo' => 'Lao',
        'la' => 'Latin',
        'lv' => 'Latvian',
        'lb' => 'Letzeburgesch, Luxembourgish',
        'li' => 'Limburgish, Limburgan, Limburger',
        'ln' => 'Lingala',
        'lt' => 'Lithuanian',
        'lu' => 'Luba-Katanga',
        'mk' => 'Macedonian',
        'mg' => 'Malagasy',
        'ms' => 'Malay',
        'ml' => 'Malayalam',
        'mt' => 'Maltese',
        'gv' => 'Manx',
        'mi' => 'Maori',
        'mr' => 'Marathi',
        'mh' => 'Marshallese',
        'ro' => 'Moldovan, Moldavian, Romanian',
        'mn' => 'Mongolian',
        'na' => 'Nauru',
        'nv' => 'Navajo, Navaho',
        'nd' => 'Northern Ndebele',
        'ng' => 'Ndonga',
        'ne' => 'Nepali',
        'se' => 'Northern Sami',
        'no' => 'Norwegian',
        'nb' => 'Norwegian Bokmål',
        'nn' => 'Norwegian Nynorsk',
        'ii' => 'Nuosu, Sichuan Yi',
        'oc' => 'Occitan (post 1500)',
        'oj' => 'Ojibwa',
        'or' => 'Oriya',
        'om' => 'Oromo',
        'os' => 'Ossetian, Ossetic',
        'pi' => 'Pali',
        'pa' => 'Panjabi, Punjabi',
        'ps' => 'Pashto, Pushto',
        'fa' => 'Persian',
        'pl' => 'Polish',
        'pt' => 'Portuguese',
        'qu' => 'Quechua',
        'rm' => 'Romansh',
        'rn' => 'Rundi',
        'ru' => 'Russian',
        'sm' => 'Samoan',
        'sg' => 'Sango',
        'sa' => 'Sanskrit',
        'sc' => 'Sardinian',
        'sr' => 'Serbian',
        'sn' => 'Shona',
        'sd' => 'Sindhi',
        'si' => 'Sinhala, Sinhalese',
        'sk' => 'Slovak',
        'sl' => 'Slovenian',
        'so' => 'Somali',
        'st' => 'Sotho, Southern',
        'nr' => 'South Ndebele',
        'es' => 'Spanish',
        'su' => 'Sundanese',
        'sw' => 'Swahili',
        'ss' => 'Swati',
        'sv' => 'Swedish',
        'tl' => 'Tagalog',
        'ty' => 'Tahitian',
        'tg' => 'Tajik',
        'ta' => 'Tamil',
        'tt' => 'Tatar',
        'te' => 'Telugu',
        'th' => 'Thai',
        'bo' => 'Tibetan',
        'ti' => 'Tigrinya',
        'to' => 'Tonga (Tonga Islands)',
        'ts' => 'Tsonga',
        'tn' => 'Tswana',
        'tr' => 'Turkish',
        'tk' => 'Turkmen',
        'tw' => 'Twi',
        'ug' => 'Uighur, Uyghur',
        'uk' => 'Ukrainian',
        'ur' => 'Urdu',
        'uz' => 'Uzbek',
        've' => 'Venda',
        'vi' => 'Vietnamese',
        'vo' => 'Volap_k',
        'wa' => 'Walloon',
        'cy' => 'Welsh',
        'fy' => 'Western Frisian',
        'wo' => 'Wolof',
        'xh' => 'Xhosa',
        'yi' => 'Yiddish',
        'yo' => 'Yoruba',
        'za' => 'Zhuang, Chuang',
        'zu' => 'Zulu',
        'iw' => 'Hebrew',
        'pt-BR' => 'Portuguese (Brazil)',
        'pt-PT' => 'Portuguese (Portugal)',
        'zh-HK' => 'Chinese (HK)',
        'zh-CN' => 'Chinese (CN)',
        'zh-TW' => 'Chinese (Taiwan)',
        'fr-CA' => 'French (Canada)',
    ];

    if( isset( $codes[ $code ] ) )
        return $codes[ $code ];
    return $code;
}
?>