;(function(window, $) {
	'use strict';

    $.fn.selectRange = function(start, end) {
        if (end === undefined) {
            end = start;
        } 
        return this.each(function() {
            if ('selectionStart' in this) {
                this.selectionStart = start;
                this.selectionEnd = end;
            } else if (this.setSelectionRange) {
                this.setSelectionRange(start, end);
            } else if (this.createTextRange) {
                var range = this.createTextRange();
                range.collapse(true);
                range.moveEnd('character', end);
                range.moveStart('character', start);
                range.select();
            }
        });
    };

    $.fn.cypDialog = function( options ) {
        var settings = $.extend({
            title: 'Clever YouTube Plugin',
            autoOpen: false,
            closeText: '',
            dialogClass: 'cyp-dialog cyp-dialog-confirmation',
            modal: true,
            resizable: false,
            draggable: false,
            buttons: {
                'OK': function() {
                    $(this).dialog('close');
                }
            },
        }, options );
        
        return this.dialog(settings);
    };

})(window, jQuery);