;(function(window, $) {
	'use strict';
    
    $(document).ready(function() {
        applyNumbers();
        var dontClickAudio = window.cyp.audio.load('sounds/dont-click.mp3');
        $('.cyp-tabs').each(function () {
            var $this = $(this);
            var selected = $this.data('selected');
            new CBPFWTabs(this, { start: selected });
        });
        $('.cyp-tabs nav > ul > li').click(function (e) {
            var $this = $(this);

            if ($this.data('disabled')) {
                var $span = $this.find('a > span');

                if ($span.is(':visible')) {
                    $span.effect('shake', { times: 2, distance: 10 }, 500);
                } else {
                    $this.find('a')
                        .effect('shake', { times: 2, distance: 5 }, 500);
                }
                dontClickAudio.play();
            } else {
                CleverYouTubePluginHelper.pauseAll();
                CleverYouTubePluginHelper.checkResize();
                CleverYouTubePluginHelper.animatedButtons();
            }
        });
    });
    $(window).resize(function () {
        applyNumbers();
    });

    function applyNumbers() {
        var $collections = $('.cyp-tabs');
        $collections.removeClass('cyp-tabs-numbers');
        $collections.each(function () {
            var $this = $(this);
            var maxHeight = 0;
            
            $this.find('nav > ul > li').each(function () {
                var height = $(this).outerHeight();
                maxHeight = Math.max(height, maxHeight);
            });
            
            if (maxHeight > 160) {
                $this.addClass('cyp-tabs-numbers');
            }
        });
    }

})(window, jQuery);