<?php	

function cyp_is_amp() {
	return function_exists('is_amp_endpoint') && is_amp_endpoint();
}

function collapseBoxForUser($userId, $page, $boxId) {
	$userId = get_current_user_id();
    $optionName = "closedpostboxes_$page";
    $close = get_user_option($optionName, $userId);
    $closeIds = explode(',', $close);
    $closeIds[] = $boxId;
    $closeIds = array_unique($clodeIds); // remove duplicate Ids
    $close = implode(',', $closeIds);
    update_user_option($userId, $optionName, $close);
}

/* from https://surniaulula.com/2013/05/29/collapse-close-wordpress-metaboxes/ */
function collapse_metaboxes($page, $ids = array(), $force = false) {
    $user_id = get_current_user_id();
    $option_name = 'closedpostboxes_' . $page; // use the "pagehook" ID
    $option_arr = get_user_option( $option_name, $user_id ); // get the options for that page
 
    // create an empty array if get_user_option() had nothing to return
    if ( ! is_array( $option_arr ) ) {
		$option_arr = array();
	}
 
    // if we have nothing yet for this page, then set the defaults
    // or if we're forcing the metabox closed, then add the metabox ID to the array
    if ( empty( $option_arr ) || $force == true ) {
        foreach ( $ids as $id ) {
			$option_arr[] = $id;
		}
	}
 
    // we update the user options
    // note that we use array_unique() here to remove duplicate elements we may have
    // created when forcing metaboxes closed that are already closed
    update_user_option( $user_id, $option_name, array_unique( $option_arr ), true );
}
 
function cyp_get_max_styles() {

	return 31;

}
function get_page_options() {
	$options = array();
	$pages = get_pages($args); 
	$options[] = array(
		'value' => '',
		'name' => 'Select Page',
		'disabled' => false,
		'selected' => true);

	foreach ($pages as $page) {
		$options[] = array(
			'value' => intval($page->ID),
			'name' => $page->post_title,
			'disabled' => false,
			'selected' => false);
	}

	return $options;
}
function get_template_options() {
	$options = array();
	$templates = wp_get_theme()->get_page_templates();
	$options[] = array(
		'value' => '',
		'name' => 'Select Template',
		'disabled' => false,
		'selected' => true);

	foreach ($templates as $path => $title) {
		$options[] = array(
			'value' => $path,
			'name' => $title,
			'disabled' => false,
			'selected' => false);
	}

	return $options;
}
function cyp_get_style_options() {
	$options = array();
	$default_style_names = get_default_style_names();
	$tmpOptionsArrayGlobal = get_option('OptionsArrayGlobal');
	$max_styles = cyp_get_max_styles();
	$hasAdded = false;
	
	for ($i = 1; $i <= $max_styles; $i++) {
		$tmpStyleArray = get_option('OptionsArrayStyle' . $i);
		$name = (empty($tmpStyleArray['vidstylename']) ? $default_style_names[$i - 1] : $tmpStyleArray['vidstylename']);
		$option = array(
			'value' => $i,
			'name' => $i . ' – ' . $name,
			'disabled' => false,
			'selected' => false);
		
		if ($i == 1) {
			$option['selected'] = true;
		} else if ($i >= 3 && $tmpOptionsArrayGlobal['userOwnsIt'] != true) {
			$option['name'] = $i . ' Disabled in Trial Mode';
			$option['disabled'] = true;
		}
		$options[] = $option;
		$hasAdded = true;
	}
	
	if (!$hasAdded) {
		$options[] = array(
			'value' => 1,
			'name' => '1 My first video design',
			'disabled' => false,
			'selected' => true);
	}

	return $options;
}


function cyp_get_style_settings_names() {

	return array(

		'vidstylename',

		'vidstyledescription',

		'vidcolor',

		'vidresponsive',

		'vidwidth',

		'vidborder',

		'vidshowbutton',

		'vidbutton',

		'vidquality',

		'vidpicbefore',

		'vidpicafter',

		'vidshadow',

		'vidautoplay',

		'vidhtml',

		'vidshowhtml',

		'vidhtmlbefore',

		'vidannotations',

		'vidclosedcaptions',

		'vidrepeat',

		'vidanimated',

		'button_transparency',

		'vidsonar',

		'vidclosedcaptionslogo',
		
		'vidclosedcaptionslogotext',

		'description',

		'description_position',

		'description_transparency',

		'description_background',

		'description_color',

		'showdescription',

		'vidforcevolume',

	);

}



function cyp_get_input_name($setting, $styleNumber) {

	return 'input_' . $setting . '_s' . $styleNumber;

}



function get_video_settings() {

	return array(

		array(

			'value' => 'default',

			'label' => 'Auto'

		),

		array(

			'value' => '240p',

			'label' => '240p'

		),

		array(

			'value' => '360p',

			'label' => '360p'

		),

		array(

			'value' => '480p',

			'label' => '480p'

		),

		array(

			'value' => '720p',

			'label' => '720p'

		),

		array(

			'value' => '1080p',

			'label' => '1080p'

		),

	);

}



function get_default_style_names() {

	return array(

		'My first video design',

		'My second video design',

		'My third video design',

		'My fourth video design',

		'My fifth video design',

		'My sixth video design',

		'My seventh video design',

		'My eight video design',

		'My ninth video design',

		'My tenth video design',

		'My eleventh video design',

		'My twelfth video design',

		'My thirteenth video design',

		'My fourteenth video design',

		'My fifteenth video design',

		'My sixteenth video design',

		'My seventeenth video design',

		'My eighteenth video design',

		'My nineteenth video design',

		'My twentieth video design',

		'My twenty first video design',

		'My twenty second video design',

		'My twenty third video design',

		'My twenty fourth video design',

		'My twenty fifth video design',

		'My twenty sixth video design',

		'My twenty seventh video design',

		'My twenty eight video design',

		'My twenty ninth video design',

		'My thirtieth video design',

		'My thirty first video design',

		'My thirty second video design',

		'My thirty third video design',

		'My thirty fourth video design',

		'My thirty fifth video design',

		'My thirty sixth video design',

		'My thirty seventh video design',

		'My thirty eight video design',

		'My thirty ninth video design',

		'My fortieth video design',

	);

}



// http://mekshq.com/how-to-convert-hexadecimal-color-code-to-rgb-or-rgba-using-php/

function cyp_hex2rgba($color, $opacity = false) {

 	$default = 'rgb(0,0,0)';

 

	//Return default if no color provided

	if(empty($color)) {

        return $default;

	} 

 

	//Sanitize $color if "#" is provided 

	if ($color[0] == '#' ) {

		$color = substr( $color, 1 );

	}



	//Check if color has 6 or 3 characters and get values

	if (strlen($color) == 6) {

		$hex = array( $color[0] . $color[1], $color[2] . $color[3], $color[4] . $color[5] );

	} elseif ( strlen( $color ) == 3 ) {

		$hex = array( $color[0] . $color[0], $color[1] . $color[1], $color[2] . $color[2] );

	} else {

		return $default;

	}



	//Convert hexadec to rgb

	$rgb =  array_map('hexdec', $hex);



	//Check if opacity is set(rgba or rgb)

	if($opacity){

		if(abs($opacity) > 1) {

			$opacity = 1.0;

		}

		$output = 'rgba('.implode(",",$rgb).','.$opacity.')';

	} else {

		$output = 'rgb('.implode(",",$rgb).')';

	}



	//Return rgb(a) color string

	return $output;

}



function get_boolean($input)



{



	if (($input == "no")



		|| ($input == "off")



		|| ($input == "none")



		|| ($input == "default")



		|| ($input === false)



		|| empty($input)



		|| ($input == "0")
		

		|| ($input === "false"))



	{



		return( "false" );



	}



	return( "true" );



}







function get_boolean2($input)



{



	if (empty($input))



	{



		return("false");



	}







	return("true");



}







function get_boolean3( $input )



{



	if( $input == "1" )



	{



		return( true );



	}







	return( false );



}







function strbool($value)



{



    return $value ? 'true' : 'false';



}







function boolfromstr($value)



{



	if( $value == "true" || $value == "TRUE" )



	{



		return true;



	}







	return false;



}







function hms_to_int( $data )



{



	// check if in HH:MM:SS form



	if( strrpos( $data, ":" ) === FALSE )



	{



		return $data;



	}



	else 



	{



		$time = 0;







		$data = explode( ":", $data );



		$mut = 1;



		



		while( count( $data ) > 0 )



		{



			$time += $mut * intval( array_pop( $data ), 10 );



			$mut *= 60;



		}



		



		return $time;	



	}



}







function SSLsafeURL( $input )



{



	$isSSL = false;



	if( isset( $_SERVER["HTTPS"] ) )



	{



		if ( "on" == strtolower($_SERVER["HTTPS"]) )



			$isSSL = true;



		if ( "1" == $_SERVER["HTTPS"] )



			$isSSL = true;



	}



	elseif( isset( $_SERVER["SERVER_PORT"] ) && ( "443" == $_SERVER["SERVER_PORT"] ) )



	{



		$isSSL = true;



	}







	if( $isSSL )



	{



		return str_replace( "http://", "https://", $input );



	}







	return $input;



}







function addhoverpath($inpath) {







	// $filename will equal something like 'colorful_buttons-13.png'	



	$the_filename = basename($inpath);







	// now trim off the filename from the user's incoming filepath.



	$the_path = dirname($inpath);







	return $the_path . '/hover/' . $the_filename;







}











function ConvertYouTubeURLtoYouTubeID( $url ) {
	// Ways that a video URL might look:
	// URL			= http://www.youtube.com/watch?v=N2mNiu6yMdc
	// SHARECODE	= http://youtu.be/N2mNiu6yMdc
	// EMBEDDED		= http://www.youtube.com/embed/N2mNiu6yMdc
	// Sec URL			= https://www.youtube.com/watch?v=N2mNiu6yMdc
	// Sec SHARECODE	= https://youtu.be/N2mNiu6yMdc
	// Sec EMBEDDED		= https://www.youtube.com/embed/N2mNiu6yMdc	
	// Match string of length 11 after v=

	if( strpos( $url, 'v=' ) !== false ) {
		return substr( $url, ( strpos( $url, "v=" ) + 2 ), 11 );
	}

	if( strpos( $url, 'http://youtu.be/' ) !== false ) {
		return substr( $url, ( strpos( $url, "be/" ) + 3 ), 11 );
	}

	if( strpos( $url, 'http://www.youtube.com/embed/' ) !== false ) {
		return substr( $url, ( strpos( $url, "ed/" ) + 3 ), 11 );
	}

	if( strpos( $url, 'https://youtu.be/' ) !== false ) {
		return substr( $url, ( strpos( $url, "be/" ) + 3 ), 11 );
	}

	if( strpos( $url, 'https://www.youtube.com/embed/' ) !== false ) {
		return substr( $url, ( strpos( $url, "ed/" ) + 3 ), 11 );
	}	

	// if its just an 11 digit number just assume the user entered the video ID itself.
	if( strlen( $url ) == 11 ) {
		return $url;
	}

	return null; 
}









function getYouTubeHeight($inWidth) {



		



	$tmp = ($inWidth * 360) / 640;



	$tmp = round($tmp);



	return $tmp + 0;







}







function get_the_play_button_width($inWidth) {







	$tmp = ($inWidth * 86) / 640;



	



	// add a few pixels



	$tmp = $tmp + 12;







	// add a ceiling and floor



	if ($tmp > 86) {$tmp = 86;}



	if ($tmp < 50) {$tmp = 50;}



	



	return $tmp;







}







function get_the_play_button_height($inHeight) {







	$tmp = ($inHeight * 60) / 360;



	



	// add a few pixels



	$tmp = $tmp + 12;







	// add a ceiling and floor



	if ($tmp > 60) {$tmp = 60;}



	if ($tmp < 45) {$tmp = 45;}



	



	return $tmp;







}







function printImageSelectButtonsAndEditBox( $inIder ) {

?>

    <table id="table_specifier_<?php echo $inIder; ?>" border="0" cellpadding="0" cellspacing="0">

      <tr>

        <td width="65" height="45" align="center">

        	<img height="31" width="55"

			src="<?php echo plugins_url('/images/the-settings-page/select-icon.png', __FILE__); ?>"

			id="img_preview_<?php echo $inIder; ?>"

			class="img_CYP_library_preview cyp_open_library_<?php echo $inIder; ?>"

			onerror="this.src='<?php echo plugins_url('/images/the-settings-page/select-icon.png', __FILE__); ?>';" style="display: block; margin-right: 7px;">

		</td>

        <td>&nbsp;&nbsp;&nbsp;</td> 

        <td width="1" align="center">

			<img src="<?php echo plugins_url('/images/icons/icon-library-spinner.gif', __FILE__); ?>" class="hide">

			<img

				id="img_launchlibrary_<?php echo $inIder; ?>"

				class="cyp_open_library_<?php echo $inIder; ?>"

				style="margin-right: 11px; cursor: pointer;"

				title="Show Clever YouTube Plugin Library"

				src="<?php echo plugins_url('/images/icons/icon-library.png', __FILE__); ?>">

		</td>

        <td width="22" align="center">

			<a id="a_upload_the_<?php echo $inIder; ?>" onclick="javascript:TheClickedGalleryNum='<?php echo $inIder; ?>';" style="cursor: pointer;">

				<img style="margin-right: 11px;"

				title="Launch the WordPress Media Browser to upload an image (or select an existing one)."

				src="<?php echo plugins_url('/images/icons/button-media.png', __FILE__); ?>">

			</a>

		</td>

        <td width="100%">

            <table width="100%" border="0" cellpadding="0" cellspacing="0" style="border: 1px solid #DFDFDF; border-collapse: collapse;">

              <tr>

                <td width="100%">

					    <input

						class="unstyled cyp-clearable"

						id="input_GUI_<?php echo $inIder; ?>"

						name="input_GUI_<?php echo $inIder; ?>"

						style="display: table-cell; width: 98%; border: 0px; font-size: 8pt; font-family: 'Courier New'; color: #060;"

						type="text" placeholder="http://" spellcheck="false" autocomplete="off" value="" /></td>

              </tr>

            </table>

        </td>

      </tr>

    </table>

	<script>

	// ========================================== 

	// Code to call the WordPress Media Uploader

	// ==========================================

	var TheClickedGalleryNum = 0;



	jQuery(document).ready(function($) {
		
		$('#a_upload_the_<?php echo $inIder; ?>').click(function(e) {

			e.preventDefault();

			var media = wp.media({ 

				title: 'Upload image or mp4 video',

				multiple: false

			}).open()

			.on('select', function(e){

				var uploaded = media.state().get('selection').first();

				var url = uploaded.toJSON().url;
				
				$('#input_GUI_<?php echo $inIder; ?>').val(url).blur();

			});



			return false;

		});

		$('.cyp_open_library_<?php echo $inIder; ?>').click(function() {

			var $this = $(this);

			var destination;

			

			if (!$this.is('.img_CYP_library_preview')) {

				$this.attr('src', '<?php echo plugins_url('/images/icons/icon-library-spinner.gif', __FILE__); ?>');

			}

			

			if (typeof frmCYT !== 'undefined') {

				destination = document.getElementsByName('input_<?php echo $inIder; ?>_s' + frmCYT.input_curtab.value)[0];

			} else {

				destination = document.getElementById('input_GUI_<?php echo $inIder; ?>');

			}

			ShowCYPLibrary(0, findPosY(this), destination);

			show_lib_tab('<?php echo $inIder; ?>');

			

			if (!$this.is('.img_CYP_library_preview')) {

				$this.attr('src', '<?php echo plugins_url('/images/icons/icon-library.png', __FILE__); ?>');

			}

		});

		$('#input_GUI_<?php echo $inIder; ?>').blur(function() {

			if (typeof frmCYT !== 'undefined') {
				
				document.getElementsByName('input_<?php echo $inIder; ?>_s' + frmCYT.input_curtab.value)[0].value = this.value;

			}

			

			if (typeof prepare_the_cyp_interface !== 'undefined' && $.isFunction(prepare_the_cyp_interface)) {

				prepare_the_cyp_interface();

			}

		}).keyup(function() {

			if (typeof frmCYT !== 'undefined') {

				document.getElementsByName('input_<?php echo $inIder; ?>_s' + frmCYT.input_curtab.value)[0].value = this.value;

			}

		});

	});

	</script> 

<?php	



}	



	



function printGalleryPicker( $caller=null ) {

	$dirs = array( "vidbutton", "vidborder", "vidpicbefore", "vidpicafter" );

?>

	<script>

		function clickingiframeselection( inObj ) {

			// When the user hovers his mouse over the play button, the image src changes. So, we need to extract the word "/hover/"

			inObj.src = inObj.src.replace('/hover/', '/');



			// do stuff for the metabox

			if( inObj.src.indexOf( "administrative-defaults-use-button-from-styles-settings" ) > -1 ) {

				globalDestinationObject.value = "";

			} else {

				// Send the object.src to the global object (which is an edit box on the Clever YouTube Plugin Settings Page) (e.g. the parent page.)

				globalDestinationObject.value = inObj.src;

			}

			jQuery(globalDestinationObject).change();



			// Remember, the post editor doesn't have this function prepare_the_cyp_interface(). So test if it exists first.

			if ( typeof prepare_the_cyp_interface === "function" ) {

				prepare_the_cyp_interface(1);

			}



			// NOTE: Hmm.... I commented out the below because the prepare_the_cyp_interface() function closes the iframe picker...

			// document.getElementById('iframe_picker').src = '';

			// Finally, hide the iframe

			hideGallery();

		} // END function

		function clickingiframeselection_flash(src) {

			// Send the src to the global object (which is an edit box on the Clever YouTube Plugin Settings Page) (e.g. the parent page.)

			globalDestinationObject.value = src;



			// Remember, the post editor doesn't have this function prepare_the_cyp_interface(). So test if it exists first.

			if ( typeof prepare_the_cyp_interface === "function" ) {

				prepare_the_cyp_interface(1);

			}



			// NOTE: Hmm.... I commented out the below because the prepare_the_cyp_interface() function closes the iframe picker...

			// document.getElementById('iframe_picker').src = '';



			// Finally, hide the iframe

			hideGallery();

		} // END function   

		function hideGallery() {

			var $gallery = jQuery('#div_GalleryPicker');

			

			if ($gallery.dialog('instance')) {

				$gallery.dialog('close');

			}

		}

	</script>

    <div id="div_GalleryPicker" class="div_gallery_picker">          	

        <div class="container" style="clear: both;">

			<div id="gallery-picker-section-loading">

				<img src="<?php echo( plugins_url('/images/spinner.gif', __FILE__) ); ?>">

			</div>

			<?php

			for ($i=0; $i < count($dirs); $i++) { 

				$subfolder = $dirs[$i];

			?>

			<div class="picker" id="<?php echo("section-".$subfolder); ?>" style="width: inherit; height: inherit;" >

				<?php

					$icon_image_list = scandir(dirname( dirname(__FILE__) ) . "/clever-youtube-plugin/library/" . $subfolder);

			        $counter = 1;

			        $imgCategoryOld = null;

			        $the_hover_path = plugins_url('/library/', __FILE__) . $subfolder . '/hover/';



			        foreach($icon_image_list as $curimg) {

			            $curimg = strtolower($curimg);

						

						// skip gif animated buttons

	                	if (strpos( $curimg, "gif_animated_buttons" ) !== FALSE) {

	                		continue;

	                	}



			            // if not from metabox, then skip "use default"

	                	if( strpos( $curimg, "administrative_defaults-use-button-from-styles-settings.png" ) !== FALSE && $caller != "metabox" ) {

	                		continue;

	                	}

						

						// skip default button

						if (strpos( $curimg, "administrative_defaults-default.png" ) !== FALSE) {

							continue;

						}



			            if ( (strpos($curimg,'.jpg') !== false) or (strpos($curimg,'.png') !== false) or (strpos($curimg,'.gif') !== false) or (strpos($curimg,'.jpeg') !== false)) {

			                $theImage = plugins_url('/library/', __FILE__) . $subfolder . '/' . $curimg; 

			                $imgCategoryNew = substr($curimg,0,strpos($curimg,'-'));



			                if ($imgCategoryNew != $imgCategoryOld) {

			                    echo "<h4 style='font-size: 11pt; font-weight: bold; color: #817058; font-family: Arial; margin-bottom: 8px; clear: both;'>" . ucwords(str_replace("_", " ", $imgCategoryNew)) . "</h4>";

			                    $imgCategoryOld = $imgCategoryNew;

			                }



			                if ($subfolder == 'vidbutton') {

								// Animated buttons

								if (substr($curimg, 0, 16) === 'animated_buttons') {

									$counter++;

									$imgId = "img_vidface_" . $counter;

			                	?>

									<div class="cyp-settings-play-button">

										<span class="cyp-animated-play-button-helper"></span>

										<img id="<?php echo $imgId; ?>"

											onclick="clickingiframeselection(this);"

											src="<?php echo $theImage ?>"

											ondragstart="return false;">

									</div>

			                        <!-- preload -->

			                        <img src="<?php echo $the_hover_path . $curimg; ?>" style="display: none; height: 0px; width: 0px;" />

									<script>animateButton("#<?php echo $imgId; ?>", "<?php echo $theImage; ?>", "<?php echo $the_hover_path . $curimg; ?>");</script>

								<?php

			                    // Button is an image

			                	} else {

			                	?>                                           

			                        <img onmouseover="this.src='<?php echo $the_hover_path . $curimg; ?>';" onmouseout="this.src='<?php echo $theImage; ?>';" style="cursor: pointer;" id="img_vidface_<?php echo $counter++; ?>" onclick="clickingiframeselection(this);" src="<?php echo $theImage ?>" ondragstart="return false;">

			                        <!-- preload -->

			                        <img src="<?php echo $the_hover_path . $curimg; ?>" style="height: 0px; width: 0px;" />

			                    <?php

				                }

				                ?>

			                <?php } else { ?>

			                    <img height="70" id="img_vidface_<?php echo $counter++; ?>" onclick="clickingiframeselection(this);" class="img_picker_buttons" src="<?php echo $theImage ?>" style="cursor: pointer;" ondragstart="return false;">

			                <?php } ?>

			                <?php

			            } // END if 

			        } // END foreach 

			    ?>

			</div>

			<?php

			} // end for loop

			?>

		</div>

    </div>

	<script>

		jQuery(document).ready(function ($) {

			$('.cyp-clearable').on('input', function() {

				if (this.value) {

					$(this).addClass('cyp-clear-input');

				} else {

					$(this).removeClass('cyp-clear-input');

				}

			});

			$(document).on('mousemove', '.cyp-clear-input', function(e) {

				var value = this.offsetWidth-15 < e.clientX - this.getBoundingClientRect().left;

				

				if (value) {

					$(this).addClass('cyp-clear-input-onX');

				} else {

					$(this).removeClass('cyp-clear-input-onX');

				}

			}).on('touchstart click', '.cyp-clear-input-onX', function( ev ){

				ev.preventDefault();

				$(this).removeClass('cyp-clear-input cyp-clear-input-onX').val('').change().blur();

			});

			$('.cyp-clearable').trigger('input');

			

			jQuery(window).resize(function() {

				var $gallery = jQuery('#div_GalleryPicker');

				

				if ($gallery.dialog('instance')) {

					$gallery.dialog("option", "width", 0.7 * jQuery(window).width());

					$gallery.dialog("option", "height", 0.7 * jQuery(window).height());

				}

			});

		});

	</script>

<?php	

}	



?>