<?php

/*

Plugin Name: Clever YouTube Plugin 4.241

Version: 4.241

Plugin URI: http://CleverGizmos.com

Description: Control the way YouTube videos are displayed on your website.

Author: CleverGizmos.com

Author URI: http://CleverGizmos.com/

*/



require_once( "global.php" );

require_once( "the_settings_page.php" );

require_once( "the_rendering.php" );

require_once( "the_meta_box.php" );

require_once( "the_help_text.php" );



function cyp_version() {

	if (!function_exists('get_plugin_data')) {

        require_once(ABSPATH . 'wp-admin/includes/plugin.php');

	}

    $plugin_data = get_plugin_data(__FILE__, false, false);

    $plugin_version = $plugin_data['Version'];

	

    return $plugin_version;

}



function func_load_stuff_in_the_admin_screen_head_tag() {

?>

	<script src="<?php echo( plugin_dir_url(__FILE__) . 'global.js'); ?>?v=<?php echo cyp_version(); ?>"></script>

	<script src="<?php echo( plugin_dir_url(__FILE__) . 'cookies.js'); ?>?v=<?php echo cyp_version(); ?>"></script>

	<script language="javascript">

	

		function SaveYourWork() {



			// The media uploader calls this so we gotta check if the variable exists

			if (typeof the_user_has_unsaved_work != "undefined")

			{

		

				if ( the_user_has_unsaved_work )

				{ 

					return('You didn\'t save your Clever YouTube Plugin settings yet. Your changes will be lost if you leave this page.');

				} 

			}

			

		}

			

		window.onbeforeunload=SaveYourWork;

		

	</script>

    

<?php

}



add_action( 'admin_head', 'func_load_stuff_in_the_admin_screen_head_tag' );



function func_load_CYT_resources() {
	wp_enqueue_script('jquery');

	// my javascript and css
	wp_enqueue_style('cyp-style', plugins_url( 'cyp-styles.css', __FILE__ ), false, cyp_version(), 'all' );

	if( is_admin() ) {
		wp_enqueue_style('cyp-style-global', plugins_url( 'global.css', __FILE__ ), false, cyp_version(), 'all' );
		wp_enqueue_media();

		// http://www.webmaster-source.com/2010/01/08/using-the-wordpress-uploader-in-your-plugin-or-theme/
		wp_enqueue_style('thickbox');
		wp_enqueue_script('media-upload');
		wp_enqueue_script('thickbox');
		wp_enqueue_script('my-upload');

		// jQuery UI
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-sortable');
		wp_enqueue_script('jquery-ui');
		wp_enqueue_script('jquery-ui-dialog');
		wp_enqueue_script('jquery-ui-slider');
		wp_enqueue_script('jquery-ui-spinner');
		wp_enqueue_style('jQuery-UI-Style', "//code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css" , false, '1.10.3', 'all' );
		wp_enqueue_script('bgrins-spectrum-script', plugin_dir_url(__FILE__). 'vendor/bgrins-spectrum-1.8.0/spectrum.js', array(), '1.8.0');
		wp_enqueue_style('bgrins-spectrum-style', plugin_dir_url(__FILE__). 'vendor/bgrins-spectrum-1.8.0/spectrum.css', false, '1.8.0', 'all' );
		wp_enqueue_script('postbox');
	}
	wp_enqueue_script('jquery-effects-core');
	wp_enqueue_script('jquery-effects-shake');

	wp_enqueue_script('cyp-script', plugin_dir_url(__FILE__). 'cyp.js', array(), cyp_version());
	wp_localize_script('cyp-script', 'WPURLS', array( 'cypurl' => plugin_dir_url(__FILE__)));	
	wp_enqueue_script('client-script', plugin_dir_url(__FILE__). 'cyp-client.js', array(), cyp_version());
	wp_enqueue_script('cbpFWTabs', plugin_dir_url(__FILE__). 'cbpFWTabs.js', array(), cyp_version());
	wp_enqueue_script('cyp-tabs', plugin_dir_url(__FILE__). 'cyp-tabs.js', array(), cyp_version());
}



add_action('admin_print_scripts', 'func_load_CYT_resources');

add_action('admin_print_styles', 'func_load_CYT_resources');

add_action('wp_enqueue_scripts','func_load_CYT_resources'); 

add_action('wp_enqueue_styles','func_load_CYT_resources'); 

add_action('admin_head','func_load_CYT_resources'); 



function func_to_print_the_plugin_settings_link($links) { 

	$settings_link = admin_url() . 'admin.php?page=' . plugin_basename(__FILE__); 

	$settings_link = '<a href="' . $settings_link . '" title="Click here to set your video properties.">Settings</a>'; 

	array_unshift($links, $settings_link); 

	return $links; 

}

add_filter("plugin_action_links_" . plugin_basename(__FILE__), 'func_to_print_the_plugin_settings_link' );



function func_to_add_CYT_meta_box() {

	// Add a metabox to posts and pages.

	add_meta_box( 'my-meta-box-id', 'Clever YouTube Plugin (Shortcode Generator)', 'func_to_draw_the_CYT_metabox', 'post', 'normal', 'high' );

	add_meta_box( 'my-meta-box-id', 'Clever YouTube Plugin (Shortcode Generator)', 'func_to_draw_the_CYT_metabox', 'page', 'normal', 'high' );	

}

add_action('add_meta_boxes', 'func_to_add_CYT_meta_box');



function func_to_setup_CYT_settings_page() {

	// Add the plugin to the left WordPress menu.

	add_menu_page('Clever YouTube Plugin Settings', 'Clever YouTube', 'administrator', __FILE__, 'draw_my_yt_settings_page', plugins_url('/images/icons/main-star.png', __FILE__));

	// add_menu_page('Clever YouTube Plugin Settings', 'Clever YouTube', 'administrator', __FILE__, 'print_settings_page', plugins_url('/images/icons/main-star.png', __FILE__));

}

add_action('admin_menu', 'func_to_setup_CYT_settings_page');



function the_plugin_version() {

	// This function must be run from THIS page!

	$plugin_data = get_plugin_data( __FILE__ );

	echo $plugin_data['Version'];	

}



// ================================================================

// Shortcode Stuff

// http://codex.wordpress.org/Function_Reference/do_shortcode

// ================================================================

add_shortcode('cleveryoutube', 'func_to_draw_the_videos');

add_shortcode('cleveryoutubepopup', 'render_cyp_popup');

add_shortcode('cleveryoutubetimelink', 'render_cyp_timelink');

add_shortcode('cleveryoutubetabs', 'render_cyp_tabs');



// Use shortcodes in text widgets.

add_filter('widget_text', 'do_shortcode');



?>