<?php

function cyp_dom_tab_id($collectionId, $tabId) {
	return $collectionId . '-tab' . ($tabId + 1);
}
function cyp_render_tab_video($tab, $autoplay, $i, $tabstyle) {
	if (!empty($tab['url'])) {
		$youtubeId = ConvertYouTubeURLtoYouTubeID($tab['url']);
		$style = $tab['style'];
		$shortcode = '[cleveryoutube ' .
			'video="' . $youtubeId . '" ' .
			'style="' . $style . '" ' .
			'forceresponsive="1" ' .
			'autoplay="' . $autoplay . '" ' .
			'jsfunction="cyp_tab_play_button_click(' . $tabstyle . ', ' . ($i + 1) . ')' . '"' .
			']';
		echo do_shortcode($shortcode);
	}
}
function cyp_render_tab_content($tab) {
	if (!empty($tab['content'])) {
		$page = get_post($tab['content']);

		if (!has_shortcode($page->post_content, 'cleveryoutubetabs')) {
			$content = apply_filters('the_content', $page->post_content); 

			if (!empty($content)) {
				echo '<div class="cyp-tab-page-content">' . $content . '</div>';
			}
		}
	}
}
function cyp_render_template($template) {
	if (!empty($template)) {
		$overridden_template = locate_template($template);

		 if ($overridden_template) {
			load_template($overridden_template, false);
		}
	}
}
function cyp_render_tab_template($tab) {
	cyp_render_template($tab['template']);
}
function cyp_get_tab_title($tab, $i, $enabled) {
	if ($enabled) {
		if (empty($tab['title'])) {
			return 'Tab ' . ($i + 1);
		} else {
			return nl2br($tab['title']);
		}
	} else {
		return 'Coming<br>Soon...';
	}
}
function cyp_render_tabcollection($collection, $config) {
	global $tab_images_are_cached;

	$id = 'cyp-tabs' . $collection['id'];
	$selectedId = ($config['selected_tab'] ? $config['selected_tab'] : intval($collection['widget']['selected_tab']));
	$count = count($collection['tabs']);
	$max = $config['num_of_enabled_tabs'] ? $config['num_of_enabled_tabs'] : $count;

	if ($selectedId <= 0 || $selectedId > $max) {
		$selectedId = 1;
	}
	$selected = $selectedId - 1;
	ob_start();
	$cache = array();

	if (!$tab_images_are_cached) {
		for ($i = 1; $i <= 5; $i++) {
			$cache[] = $i . '.png';
			$cache[] = $i . '-selected.png';
			$cache[] = $i . '-disabled.png';
		}
		$tab_images_are_cached = true;
	}
	?>
<?php foreach ($cache as $path) : ?>
	<?php $url = plugins_url('/images/the-rendering/' . $path, __FILE__); ?>
	<img src="<?php echo $url; ?>" style="display: none;" />
<?php endforeach; ?>
<div class="cyp-tabs cyp-tabs-n-<?php echo $count; ?> <?php echo $id; ?>" data-selected="<?php echo $selected; ?>">
	<nav>
		<ul>
		<?php foreach ($collection['tabs'] as $i => $tab) :?>
		<?php $enabled = (!$config['num_of_enabled_tabs'] || $i < $config['num_of_enabled_tabs']); ?>
			<li<?php echo ($enabled ? '' : ' data-disabled="true"'); ?>>
				<a href="#<?php echo cyp_dom_tab_id($id, $i); ?>">
					<span><?php echo cyp_get_tab_title($tab, $i, $enabled); ?></span>
				</a>
			</li>
		<?php endforeach; ?>
		</ul>
	</nav>
	<div class="cyp-tabs-content">
		<?php foreach ($collection['tabs'] as $i => $tab) :?>
		<section id="<?php echo cyp_dom_tab_id($id, $i); ?>">
		<?php if (!$config['num_of_enabled_tabs'] || $i < $config['num_of_enabled_tabs']) : ?>
			<?php
			$autoplay = ($collection['widget']['autoplay'] && $selected === $i ? 'true' : 'false');

			if ($autoplay && isset($collection['widget']['autoplay_ignore']) && $collection['widget']['autoplay_ignore'] && is_user_logged_in()) {
				$autoplay = 'false';
			}
			cyp_render_tab_video($tab, $autoplay, $i, $config['tabstyle']);

			if (!empty($collection['template_below'])): ?>
			<div class="cyp-tabs-below">
				<?php cyp_render_template($collection['template_below']); ?>
			</div>
			<?php endif;
			cyp_render_tab_content($tab);
			cyp_render_tab_template($tab);
			?>
		<?php endif; ?>
		</section>
		<?php endforeach; ?>
	</div>
</div>
	<?php
	$content = ob_get_contents();
	ob_end_clean();

	return $content;
}

?>