<?php

function get_max_tab_collections() {
	return 10;
}
function get_max_tabs_per_collection() {
	return 6;
}
function get_tabs_default_settings() {
	$titles = array(
		'My first tab design',
		'My second tab design',
		'My third tab design',
		'My fourth tab design',
		'My fifth tab design',
		'My sixth tab design',
		'My seventh tab design',
		'My eight tab design',
		'My ninth tab design',
		'My tenth tab design',
	);
	$defaults = array(
		'tab_collections' => array(),
		'current' => 1);

	foreach ($titles as $i => $title) {
		$defaults['tab_collections'][$i] = array(
			'id' => ($i + 1),
			'title' => $title,
			'description' => '',
			'tabs' => array(
				array(
					'title' => '',
					'url' => '',
					'style' => 1,
					'content' => '',
					'template' => ''
				)
			),
			'template_below' => '',
			'widget' => array(
				'selected_tab' => 1,
				'autoplay' => false,
				'autoplay_ignore' => false
			)
		);
	}

	return $defaults;
}
function cyp_tab_title_max_length() {
	return 45;
}
function cyp_tabs_handle_post() {
	if (isset($_POST['cyp_input_update_tabs'])) {
		if (isset($_POST['cyp_tabs_settings'])) {
			$settings = $_POST['cyp_tabs_settings'];
			$settings = json_decode(stripslashes($settings), true);
			$cleanTabCollections = array();

			for ($i = 0; $i < get_max_tab_collections(); $i++) {
				$postCollection = $settings['tab_collections'][$i];

				if (isset($postCollection)) {
					$collection = array(
						'id' => ($i + 1),
						'title' => $postCollection['title'],
						'description' => $postCollection['description'],
						'tabs' => array(),
						'template_below' => $postCollection['template_below'],
						'widget' => array(
							'selected_tab' => $postCollection['widget']['selected_tab'],
							'autoplay' => $postCollection['widget']['autoplay'] ? true : false,
							'autoplay_ignore' => isset($postCollection['widget']['autoplay_ignore']) && $postCollection['widget']['autoplay_ignore'] ? true : false
						)
					);

					for ($j = 0; $j < get_max_tabs_per_collection(); $j++) {
						$postTab = $postCollection['tabs'][$j];

						if (isset($postTab)) {
							$title = strip_tags($postTab['title']);
							$title = preg_replace('/[\r\n]+/', PHP_EOL, $title);
							$title = preg_replace('/ +/', ' ', $title);
							$title = trim($title);

							if (!empty($title)) {
								$title = substr($title, 0, cyp_tab_title_max_length());
							}
							$collection['tabs'][] = array(
								'title' => $title,
								'url' => $postTab['url'],
								'style' => intval($postTab['style']),
								'content' => intval($postTab['content']),
								'template' => $postTab['template'],
							);
						}
					}
					$cleanTabCollections[] = $collection;
				}
			}
			$cleanSettings = array(
				'tab_collections' => $cleanTabCollections,
				'current' => $settings['current']
			);
			update_option('cyp_tab_settings', $cleanSettings);
		}
	}
}
function cyp_get_tab_settings($tabs_defaults) {
	$tabs_settings = get_option('cyp_tab_settings');

	if (empty($tabs_settings)) {
		$tabs_settings = $tabs_defaults;
	}

	for ($i = count($tabs_settings['tab_collections']); $i < count($tabs_defaults['tab_collections']); $i++) {
		$tabs_settings['tab_collections'][$i] = $tabs_defaults['tab_collections'][$i];
	}

	foreach ($tabs_settings['tab_collections'] as &$collection) {
		if (empty($collection['tabs'])) {
			$collection['tabs'][] = 
				array(
					'title' => '',
					'url' => '',
					'style' => '',
					'content' => '',
				);
		}
	}

	return $tabs_settings;

}
function render_settings_page_tabs() {
	cyp_tabs_handle_post();

	global $tabs_settings;
	global $tmpOptionsArrayGlobal;
	global $template_options;
	$tabs_defaults = get_tabs_default_settings();
	$tabs_settings = cyp_get_tab_settings($tabs_defaults);
	$style_options = cyp_get_style_options();
	$content_options = get_page_options();
	$template_options = get_template_options();
	$tmpOptionsArrayGlobal = get_option('OptionsArrayGlobal');
	?>

	<?php
	function cyp_meta_box_step_tabs() {
		?>
		<div class="cyp-settings-tabs-wrap">
			<div class="cyp-settings-tabs-container"></div>
			<div class="cyp-settings-tabs-footer">
				<a href class="cyp-add-tab">Add New Tab</a>
			</div>
		</div>
		<?php
	}
	function cyp_meta_box_step_widget() {
		?>
		<div class="cyp-settings-tabscollection-metabox-content">
			<!-- Currently Selected Tab -->
			<div class="cyp-setting-header">
				<div class="cyp-setting-toggle">
					<input class="cyp-tabcollection-widget-selected" />
				</div>
				<div class="cyp-setting-title">
					<span class="cyp-help-icon cyp-help-widget-selected"></span>
					Show this Tab when the Web Page loads:
				</div>
				<div id="help_tabcollection_widget_selected" class="div_helpboxCYP" style="display: none;"><?php the_cyp_help_info('help_tabcollection_widget_selected'); ?></div>
			</div>
			<!-- Auto-Play -->
			<div class="cyp-setting-header">
				<div class="cyp-setting-toggle">
					<span class="cyp-switch cyp-widget-autoplay"></span>
				</div>
				<div class="cyp-setting-title">
					<span class="cyp-help-icon cyp-help-widget-autoplay"></span>
					Auto-Play the YouTube video in <span class="cyp-tabcollection-widget-selected-value">Tab 0</span> when the Web Page Loads?
				</div>
				<div id="help_tabcollection_widget_autoplay" class="div_helpboxCYP" style="display: none;"><?php the_cyp_help_info('help_tabcollection_widget_autoplay'); ?></div>
				<div class="cyp-setting-content" id="cyp-widget-autoplay-child">
					<div class="cyp-setting-content-level2">
						<span class="cyp-help-icon cyp-help-widget-autoplay-ignore"></span>
						But if the user is logged into WordPress then don't Auto-Play.
						<span class="cyp-switch cyp-widget-autoplay-ignore"></span>
						<div id="help_tabcollection_widget_autoplay_ignore" class="div_helpboxCYP" style="display: none;"><?php the_cyp_help_info('help_tabcollection_widget_autoplay_ignore'); ?></div>
					</div>

				</div>
			</div>
		</div>
		<?php
	}
	function cyp_meta_box_step_shortcode() {
		?>
		<div class="cyp-settings-tabscollection-metabox-content">
			<div class="cyp-setting-header">
				<div class="cyp-setting-title">
					<span class="cyp-help-icon cyp-help-shortcode"></span>
					Copy the Shortcode here. (<a href class="cyp-tabcollection-shortcode-select">Select all</a>)
				</div>
				<div id="help_tabcollection_shortcode" class="div_helpboxCYP" style="display: none;"><?php the_cyp_help_info('help_tabcollection_shortcode'); ?></div>
				<div class="cyp-setting-content">
					<textarea onclick="this.select();" readonly rows="1" class="widefat cyp-tabcollection-shortcode" spellcheck="false"></textarea>
				</div>
			</div>
		</div>
		<?php
	}
	function cyp_meta_box_side_tabcollections() {
		global $tabs_settings;
		global $tmpOptionsArrayGlobal;
		?>
		<div class="div_CYP_right_nav_bar">
			<h3 style="font-size: 14px;">My Video Tabs</h3>
			<ol>
				<?php foreach ($tabs_settings['tab_collections'] as $i => $collection): ?>
				<li class="li_right_nav_settings_page" data-id="<?php echo $collection['id']; ?>">
				<?php if ($tmpOptionsArrayGlobal['userOwnsIt'] == true || $i === 0) : ?>
					<a class="edit-icon" alt="Edit Video Tab Widget name"></a>
					<a class="a_right_nav_settings_page"><?php echo $collection['title']; ?></a>
				<?php else : ?>
					<span class="a_right_nav_settings_page_disabled" onClick="javascript:alert('This Video Style is disabled because you are in Trial Mode. Purchase the Clever YouTube Plugin to enable this Style.');">Disabled in Trial Mode</span>
				<?php endif; ?>
				</li>
				<?php endforeach; ?>
			</ol>
		</div>
		<?php
	}
	function cyp_meta_box_step_template() {
		global $template_options;
		?>
		<div class="cyp-settings-tabscollection-metabox-content">
			<!-- Template below video player -->
			<div class="cyp-setting-header">
				<div class="cyp-setting-toggle cyp-setting-toggle-wide">
					<select class="cyp-select cyp-select-template-below">
					<?php foreach ($template_options as $i => $option) : ?>
						<option
							value="<?php echo $option['value']; ?>"
							<?php echo $option['disabled'] ? 'disabled' : ''; ?>
							<?php echo $i === 0 ? 'selected' : ''; ?>
							<?php echo $i === 0 && !$option['value'] ? 'class="cyp-select-value-none"' : ''; ?>
							>
							<?php echo $option['name']; ?>
						</option>
					<?php endforeach; ?>
					</select>
				</div>
				<div class="cyp-setting-title">
					<span class="cyp-help-icon cyp-help-template-below"></span>
					Show this Template below Video Player:
				</div>
				<div id="help_tabcollection_template_below" class="div_helpboxCYP" style="display: none;"><?php the_cyp_help_info('help_tabcollection_template_below'); ?></div>
			</div>
		</div>
		<?php
	}
	add_meta_box(
		'cyp_step_tabs',
		__( 'Step A: Tab Settings', 'cyp' ),
		'cyp_meta_box_step_tabs',
		'settings_page_cyp_tabs',
		'normal'
	);
	add_meta_box(
		'cyp_step_template',
		__( 'Step B: Template Below Video Player', 'cyp' ),
		'cyp_meta_box_step_template',
		'settings_page_cyp_tabs',
		'normal'
	);
	add_meta_box(
		'cyp_step_widget',
		__( 'Step C: Widget Defaults', 'cyp' ),
		'cyp_meta_box_step_widget',
		'settings_page_cyp_tabs',
		'normal'
	);
	add_meta_box(
		'cyp_step_shortcode',
		__( 'Step D: Get Shortcode', 'cyp' ),
		'cyp_meta_box_step_shortcode',
		'settings_page_cyp_tabs',
		'normal'
	);
	add_meta_box(
		'cyp_side_tabcollections',
		__( 'My Video Tabs', 'cyp' ),
		'cyp_meta_box_side_tabcollections',
		'settings_page_cyp_tabs',
		'side'
	);
	colapse_metaboxes('settings_page_cyp_tabs');
	wp_nonce_field('meta-box-order', 'tabs-meta-box-order-nonce', false);
	wp_nonce_field('closedpostboxes', 'tabs-closedpostboxesnonce', false);
	?>

	<div class="wrap cyp-settings">
		<form name="cyp_form_tabs" class="cyp-settings-form" method="post" onSubmit="document.getElementById('cyp_input_update_tabs').focus();" action="<?php echo admin_url() . 'admin.php?page=clever-youtube-plugin/main.php&action=tabs'; ?>">
			<div id="poststuff" class="metabox-holder">
				<div class="inner-sidebar" id="side-info-column">
					<?php do_meta_boxes('settings_page_cyp_tabs', 'side', array()); ?>
				</div>
				<div id="post-body-content">
					<div class="cyp-settings-header">
						<h3 class="span_stylename">
							<span id="span_GUI_vidstylenum">Style 1.</span> <span id="input_GUI_vidstylename">My first video design</span>
						</h3>
						<input autocomplete="off" id="input_GUI_vidstyledescription" class="cyp-edit-style-description" maxlength="65" placeholder="My notes for this style." />
						<img style="display: none;" src="<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-up_hover.png', __FILE__); ?>">
						<img style="display: none;" src="<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-down_hover.png', __FILE__); ?>">
						<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse;">
						<tr>
							<td>
								<img class="handle-collapse-boxes collapse-boxes-up" style="cursor: pointer; display: block;" src="<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-up.png', __FILE__); ?>">
							</td>
							<td rowspan="2">&nbsp;&nbsp;</td>
							<td rowspan="2">
								<input onclick="the_user_has_unsaved_work=false;"
								style="margin: 0 auto;"
								type="submit" class="button button-primary button-large cyp-submit"
								name="cyp_input_update_tabs" id="cyp_input_update_tabs"
								value="Save All Tab Widget Settings" />
							</td>
							<td rowspan="2">
								<a href="#" class="cyp-button-clear-style">
									Clear this Tab Widget
								</a>
							</td>
						</tr>
						<tr>
							<td>
								<img class="handle-expand-boxes collapse-boxes-down" style="cursor: pointer; display: block;" src="<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-down.png', __FILE__); ?>">
							</td>
						</tr>
						</table>
						<br>
					</div>
                    
					<?php do_meta_boxes('settings_page_cyp_tabs', 'normal', array()); ?>
                    
                    <!-- insert a message here for the user? maybe later. -->
                    <h3>&nbsp;</h3>
                   
				</div>
				<textarea name="cyp_tabs_settings" id="cyp_tabs_settings" class="cyp-hide"></textarea>
				<input name="cyp_metaboxes" id="cyp_metaboxes" type="hidden" value="" />
				<input name="cyp_metaboxes_page" id="cyp_metaboxes_page" type="hidden" value="settings_page_cyp_tabs" />
			</div>
		</form>
	</div>
	<div id="cyp-confirm-delete-tab">
		Are you sure you want to delete this Video Tab?
	</div>
	<div id="cyp-confirm-clear-tabcollection">
		Are you sure you want to reset this Video Tab Widget?
	</div>
	<div id="change-tabcollection-name-dialog-form" title="Change Video Tab Widget Name" style="overflow: hidden;">
		<input type="text" name="name" id="change-tabcollection-name-input" autocomplete="off" style="width: 320px;" class="text ui-widget-content ui-corner-all">
	</div>
	<div id="cyp-delete-tab1-warning">
		You cannot delete this Tab. Each Tab Widget must contain at least 1 Tab.
	</div>
	<script>
	jQuery(function($) {
		var tab_title_max_length = <?php echo cyp_tab_title_max_length(); ?>;
		var settings = <?php echo json_encode($tabs_settings); ?>;
		var settings_initial = $.extend(true, {}, settings);
		var max_tabs = <?php echo get_max_tabs_per_collection(); ?>;
		var style_options = <?php echo json_encode($style_options); ?>;
		var content_options = <?php echo json_encode($content_options); ?>;
		var template_options = <?php echo json_encode($template_options); ?>;
		var defaults = <?php echo json_encode($tabs_defaults); ?>;
		setup_sidebar_nav();
		setupChangeCollectionName();
		setupWidgetSelected();
		setupTabSettings();
		setupClearTabCollection();
		setupShortcode();
		setupWidgetAutoplay();
		setupTemplateBelow();
		load_tab_collection(settings.current);
		setupDescription();
		return;

		function get_collection(id) {
			return settings.tab_collections[id - 1];
		}
		function get_current() {
			return get_collection(settings.current);
		}
		function load_tabs() {
			var current = get_current();
			var html = '';

			for (var i = 0; i < current.tabs.length; i++) {
				var id = i + 1;
				var tab = current.tabs[i];
				html += '<div class="cyp-settings-tab" data-tabid="' + id + '">';
				html += '<div class="cyp-settings-tab-wrap">';

				// header
				html += '<div class="cyp-settings-tab-header">';
				html += '<span class="cyp-tab-label">Tab ' + id + '</span>';
				html += '<span class="cyp-tab-label-arrow">&#10142;</span>';
				html += '</div>';

				html += '<div class="cyp-settings-tab-body">';

				html += '<div class="cyp-settings-tab-body-dragging"></div>';

				var removeDisabled = (current.tabs.length === 1 ? ' cyp-remove-tab-disabled' : '');
				html += '<div class="cyp-settings-tab-body-content">';
				html += '<a href class="cyp-remove-tab' + removeDisabled + '"></a>';

				// title
				var max = ((tab.title.length || 0) > tab_title_max_length ? ' cyp-settings-tab-title-count-max' : '');
				const titlePlaceholder = 'Tab ' + String.fromCharCode(65 + i);
				html += '<div class="cyp-settings-tab-field cyp-settings-tab-field-title">';
				html += '<span class="cyp-settings-tab-field-label cyp-tab-drag-handle">Tab Title:</span>';
				html += '<textarea class="cyp-settings-tab-field-input cyp-settings-tab-title" ' +
					'placeholder="' + titlePlaceholder  + '" rows="3">' +
					strip_tags(tab.title) +
					'</textarea>';
				html += '<span class="cyp-settings-tab-title-count' + max + '">' + (tab.title.length || 0) + '/' + tab_title_max_length + '</span>';
				html += '</div>';

				// url
				html += '<div class="cyp-settings-tab-field">';
				html += '<span class="cyp-settings-tab-field-label cyp-tab-drag-handle">YouTube Video:</span>';
				html += '<input class="cyp-settings-tab-field-input cyp-settings-tab-url" type="text" value="' + escapeHtml(tab.url) + '" placeholder="http://www.youtube.com/watch?v=Vpg9yizPP_g" />';
				html += '<span class="cyp-settings-tab-extra">';
				html += '<a href="#" class="cyp-youtube" target="_blank"></a>';
				html += '</span>';
				html += '</div>';

				// style
				html += '<div class="cyp-settings-tab-field">';
				html += '<span class="cyp-settings-tab-field-label cyp-tab-drag-handle">Video Style:</span>';
				renderSelect('cyp-settings-tab-style', style_options, tab.style);
				html += '</div>';

				// content
				html += '<div class="cyp-settings-tab-field">';
				html += '<span class="cyp-settings-tab-field-label cyp-tab-drag-handle">Tab Content:</span>';
				html += '<div class="cyp-settings-tab-field-col50">';
				html += '<div class="cyp-settings-tab-field-col50-inner">';
				renderSelect('cyp-settings-tab-content', content_options, tab.content || '');
				html += '</div>';
				html += '</div>';
				html += '<div class="cyp-settings-tab-field-col50">';
				html += '<div class="cyp-settings-tab-field-col50-inner">';
				renderSelect('cyp-settings-tab-template', template_options, tab.template || '');
				html += '</div>';
				html += '</div>';
				html += '</div>';

				html += '</div>';
				html += '</div>';

				// footer
				html += '<div class="cyp-settings-tab-footer">';
				html += '</div>';

				html += '</div>';
				html += '</div>';
			}
			$('.cyp-settings-tabs-container').html(html);
			updateWidgetSelectedMinMax();
			setupYouTubeIcons();
			return;

			function renderSelect(name, options, selected) {
				var noValueClass = 'cyp-select-value-none';
				var selectClass = 'cyp-settings-tab-field-input cyp-select ' + name;

				if (!selected) {
					selectClass += ' ' + noValueClass;
				}
				html += '<select class="' + selectClass + '">';

				for (var j = 0; j < options.length; j++) {
					var option = options[j];
					html += '<option';
					html += ' value="' + option.value + '"';
					
					if (option.disabled) {
						html += ' disabled';
					}
					
					if (selected === option.value) {
						html += ' selected';
					}

					if (j === 0 && !option.value) {
						html += ' class="' + noValueClass + '"';
					}
					html += '>';
					html += option.name;
					html += '</option>';
				}
				html += '</select>';
			}
		}
		function loadWidgetSelected() {
			var current = get_current();
			$('.cyp-tabcollection-widget-selected').val(current.widget.selected_tab);
		}
		function loadWidgetAutoplay() {
			var current = get_current();
			setWidgetAutoplay(current.widget.autoplay);
			setWidgetAutoplayIgnore(current.widget.autoplay_ignore);
		}
		function loadTemplateBelow() {
			var current = get_current();
			setTemplateBelow(current.template_below);
		}
		function setTemplateBelow(value) {
			var current = get_current();
			current.template_below = value;
			var $select = $('.cyp-select-template-below');
			$select.val(value);
			
			if (value) {
				$select.removeClass('cyp-select-value-none');
			} else {
				$select.addClass('cyp-select-value-none');
			}
		}
		function setWidgetAutoplay(enabled) {
			var current = get_current();
			current.widget.autoplay = (enabled ? true : false);

			if (current.widget.autoplay) {
				$('.cyp-widget-autoplay')
					.data('value', true)
					.addClass('cyp-switch-on')
					.removeClass('cyp-switch-off');
				$('#cyp-widget-autoplay-child').show();
			} else {
				$('.cyp-widget-autoplay')
					.data('value', false)
					.addClass('cyp-switch-off')
					.removeClass('cyp-switch-on');
				$('#cyp-widget-autoplay-child').hide();
			}

			return current.widget.autoplay;
		}
		function load_tab_collection(id) {
			if (id > 0 && id <= settings.tab_collections.length) {
				settings.current = id;
				var collection = get_current();
				load_header();
				load_tabs();
				loadShortcode();
				loadWidgetSelected();
				loadWidgetAutoplay();
				loadTemplateBelow();
				set_nav_selected();
				updateFormInput();
				refreshAddTabState();
				refreshClearTabCollection();
				updateWidgetAutoPlayLabel();
				updateWidgetSelectedMinMax();
			}
			return;

			function load_header() {
				$('#span_GUI_vidstylenum').html('Video Tab ' + collection.id + '.');
				$('#input_GUI_vidstylename').html(collection.title);
				$('.cyp-edit-style-description').val(collection.description);
			}
			function set_nav_selected() {
				$('.li_right_nav_settings_page_SELECTED').removeClass('li_right_nav_settings_page_SELECTED');
				$('.a_right_nav_settings_page_SELECTED').removeClass('a_right_nav_settings_page_SELECTED');
				var $li = $('.li_right_nav_settings_page[data-id=\'' + collection.id + '\']');
				$li.find('.a_right_nav_settings_page').addClass('a_right_nav_settings_page_SELECTED');
				$li.addClass('li_right_nav_settings_page_SELECTED');
			}
		}
		function update_title(id, title) {
			var collection = get_collection(id);

			if (!title) {
				var collectionDefault = defaults.tab_collections[id - 1];
				title = collectionDefault.title;
			}
			collection.title = title;
			$('.li_right_nav_settings_page[data-id="' + id + '"] .a_right_nav_settings_page').html(title);

			if (id === settings.current) {
				$('#input_GUI_vidstylename').html(title);
			}
			onChange();
		}
		function setup_sidebar_nav() {
			$('.a_right_nav_settings_page').click(function () {
				var id = $(this).parent('.li_right_nav_settings_page').data('id');
				load_tab_collection(id);
			});
		}
		function setupChangeCollectionName() {
			setupDialog();
			setupKeyShortcut();
			setupInput();
			setupHeader();
			return;
			
			function setupHeader() {
				$('#input_GUI_vidstylename, #span_GUI_vidstylenum').click(function () {
					openDialog(settings.current);
				});
			}
			function setupInput() {
				$('.edit-icon').click(function () {
					var id = $(this).parent('.li_right_nav_settings_page').data('id');
					openDialog(id);
				});
			}
			function setupDialog() {
				$('#change-tabcollection-name-input').change(function () {
					var $this = $(this);
					var val = $this.val();

					if (val && val.length > 0) {
						while (val[0] === '-' || val[0] === '–') {
							val = val.substring(1);
						}
						$this.val(val);
					}
				});
				$('#change-tabcollection-name-dialog-form').cypDialog({
					height: 172,
					minHeight: 172,
					maxHeight: 172,
					width: 350,
					minWidth: 340,
					dialogClass: 'cyp-dialog cyp-dialog-confirmation cyp-style-name-dialog',
					modal: true,
					resizable: true,
					buttons: {
						"Change Name": function() {
							var title = $('#change-tabcollection-name-input').val();
							var id = $('#change-tabcollection-name-dialog-form').data('id');
							update_title(id, title);
							$(this).dialog('close');
						},
						Cancel: function() {
							$(this).dialog('close');
						}
					},
					open: function(event, ui) {
						var id = $('#change-tabcollection-name-dialog-form').data('id');
						var collection = get_collection(id);
						$('#change-tabcollection-name-input').val(collection.title);
						$('#change-tabcollection-name-dialog-form').unbind('keypress').bind('keypress', function(e) {
							if (e.keyCode === $.ui.keyCode.ENTER) {
								var title = $('#change-tabcollection-name-input').val();
								update_title(id, title);
								$(this).dialog('close');
							}
						});
					},
					close: function() {
						$('#change-style-name-input').val('');
					}
				});
			}
			function setupKeyShortcut() {
				$(document).keydown(function (e) {
					// handle F2 key press
					if (e.keyCode === 113) {
						openDialog(settings.current);
					}
				});
			}
			function openDialog(id) {
				$('#change-tabcollection-name-dialog-form')
					.data('id', id)
					.dialog('open')
					.dialog('option', 'title', 'Edit Name of Video Tab Widget #' + id);
			}
		}
		function setupTabSettings() {
			var dragOkAudio = window.cyp.audio.load('sounds/drag-ok.mp3');
			var dragCancelAudio = window.cyp.audio.load('sounds/drag-cancel.mp3');
			setupAddTab();
			setupRemoveTab();
			load_tabs();
			setupInputs();
			refreshAddTabState();
			setupDrag();
			return;

			function setupAddTab() {
				$('.cyp-add-tab').click(function () {
					var current = get_current();

					if (current.tabs.length < max_tabs) {
						current.tabs.push({
							title: '',
							url: '',
							style: 1,
							content: '',
						});
						refreshAddTabState();
						load_tabs();
						onChange();
					}

					return false;
				});
			}
			function setupRemoveTab() {
				setupDialog();
				setupHandler();
				return;

				function setupHandler() {
					$('.cyp-settings-tabs-container').on('click', '.cyp-remove-tab', function () {
						var current = get_current();

						if (current.tabs.length <= 1) {
							$('#cyp-delete-tab1-warning').dialog('open');
						} else {
							var id = $(this).parents('.cyp-settings-tab').data('tabid');
							var tab = current.tabs[id - 1];

							if (tab.title || tab.url) {
								// ask for confirmation when title or url not empty
								$('#cyp-confirm-delete-tab')
									.data('id', id)
									.dialog('open');
							} else {
								deleteTab(id);
							}
						}

						return false;
					});
				}
				function deleteTab(id) {
					var current = get_current();
					current.tabs.splice(id - 1, 1);
					refreshAddTabState();
					$('.cyp-settings-tab:nth-child(' + id + ')')
						.fadeOut(800, function() {
							load_tabs();
							onChange();
						});
				}
				function setupDialog() {
					$('#cyp-confirm-delete-tab').cypDialog({
						buttons: {
							'Yes': function() {
								var id = $('#cyp-confirm-delete-tab').data('id');
								deleteTab(id);
								$(this).dialog('close');
							},
							Cancel: function() {
								$(this).dialog('close');
							}
						}
					});
					$('#cyp-delete-tab1-warning').cypDialog({
						buttons: {
							Close: function() {
								$(this).dialog('close');
							}
						}
					});
				}
			}
			function setupInputs() {
				onChangeSelector('.cyp-select', function () {
					var $this = $(this);

					if ($this.val()) {
						$this.removeClass('cyp-select-value-none');
					} else {
						$this.addClass('cyp-select-value-none');
					}
				});
				onChangeSelector('.cyp-settings-tab-title', onChangeTitle);
				onChangeSelector('.cyp-settings-tab-url', onChangeUrl);
				onChangeSelector('.cyp-settings-tab-style', function(tab) {
					tab.style = $(this).val();
				});
				onChangeSelector('.cyp-settings-tab-content', function(tab) {
					tab.content = $(this).val();
				});
				onChangeSelector('.cyp-settings-tab-template', function(tab) {
					tab.template = $(this).val();
				});
				$('.cyp-settings-tabs-container').on('blur', '.cyp-settings-tab-title', function(e) {
					var $this = $(this);
					var val = $this.val();
					var id = $this.parents('.cyp-settings-tab').data('tabid');
					var current = get_current();
					var tab = current.tabs[id - 1];
					val = val.replace('<br>', '\n');
					val = val.replace('<br/>', '\n');
					val = val.replace('<br />', '\n');
					val = strip_tags(val);

					if (tab.title !== val) {
						$this.val(val);
						onChangeTitle.call(this, tab, e);
					}
				});
				return;

				function onChangeUrl(tab) {
					var $this = $(this);
					tab.url = $this.val();
					var $youTube = 
						$this.parents('.cyp-settings-tab')
							.find('.cyp-youtube');
					setupYouTubeIcon($youTube, tab.url);
				}
				function onChangeTitle(tab, e) {
					var $this = $(this);
					var val = $this.val();

					if (tab.title !== val) {
						tab.title = val;
						var value = (tab.title.length || 0);
						var max = tab_title_max_length;
						var $count = $(this)
							.parents('.cyp-settings-tab')
							.find('.cyp-settings-tab-title-count');
						$count.text(value + '/' + max);

						if (value > max) {
							$count.addClass('cyp-settings-tab-title-count-max');
						} else {
							$count.removeClass('cyp-settings-tab-title-count-max');
						}
					}
				}
				function onChangeSelector(selector, callback) {
					$('.cyp-settings-tabs-container').on('propertychange change click keyup input paste', selector, function(e) {
						var id = $(this).parents('.cyp-settings-tab').data('tabid');
						var current = get_current();
						var tab = current.tabs[id - 1];
						callback.call(this, tab, e);
						onChange();
					});
				}
			}
			function setupDrag() {
				$('.cyp-settings-tabs-container').sortable({
					handle: '.cyp-tab-drag-handle',
					cancel: '.cyp-remove-tab',
					placeholder: 'cyp-tab-drag-placeholder',
					helper: function (event, element) {
						return element.clone()
							.addClass('cyp-settings-tab-dragging');
					},
					start: function (event, ui) {
						ui.item.show()
							.addClass('cyp-settings-tab-dragging-source');
						var startPosition = ui.item.index() + 1;
						ui.item.data('start-position', startPosition);
					},
					change: function (event, ui) {
						removeHighlight();
						var startPosition = ui.item.data('start-position');
						var correction = (startPosition <= ui.placeholder.index() ? 0 : 1);
						var position = ui.placeholder.index() + correction;

						if (startPosition !== position) {
							addHighlight(position);
						}
					},
					stop: function (event, ui) {
						removeHighlight();
						ui.item.removeClass('cyp-settings-tab-dragging-source');
						var startPosition = ui.item.data('start-position');
						
						if (startPosition !== ui.item.index() + 1) {
							var current = get_current();
							var newOrder = [];
							var newId = 1;
							var i = 0;
							var tabThatGoesToStartPosition = null;

							$('.cyp-settings-tab').each(function() {
								var $this = $(this);
								var oldId = parseInt($this.data('tabid'), 10);
								var tab = current.tabs[oldId - 1];
								newOrder.push(tab);
								$this.data('tabid', newId);
								$this.find('.cyp-tab-label').text('Tab ' + newId);

								if (newId === startPosition) {
									tabThatGoesToStartPosition = $this;
								}
								newId += 1;

								var placeholder = 'Tab ' + String.fromCharCode(65 + i);
								$this.find('.cyp-settings-tab-title')
									.attr('placeholder', placeholder);
								i += 1;
							});
							current.tabs = newOrder;
							fadeCover(tabThatGoesToStartPosition);
							onChange();
							dragOkAudio.play();
						} else {
							dragCancelAudio.play();
						}
					}
				});
				function addHighlight(index) {
					$('.cyp-settings-tab').each(function () {
						var $this = $(this);

						if ($this.data('tabid') === index) {
							$this.addClass('cyp-settings-tab-highlight');
							return false;
						}
					});
				}
				function removeHighlight() {
					$('.cyp-settings-tab-highlight').removeClass('cyp-settings-tab-highlight');
				}
				function fadeCover(tab) {
					var cover = $('<div class="cyp-settings-tab-cover"></div>');
					tab.prepend(cover);
					cover.fadeOut({
						duration: 1500,
						done: function() {
							cover.remove();
						}
					});
				}
			}
		}
		function setupYouTubeIcons() {
			$('.cyp-settings-tab').each(function () {
				var url = $(this).find('.cyp-settings-tab-url').val();
				var $youTube = $(this).find('.cyp-youtube');
				setupYouTubeIcon($youTube, url);
			});
		}
		function setupYouTubeIcon($youTube, url) {
			var id = window.cyp.youtube.parseUrl(url);

			if (id) {
				var youTubeUrl = 'https://youtu.be/' + id;
				$youTube.attr('href', youTubeUrl)
					.unbind('click')
					.removeClass('cyp-youtube-disabled');
			} else {
				$youTube.click(function () { return false; })
					.addClass('cyp-youtube-disabled');
			}
		}
		function refreshAddTabState() {
			var current = get_current();

			if (current.tabs.length >= max_tabs) {
				$('.cyp-add-tab').addClass('cyp-add-tab-disabled');
			} else {
				$('.cyp-add-tab').removeClass('cyp-add-tab-disabled');
			}
		}
		/* from http://locutus.io/php/strings/strip_tags/ */
		function strip_tags(input, allowed) {
			if (!input) {
				return '';
			}
			allowed = (((allowed || '') + '').toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('');
			var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi;
			var commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;

			return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
				return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
			});
		}
		function escapeHtml(string) {
			var entityMap = {
				"&": "&amp;",
				"<": "&lt;",
				">": "&gt;",
				'"': '&quot;',
				"'": '&#39;',
				"/": '&#x2F;'
			};

			return String(string).replace(/[&<>"'\/]/g, function (s) {
				return entityMap[s];
			});
		}
		function setupClearTabCollection() {
			setupDialog();
			setupHandler();
			return;

			function setupDialog() {
				$('#cyp-confirm-clear-tabcollection').cypDialog({
					buttons: {
						'Yes': function() {
							var collectionDefault = defaults.tab_collections[settings.current - 1];
							settings.tab_collections[settings.current - 1] = $.extend(true, {}, collectionDefault);
							load_tab_collection(settings.current);
							onChange();
							$(this).dialog('close');
						},
						Cancel: function() {
							$(this).dialog('close');
						}
					}
				});
			}
			function setupHandler() {
				$('.cyp-button-clear-style').click(function() {
					if (!$(this).hasClass('disabled')) {
						jQuery('#cyp-confirm-clear-tabcollection').dialog('open');
					}
					return false;
				});
			}
		}
		function isSettingsChanged() {
			return (JSON.stringify(settings) !== JSON.stringify(settings_initial));
		}
		function isSettingsDefault() {
			var current = get_current();
			var defaultVal = defaults.tab_collections[current.id - 1];

			return (JSON.stringify(current) === JSON.stringify(defaultVal));
		}
		function refreshClearTabCollection() {
			if (isSettingsDefault()) {
				$('.cyp-button-clear-style').addClass('disabled');
			} else {
				$('.cyp-button-clear-style').removeClass('disabled');
			}
		}
		function updateFormInput() {
			var json = JSON.stringify(settings);
			$('#cyp_tabs_settings').val(json);
		}
		function onChange() {
			refreshClearTabCollection();
			updateFormInput();
			window.the_user_has_unsaved_work = isSettingsChanged();
		}
		function setupShortcode() {
			$('.cyp-help-shortcode').click(function() {
				PYshowhideHelp('help_tabcollection_shortcode');
			});
			$('.cyp-tabcollection-shortcode-select').click(function() {
				$('.cyp-tabcollection-shortcode').select();
				return false;
			});
		}
		function loadShortcode() {
			var sc = '[cleveryoutubetabs tabstyle="' + settings.current + '"]';
			$('.cyp-tabcollection-shortcode').val(sc);
		}
		function setupWidgetSelected() {
			$('.cyp-help-widget-selected').click(function() {
				PYshowhideHelp('help_tabcollection_widget_selected');
			});
			$('.cyp-tabcollection-widget-selected').spinner({
				stop: onSpinnerChange
			});
			$('.cyp-tabcollection-widget-selected').on('propertychange change click keyup input paste', onSpinnerChange);
			return;

			function onSpinnerChange() {
				var $this = $(this);
				var val = $this.val();
				var original = val;
				var min = $this.spinner('option', 'min');
				var max = $this.spinner('option', 'max');
				val = parseInt(val, 10);
				var originalInt = val;

				if (val < min) {
					val = min;
				} else if (val > max) {
					val = max;
				} else if (isNaN(val)) {
					val = min;
				}

				if (originalInt !== val || originalInt != original) {
					$this.val(val);
				}
				var current = get_current();
				current.widget.selected_tab = val;
				updateWidgetAutoPlayLabel();
				onChange();
			}
		}
		function updateWidgetSelectedMinMax() {
			var current = get_current();
			var $selected = $('.cyp-tabcollection-widget-selected');
			var min = 1;
			var max = current.tabs.length;
			$selected
				.spinner('option', 'min', min)
				.spinner('option', 'max', max);
			
			if ($selected.val() > max) {
				$selected.val(max);
			} else if ($selected.val() < min) {
				$selected.val(min);
			}
		}
		function updateWidgetAutoPlayLabel() {
			var current = get_current();
			var val = current.widget.selected_tab;
			$('.cyp-tabcollection-widget-selected-value').text('Tab ' + val);
		}
		function setWidgetAutoplayIgnore(enabled) {
			var current = get_current();
			current.widget.autoplay_ignore = (enabled ? true : false);

			if (current.widget.autoplay_ignore) {
				$('.cyp-widget-autoplay-ignore')
					.data('value', true)
					.addClass('cyp-switch-on')
					.removeClass('cyp-switch-off');
			} else {
				$('.cyp-widget-autoplay-ignore')
					.data('value', false)
					.addClass('cyp-switch-off')
					.removeClass('cyp-switch-on');
			}

			return current.widget.autoplay_ignore;
		}
		function setupWidgetAutoplay() {
			$('.cyp-widget-autoplay').click(function () {
				var $this = $(this);
				setWidgetAutoplay($this.hasClass('cyp-switch-off'));
				onChange();
			});
			$('.cyp-help-widget-autoplay').click(function() {
				PYshowhideHelp('help_tabcollection_widget_autoplay');
			});
			$('.cyp-widget-autoplay-ignore').click(function () {
				var $this = $(this);
				setWidgetAutoplayIgnore($this.hasClass('cyp-switch-off'));
				onChange();
			});
			$('.cyp-help-widget-autoplay-ignore').click(function() {
				PYshowhideHelp('help_tabcollection_widget_autoplay_ignore');
			});
		}
		function setupTemplateBelow() {
			$('.cyp-select-template-below').change(function() {
				var value = $(this).val();
				setTemplateBelow(value);
				onChange();
			});
			$('.cyp-help-template-below').click(function() {
				PYshowhideHelp('help_tabcollection_template_below');
			});
		}
		function setupDescription() {
			cyp_setup_style_description(function() {
				var current = get_current();
				current.description = $(this).val();
				onChange();
			});
		}
	});
	</script>
<?php } ?>