<?php

function metabox_add_closed_class( $classes ) {
	array_push( $classes, 'closed' );
	
	return $classes;
}
function colapse_metabox( $page, $boxId ) {
	add_filter( 'postbox_classes_' . $page . '_' . $boxId, 'metabox_add_closed_class' );
}
function colapse_metaboxes($page) {
	$closedMetaboxes = get_option('cyp_metaboxes_' . $page);

	if (isset($closedMetaboxes) && is_array($closedMetaboxes)) {
		foreach ($closedMetaboxes as $closedMetabox) {
			colapse_metabox($page, $closedMetabox);
		}
	}
}
function cyp_is_curl_enabled() {
	return function_exists('curl_version');
}
function cyp_get_purchase_state($email) {
	$url = 'http://clevergizmos.com/resources/app-resources/cleveryoutubeplugin/cp.php?email=' . $email;
	$result = file_get_contents($url);

	if (empty($result)) {
		if (cyp_is_curl_enabled()) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
			$result = curl_exec($ch);

			if (curl_errno($ch)) {
				$result = 'NO CONNECTION';
			}
			curl_close($ch);
		}
	}

	return $result;
}
function handle_full_mode(&$tmpOptionsArrayGlobal) {
	global $registration_message_title,
		$registration_message_mood,
		$registration_message_body;
		
	// =======================================
	// Copy Protection Stuff
	// =======================================
	if (isset($_GET["CGUser"]) && !isset($_GET['switchtotrial'])) {
		// Eitherway, save the email address 
		$tmpOptionsArrayGlobal['useremail'] = $_GET["CGUser"];
		update_option("OptionsArrayGlobal", $tmpOptionsArrayGlobal);	

		// Run the query to clevergizmos.com
		$theCGoutput = cyp_get_purchase_state($_GET["CGUser"]);
		$registration_message_mood = "orange";	

		if ($theCGoutput == "THIS EMAIL DOES OWN IT") {
			// Save the ownership state
			$tmpOptionsArrayGlobal['userOwnsIt'] = true;
			update_option("OptionsArrayGlobal", $tmpOptionsArrayGlobal);
			$registration_message_title = "Thanks!";
			$registration_message_body = "Thank you for purchasing the Clever YouTube Plugin! Have fun with it!";
			$registration_message_mood = "green";
		} else {
			// Save the ownership state
			$tmpOptionsArrayGlobal['userOwnsIt'] = false;
			update_option("OptionsArrayGlobal", $tmpOptionsArrayGlobal);
			$registration_message_mood = "orange";

			if ($theCGoutput == "THIS EMAIL WAS NOT FOUND") {
				$registration_message_title = "Error: Email not found.";
				$registration_message_body = "We don't have any info on this email address. Perhaps you used a different email address at purchase?";
			} else if ($theCGoutput == "THIS EMAIL DOES NOT OWN IT") {
				$registration_message_title = "Error: This email doesn't own it.";
				$registration_message_body = "I see this email at Clevergizmos.com. But you don't own the plugin. Perhaps you used a different email address at purchase?";
			} else if ($theCGoutput == "NO CONNECTION") {
				$registration_message_title = "Error: Can't connect to CleverGizmos.";
				$registration_message_body = "Your website is preventing us from contacting Clevergizmos.com. So we can't validate this email address. This is often the result of a security plugin installed on your website. Please temporarily disable this plugin, and try to register again.";
			} else {
				$registration_message_title = "Error: Email not found.";
				$registration_message_body = "Unable to determine purchase status. Please contact Clevergizmos.com." . "MSG:" . $theCGoutput . ":";
			}
		}
	}
}
function handle_trial_mode(&$tmpOptionsArrayGlobal) {
	if (isset($_GET['switchtotrial'])) {
		$switch = filter_var($_GET['switchtotrial'], FILTER_VALIDATE_BOOLEAN);

		if ($switch) {
			$tmpOptionsArrayGlobal['userOwnsIt'] = false;
			$tmpOptionsArrayGlobal['curtab'] = 1;
			update_option('OptionsArrayGlobal', $tmpOptionsArrayGlobal);
		}
	}
}
function cyp_handle_submit(&$tmpOptionsArrayGlobal) {
	handle_full_mode($tmpOptionsArrayGlobal);
	handle_trial_mode($tmpOptionsArrayGlobal);

	if (isset($_POST['input_UpdateSettings']) || isset($_POST['cyp_input_update_tabs'])) { 	
		if (isset($_POST['input_user_email'])) {
			$tmpOptionsArrayGlobal['useremail'] = $_POST['input_user_email'];
		}

		if (isset($_POST['input_user_owns_it'])) {
			$tmpOptionsArrayGlobal['userOwnsIt'] = $_POST['input_user_owns_it'];
		}
		update_option('OptionsArrayGlobal', $tmpOptionsArrayGlobal);
		
		if (isset($_POST['cyp_metaboxes']) && isset($_POST['cyp_metaboxes_page'])) {
			$metaboxes = explode(',', $_POST['cyp_metaboxes']);
			$page = $_POST['cyp_metaboxes_page'];
			$option = 'cyp_metaboxes_' . $page;
			update_option($option, $metaboxes);
		}
	}
}
function draw_my_yt_settings_page() {
	global $registration_message_title,
		$registration_message_mood,
		$registration_message_body,
		$tmpOptionsArrayGlobal,
		$MAX_NUMBER_OF_STYLES;

	$tmpOptionsArrayGlobal = get_option('OptionsArrayGlobal');
	cyp_handle_submit($tmpOptionsArrayGlobal);
?> 
<div class="cyp-settings-page-header">
	<div class="cyp-logo"></div>
	<div class="cyp-settings-page-title">
		<h1>Clever YouTube Plugin</h1>
		<h2>Embed YouTube videos in a stylish way.</h2>
		<p>
			<span class="cyp-version">Version <?php the_plugin_version(); ?></span>
			<span class="cyp-madeby">Made by <a target="_blank" href="https://clevergizmos.com/clever-youtube-plugin/">CleverGizmos.com</a></span>
		</p>
		<p>
			<a class="cyp-instructions-btn" href="https://clevergizmos.com/app-help/?app=cyp" target="_blank">
				<span>Instruction Manual</span>
			</a>
		</p>
	</div>
	<div class="cyp-settings-license cyp-settings-page-header-separator">
		<?php
		if ($registration_message_title  != "") { ?>
			<div id="cyp-license-alert">
				<strong><?php echo $registration_message_title; ?></strong><br/>
				<?php echo $registration_message_body; ?>
			</div>
		<?php } ?> 
		<input hidden id="input_user_owns_it" name="input_user_owns_it" type="text" value="<?php echo $tmpOptionsArrayGlobal['userOwnsIt']; ?>" />
        <h3>License</h3>
		<?php if ($tmpOptionsArrayGlobal['userOwnsIt'] == true) { ?>
			<p><?php echo $tmpOptionsArrayGlobal['useremail']; ?></p>
			<div class="cyp-trial-toggle">
				<span class="cyp-muted cyp-trial-switch cyp-enabled-switch">Trial Mode</span>
				<span class="cyp-toggle cyp-toggle-on"></span>
				<span class="cyp-muted">Full Mode</span>
			</div>
		<?php } else { ?>
			<p>You are currently in "Trial Mode." To register The Clever YouTube Plugin, type your Email Address below, <strong><em>after purchasing</em></strong> this Plugin from <a rel="nofollow" target="_blank" href="https://clevergizmos.com/">Clevergizmos.com</a>.</p>
			<input autocomplete="off" placeholder="Your Email Address" id="input_user_email" name="input_user_email" spellcheck="false" type="text" value="<?php echo $tmpOptionsArrayGlobal['useremail']; ?>" />
			<div class="cyp-trial-toggle">
				<span class="cyp-muted">Trial Mode</span>
				<span class="cyp-toggle cyp-toggle-off"></span>
				<span class="cyp-muted cyp-full-switch cyp-enabled-switch">Full Mode</span>
			</div>   
		<?php } ?>
	</div>
</div>

<?php
$possible_screens = array('default', 'tabs');
$current_screen = (isset($_GET['action']) && in_array($_GET['action'], $possible_screens)) ? $_GET['action'] : 'default';
$defaultUrl = admin_url('admin.php?page=clever-youtube-plugin%2Fmain.php');
$navtabs = array(
	'default' => array(
		'active' => ('default' === $current_screen),
		'url' => $defaultUrl,
		'title' => 'Edit Video Styles',
		'description' => 'Use this area to style your Clever YouTube Plugin videos. You can specify the size of your Video Player, as well as add effects like custom Play Buttons and Video Thumbnails. Checkout the <a href="https://clevergizmos.com/clever-youtube-plugin/?cyp-sample=1" target="_blank">Video Samples</a> on the webpage for some inspiration.'
	),
	'tabs' => array(
		'active' => ('tabs' === $current_screen),
		'url' => esc_url(add_query_arg(array('action' => 'tabs'), $defaultUrl)),
		'title' => 'Edit Video Tabs',
		'description' => 'Use this area to build Video Tab Widgets for your website. A Video Tab Widget is a collection of YouTube videos and styles. And can be very useful for displaying multiple videos in a sequence. Watch this <a target="_blank" href="https://clevergizmos.com/app-help/?app=cyp&helpvid=tab-widget">Help Video</a> to learn more.'
	)
);
?>
<div class="wrap">
	<h2 class="nav-tab-wrapper cyp-nav-tab-wrapper">
		<?php foreach ($navtabs as $tab) : ?>
		<?php if ($tab['active']) : ?>
		<span class="nav-tab nav-tab-active">
			<?php echo $tab['title']; ?>
		</span>
		<?php else : ?>
		<a href="<?php echo $tab['url']; ?>" class="nav-tab">
			<?php echo $tab['title']; ?>
		</a>
		<?php endif; ?>
		<?php endforeach; ?>
	</h2>
</div>
<p class="cyp-tab-settings-intro">
	<?php echo $navtabs[$current_screen]['description']; ?>
</p> 

<?php
// cache images
$cache = array(
	'buttons/settings-page-expander/button-expander-up_hover.png',
	'buttons/settings-page-expander/button-expander-down_hover.png',
	'the-settings-page/icon-delete-tab-onmouseover.png',
	'the-settings-page/button-add-new-tab.png',
	'the-settings-page/button-add-new-tab-disabled.png',
	'the-settings-page/button-edit-style-normal.png',
	'the-settings-page/button-edit-style-hover.png',
	'buttons/button-reset-spinner.png',
	'the-library-picker/background-wood.jpg',
	'the-settings-page/button-close-help-box.png',
	'the-settings-page/gradient-for-sticky-div.png',
	'the-settings-page/help-box-arrow.png',
	'the-settings-page/button-close-help-box.png',
	'the-meta-box/cyp-header-banner.jpg',
	'the-meta-box/button-clear-previous-settings-ENABLED.png',
	'the-meta-box/button-clear-previous-settings-DISABLED.png',
	'the-settings-page/button-clear-style.png',
	'the-settings-page/button-clear-style-disabled.png',
	'icons/main-star.png',
	'the-settings-page/logo-plugin-starfish.png',
	'the-settings-page/settings-page-license-divider.png',
	'the-rendering/switch-on.png',
	'the-rendering/switch-off.png',
	'the-settings-page/icon-delete-tab.png',
	'the-settings-page/icon-delete-tab-onmouseover.png',
	'the-settings-page/icon-delete-tab-disabled.png',
	'icons/icon-question-mark.png',
	'the-settings-page/drag-bar-for-cyp-tabs.png',
	'the-settings-page/switches/switch-small-on.jpg',
	'the-settings-page/switches/switch-small-off.jpg',
	'the-settings-page/button-add-new-tab.png',
	'the-settings-page/button-add-new-tab-disabled.png',
);
foreach ($cache as $path) {
	$url = plugins_url('/images/' . $path, __FILE__);
	echo '<img src="' . $url . '" style="display: none;" />';
}

// include tab content
if ('tabs' === $current_screen) {
	include_once('the_settings_page-tabs.php');
	render_settings_page_tabs();
} else {
	include_once('the_settings_page-video.php');
	render_settings_page_video();
}
?>

<div id="cyp-license-empty-email">
	<strong>Error: empty email.</strong><br>
	You need to type your email address in the box first!
</div>
<div id="cyp-license-invalid-email">
	<strong>Error: invalid email.</strong><br>
	Your email address doesn't look right. Fix the mistake in your email address please.
</div>
<div id="cyp-confirm-change-page">
	You made some changes in this Tab, that haven't been saved yet. Save them now?
</div>
<div id="cyp-confirm-change-license">
	You need to save your current settings before attempting to change your License Status. Save them now?
</div>
<script>
jQuery(function($) {
	var metaboxes = new Metaboxes();
	preventEnterSubmission();
	setupLicense();
	setupSettingsHeader();
	setupCollapseBoxes();
	setupPostboxes();
	setupChangePage();
	return;

	function setupLicense() {
		setupDialogs();
		$('#cyp-confirm-change-license').cypDialog({ width: 410 });
		$('.cyp-trial-toggle .cyp-toggle-off').click(switchToFullMode);
		$('.cyp-trial-toggle .cyp-toggle-on').click(switchToTrialMode);
		$('.cyp-trial-switch').click(switchToTrialMode);
		$('.cyp-full-switch').click(switchToFullMode);
		setupEnterSubmit();
		setupDialogShortcuts();
		return;

		function setupDialogShortcuts() {
			$(document).delegate('.ui-dialog', 'keypress', function(e) {
				var c = String.fromCharCode(e.which).toLowerCase();

				if (c === 'y') {
					var yes = $(this).find('.ui-button-text:contains("Yes")');

					if (yes.length) {
						yes.eq(0).trigger('click');
						return false;
					}
				}
			});
		}
		function setupEnterSubmit() {
			var el = document.getElementById('input_user_email');

			if (el) {
				el.onkeypress = function(e) {
					var event = e || window.event;
					var charCode = event.which || event.keyCode;
					if ( charCode == '13' ) {
						switchToFullMode();
						return false;
					}
				}
			}
		}
		function setupDialogs() {
			$('#cyp-license-alert').cypDialog({
				autoOpen: true
			});
			$('#cyp-license-empty-email').cypDialog();
			$('#cyp-license-invalid-email').cypDialog();
		}
		function openDialog(changes) {
			if (window.the_user_has_unsaved_work) {
				$('#cyp-confirm-change-license').dialog('option', 'buttons', {
					'Save Changes': onSave,
					'Discard Changes': onDiscard,
					Cancel: function() {
						$(this).dialog('close');
					}
				});
				$('#cyp-confirm-change-license').dialog('open');
			} else {
				changes();
			}
			return;

			function onSave() {
				postSettingsForm(function () {
					changes();
				});
			}
			function onDiscard() {
				window.the_user_has_unsaved_work = false;
				changes();
			}
		}
		function switchToTrialMode() {
			openDialog(setTrialMode);
			return;

			function setTrialMode() {
				var url = window.location.href;

				if (url.indexOf('switchtotrial=true') === -1) {
					url += '&switchtotrial=true';
					window.location.href = url;
				}
			}
		}
		function switchToFullMode() {
			openDialog(setFullMode);
			return;

			function setFullMode() {
				// Cleanup email
				var cg_users_email = $('#input_user_email').val();
				cg_users_email = cg_users_email.toLowerCase();
				cg_users_email = cg_users_email.trim();
				$('#input_user_email').val(cg_users_email);

				// CHECK 1 - Is user's Email empty?
				if (cg_users_email == "") {
					$('#cyp-license-empty-email').dialog('open');
					return false; 
				}

				// CHECK 2 - Is this user's Email a valid Email Address?
				var my_email_reg_expression = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

				if (my_email_reg_expression.test(cg_users_email) == false) {
					$('#cyp-license-invalid-email').dialog('open');
					return false; 
				}

				// =============================================
				// If we got this far, then process the query
				// =============================================
				var url = "<?php echo admin_url() . 'admin.php?page=clever-youtube-plugin/main.php'; ?>";
				url = url + "&CGUser=" + cg_users_email;
				window.location.href = url;

				return true;
			}
		}
	}
	function setupSettingsHeader() {
		var $window = $(window);
		var $header = $('.cyp-settings-header');
		$window.on('scroll', function(e) {
			if ($window.scrollTop() > 293) {
				$header.addClass('cyp-fixed');
			} else {
				$header.removeClass('cyp-fixed');
			}
		});
	}
	function setupCollapseBoxes() {
		$('.cyp-settings .handle-expand-boxes').click(function () {
			$('#post-body-content .postbox').removeClass('closed');
			metaboxes.clear();
			$('#post-body-content .postbox').each(function () {
				var id = $(this).parent().attr('id');
				metaboxes.add(id);
			});
			return false;
		});
		$('.cyp-settings .handle-collapse-boxes').click(function () {
			$('#post-body-content .postbox').addClass('closed');
			metaboxes.clear();
			$(window).scrollTop(0);
			return false;
		});
		$('.cyp-settings .collapse-boxes-up').mouseover(function () {
			$(this).attr('src', '<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-up_hover.png', __FILE__); ?>');
		});
		$('.cyp-settings .collapse-boxes-up').mouseout(function () {
			$(this).attr('src', '<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-up.png', __FILE__); ?>');
		});
		$('.cyp-settings .collapse-boxes-down').mouseover(function () {
			$(this).attr('src', '<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-down_hover.png', __FILE__); ?>');
		});
		$('.cyp-settings .collapse-boxes-down').mouseout(function () {
			$(this).attr('src', '<?php echo plugins_url('/images/buttons/settings-page-expander/button-expander-down.png', __FILE__); ?>');
		});
	}
	function setupPostboxes() {
		postboxes.add_postbox_toggles('clever-youtube-plugin');

		// set initial state
		$(document).ready(function () {
			$('.cyp-settings .postbox').each(function () {
				var $postbox = $(this);
				setState($postbox);
			});
		});

		// disable sortable settings
		$('.cyp-settings .meta-box-sortables').sortable({ disabled: true });
		$('.cyp-settings .postbox .hndle').css('cursor', 'pointer');

		$('.cyp-settings .postbox > .hndle').click(function () {
			var $parent = $(this).parent();
			setState($parent);
		});

		function setState($postbox) {
			var id = $postbox.attr('id');
			var isClosed = $postbox.hasClass('closed');

			if (isClosed) {
				metaboxes.add(id);
			} else {
				metaboxes.remove(id);
			}
		}
	}
	function preventEnterSubmission() {
		jQuery('form').on('keypress', checkEnter);

		// Prevent ENTER key from submitting forms
		// http://stackoverflow.com/questions/585396/
		function checkEnter( e ) {
			e = e || event;
			var txtArea = /textarea/i.test((e.target || e.srcElement).tagName);
			return txtArea || (e.keyCode || e.which || e.charCode || 0) !== 13;
		}
	}
	function setupChangePage() {
		setupDialog();
		setupHandler();
		return;

		function setupHandler() {
			$('a.nav-tab').click(function () {
				if (window.the_user_has_unsaved_work) {
					var $this = $(this);
					$('#cyp-confirm-change-page')
						.data('destination', $this.attr('href'))
						.dialog('open');

					return false;
				}
			});
		}
		function setupDialog() {
			$('#cyp-confirm-change-page').cypDialog({
				width: 410,
				buttons: {
					'Save Changes': function() {
						var destination = $(this).data('destination');
						postSettingsForm(function () {
							window.location.href = destination;
						});
					},
					'Discard Changes': function() {
						window.the_user_has_unsaved_work = false;
						window.location.href = $(this).data('destination');
					},
					Cancel: function() {
						$(this).dialog('close');
					}
				},
			});
		}
	}
	function postSettingsForm(callback) {
		var $form = $('form.cyp-settings-form');
		var url = $form.attr('action');
		var submitName = $('.cyp-submit').attr('name');
		var data = $form.serialize();
		data += '&' + submitName + '=1';
		$.post(url, data, function(data) {
			window.the_user_has_unsaved_work = false;
			callback();
		});
	}
	function Metaboxes() {
		var self = this;
		self.data = [];
		self.add = function (id) {
			if (self.data.indexOf(id) < 0) {
				self.data.push(id);
				onChange();
			}
		};
		self.remove = function (id) {
			var index = self.data.indexOf(id);

			if (index > -1) {
				self.data.splice(index, 1);
				onChange();
			}
		};
		self.clear = function () {
			self.data = [];
			onChange();
		};

		function onChange() {
			var serialized = self.data.join(',');
			$('#cyp_metaboxes').val(serialized);
		}
	}
});
</script>
<?php } ?>