<?php

if (isset($GLOBALS['cs_plugin_dir'])) {
    require_once $GLOBALS['cs_plugin_dir'].'xmldb.inc.php';
} else {
    require_once 'xmldb.inc.php';
}


/**
* Remove <![CDATA[ and ]]> tags if exist
* 
* @param string $data
* @return string
*/
function  cs_cdata($data)
{
    if (substr($data, 0, 9) === '<![CDATA[' && substr($data, -3) === ']]>') {
        $data = substr($data, 9, -3);
    }
    
    return $data;
}

/**
* Return formatted title
* 
* @param string $title
* @param bool $include_css_js
* @return string
*/
function cs_product_title_fmt($title, $link, $include_css_js = false)
{
    $t_title= (!$include_css_js
            ? "<$_SESSION[cs_title_tag]"
            . ($_SESSION['cs_title_style'] != ''
                ? " style=\"display: inline-block; "
                . ($_SESSION['cs_title_tag'] === 'div' ? 'text-align: center; ' : '')
                . "$_SESSION[cs_title_style]\""
                : '')
            . ">"
            : '')
        . "<a target=\"_blank\" href=\"$link\" rel=\"nofollow\">"
        . $title
        . "</a>"
        . (!$include_css_js
            ? "</$_SESSION[cs_title_tag]>"
            : '');
    
    $t_title = "<strong><a target=\"_blank\" href=\"$link\" rel=\"nofollow\" "
                ."style=\"line-height: 1.2; font-weight:bold; text-decoration:none;"
              
                ."color:" .((strlen($_SESSION['cs_title_text_color'])>2) ? $_SESSION['cs_title_text_color'] : ""). ";\">"
               
                .html_entity_decode($title)
                ."</a></strong>";
    $title="<h3 ".(strlen($_SESSION['cs_title_class'])>2 ? 'class="'.$_SESSION['cs_title_class']."\"": '')." style='font-size:1.15em; text-transform:uppercase; font-weight:normal;'><as style='text-decoration:none' href='".$link."'  >".$title."</a></h3>";
    
    $t_title =        html_entity_decode($title);         
    return $t_title;
}

/**
* Get all CSS and JS code
* 
* @param int $totalp
* @param int $items_per_page
*/
function cs_get_css_js($totalp, $items_per_page)
{
    global $cs_plugin_version;
    
    #wp_register_style('cs_stylesheet', $_SESSION['cs_plugin_url'].'/style.css');
    #wp_enqueue_style('cs_stylesheet');
    if ($totalp > $items_per_page) cs_show_paging_css();
    
    wp_enqueue_script(
        'cs_script',
        $_SESSION['cs_plugin_url'].'/init.js'
        . '?plugin_url='.htmlspecialchars($_SESSION['cs_plugin_url']),
        array('jquery'),
        $cs_plugin_version);
}

/**
* Good htmlspecialchars
* 
* @param mixed $str
* @return string
*/
function hsc($str)
{
    return htmlspecialchars($str, ENT_QUOTES);
}

/**
 * Function to display product box
**/
function cs_product_box ($dummy,$p_title,$p_content){
                    
                        $item_list_box .="<div ". (($dummy=="dummy")? "id=\"cs_hide_col\"" : ($_SESSION['cs_image_descr_layout']=='horizontal' ? "id=\"cs_horizontal\"": '') )." class=\"cs_column_".substr($_SESSION['cs_display_layout'],0,1)."\" style=\"\">\n\n";
                        $item_list_box .=
                        
                            "<div align=center class=\"cs_img_center\" style=\"font-size:100%; font-weight:inherit; font-family:inherit;font-style:inherit; font-weight:inherit; line-height:150%; border:0px solid ". $_SESSION['cs_prodbox_border_color']  ."; 1background:" .$_SESSION['cs_prodbox_fill_color']  .";  1background-color: ".$_SESSION['cs_prodbox_fill_color']  .";  \"> \n"
                        
                            ."<div style=\"font-size:100%; font-weight:inherit; font-family:inherit;font-style:inherit; font-weight:inherit; line-height:120%; 1background:".((strlen($_SESSION['cs_title_bg_color'])>2) ? $_SESSION['cs_title_bg_color'] : "#f3f3f3")."; padding:5px; border-radius:3px; 1border:1px solid ".((strlen($_SESSION['cs_title_bg_color'])>2) ? $_SESSION['cs_title_bg_color'] : "#f3f3f3").";\">"
                            . '<span style=" color:'.((strlen($_SESSION['cs_title_text_color'])>2) ? $_SESSION['cs_title_text_color'] : "inherit").';">'.$p_title.'</span>'
                            ."</div>\n"
                            . $p_content
                          . "</div> <!-- end of align=center -->\n";            // align=center
                   
                         $item_list_box .= "</div><!-- end of cs cloumn -->\n";          // cs_column
                         //$item_list_box='';
                         return $item_list_box;
                    
                }
                
                
                
/**
* Return HTML product list to insert into post / page / etc
* 
* @param string $section
* @param int $user_id
* @param int $criteria
* @param int $page
* @param int $product_number
* @return string
*/
function cs_show_related_reviews($user_id, $criteria){
    
    
       
        $p_data = cs_get_items('review-details', $user_id, 'related-reviews',4,        1,"","", false);
        if (empty($p_data['posts'])) {
           // $item_list = '<strong>Sorry, no results.</strong>';
        } else {
                
            echo '<div style="margin-top:100px;"><h3>RELATED PRODUCT REVIEWS</h3>'.$section;
                 
            echo "<div id=\"cs_product_list\" style='border:1px solid #dcdcdc; background:#f5f5f5;//padding:10px;'>";
                
                $rows_count=0;
                
                foreach ($p_data['posts'] as $p) {
                    $rows_count=$rows_count+1;
                    
                    if (  ($rows_count==1) ||  ($rows_count==3) ) {
                            $item_list .="<div class='cs_row' style='margin-bottom:10px; border:0px;'>";
                    }
                     $item_list .="<div  class='cs_column_review' style='text-align:center; border:0px solid red; padding:20px; '>";
                     
                     $item_list .='<a href='.$p["target_url"].' >'.$p['post_content'].'</a>';
                     $item_list .='<h5 style="margin-top:0px; padding:8px;">'.$p['post_title'].'</h5>';
                     $item_list .='</div>';
                     
                     if (($rows_count==2) ||(($rows_count==4)) ) {
                            $item_list .='</div>';
                    }
                }
            
            echo $item_list.'';
            echo "</div>"; //product list
            echo "</div><div style='clear:both;'></div>";
           
        }
        
        
}


function cs_show_external_reviews($title, $url_return){
	
		
	    

	    
	    
	        $url="https://cbproads.com/xmlfeed/wp/main/cb_external_reviews.asp?cs_review_id=".$_GET['cs_review_id'];
	        //echo $url;
            $rss = fetch_feed($url);
            if (is_wp_error($rss)) return $empty_answer;
            if (0 == $rss->get_item_quantity(400)) { $totalp=0;}
            else{
        
          
                $items = $rss->get_items(0, 400);
                $tmp = $rss->get_item()->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, 'total_products');
                $totalp = cs_cdata($tmp[0]['data']);
            }
            
            $item_list="";
            $rows_count=0;
           // echo 'total'.$totalp;
            
            if ($totalp>0) {
                
                echo '<div style="margin-top:100px;"><h3>Customer Reviews </h3>';
	        
	      
	            echo "<div id=\"cs_product_list\" styles='border:1px solid #dcdcdc; background:#f5f5f5;//padding:10px;'>";
                
                    foreach ($items as $item) {
        
                        $paths = $item->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, "title");
                        $title = htmlspecialchars(cs_cdata($paths[0]['data']));
                  
                        $paths = $item->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, "author");
                        $author = htmlspecialchars(cs_cdata($paths[0]['data']));
                        
                        $paths = $item->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, "score");
                        $score = htmlspecialchars(cs_cdata($paths[0]['data']));
                        
                        $paths = $item->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, "review");
                        $review = htmlspecialchars(cs_cdata($paths[0]['data']));
                        
                        $paths = $item->get_item_tags(SIMPLEPIE_NAMESPACE_RSS_20, "pdate");
                        $pdate = htmlspecialchars(cs_cdata($paths[0]['data']));
                        
                        $rows_count=$rows_count+1;
                            
                          
                             $item_list .="<div class='cs_row_external'>";
                         
                                 $item_list .="<div  class='cs_column_external_review_1'>";
                                 $item_list .=$author;
                                 $item_list .='</div>';
                                 
                                 $item_list .="<div  class='cs_column_external_review_2'>";
                                 $item_list .='<h5>'.$title.'</h5>';
                                 $item_list .='<p>'.$author.' <span style="font-size:.87em; color:#A0A0A0;"> on '.$pdate.'</span></p>';
                                 $item_list .='<p">'.$review.'</p>';
                                 $item_list .='</div>';
                             
                         
                            $item_list .='</div>';
                         
                    }
                    echo $item_list;
                    
                echo "</div>"; //product list
                echo "</div><div style='clear:both;'></div>";                                       
            }
            
            
                 echo '<div style="margin-top:70px; background:#f0f0f0; padding:20px; border-radius:5px;"><h3>Write A Review </h3>';
                 echo '<p>Your email address will not be published. Please limit the review content to maximum 500 characters. </p>';
                 echo "<div id=\"cs_product_list\" '>";
            
                                
                    		    global $wp;

                              
                                //input form
                                $input_form.="<form method='post' action='https://cbproads.com/xmlfeed/wp/main/grab_external_reviews.asp'>\n";
                                $input_form.="<h6>Headline</h6><input style='width:100%;' name='headline'><br \>\n";
                                $input_form.=  "<h6>Your thoughts</h6><textarea name='review'></textarea><br \>\n";
                                $input_form.="<h6>Name</h6><input name='names'><br \>\n";
                                $input_form.="<h6>Email</h6><input name='email'><br \>\n";
                                $input_form.="<input type=hidden name='id' value='".$_GET['cs_review_id']."'>\n";
                                $input_form.="<input type=hidden name='title' value='".$title."'>\n";
                                $input_form.="<input type=hidden name='ret_url' value='".$url_return."?".$_SERVER['QUERY_STRING']."'>\n";
                                 $input_form.="<input type=submit value='Submit Review'>\n<br \><br \>\n</form>";
                                    
                                             
                               // $input_form.='</div>';
                                
                                echo $input_form;
            
            
        		echo "</div>"; //product list
                echo "</div><div style='clear:both;'></div>";
}





function cs_display_title($title,$pad_color,$section){
           
       
      $review_writeup_new='';         
     $arr_res = explode(' ',trim(($title)));
     
          if ($section==="reviews"){
        
             $review_writeup_new.='<p>In this section, you will find unbiased <strong>reviews</strong> of the best performing products of Clickbank. '.
                                'Most of the products are proven with the highest buyer satisfaction rate.<br></p>';
                          
        }elseif ($section==="popular"){
            
            $review_writeup_new.='<p>Features the best rated products</p> ';
                            
        }elseif ($section==="bestselling"){
            
            $review_writeup_new.='<p>Features the best rated products of Clickbank</p> ';
                            
        }elseif ($section==="featured"){
            
            $review_writeup_new.='<p>Features the best rated products of Clickbank</p> ';
                            
        }else{
             $review_writeup_new.='';
        }
        
       
       
        return '<div class="cs_heading_div" >'.
            '<h2><span>'.
            '<strong style="color:'.$pad_color.'";>'.$arr_res[0].'</strong> '. $arr_res[1].' '. $arr_res[2].' '. $arr_res[3] .' '.$arr_res[4]. ' '.$arr_res[5].' '.$arr_res[6].' '.$arr_res[7].'</span></h2>'.
            $review_writeup_news.'<!--<div style="position:absolute;  bottom:10px;  right:10px;"><i class="fa fa-angle-double-down" style=" color:'.$pad_color.';"></i></div>--></div>';
}
    

function cs_show($section, $user_id, $criteria = null, $page = 1, $get_mcat, $get_scat, $product_number = null)
{
    if (in_array($section, array('category', 'search'), true)) {
        $cur_view = $_SESSION['cs_switch_view'];
    } else {
        $cur_view = $_SESSION['cs_view_other'];
    }
  
  
    $p_data = cs_get_items($section, $user_id, $criteria,
        ($product_number !== null ? $product_number : $_SESSION['cs_items_per_page']),
        $page, $get_mcat,$get_scat, false);
        
    if (empty($p_data['posts'])) {
        $item_list = '<strong>Sorry, no results.</strong>';
    } else {
        $item_list = '';
        $row_count=0;
       // $column_limit=$_SESSION['cs_items_per_page']/$_SESSION['cs_display_layout'] + 1;
        $column_limit=substr($_SESSION['cs_display_layout'],0,1);
        
        // $item_list .="<div class=\"cs_row\">\n\n";
         //var_dump($p_data);
         
        $pad_color=(strlen($_SESSION['cs_primary_color'])>2 ? $_SESSION['cs_primary_color']: '#cccccc');
        

        
        foreach ($p_data['posts'] as $p) {
            
            $row_count=$row_count+1;
            
            if(  ($section==="reviews") || ($section==="review-details")){
               
               
                
                if ($_SESSION['cs_product_review_layout']==='horizontal'){
                            $item_list .="<div class=\"cs_row_horizontal\">\n\n";
                            $item_list .=      "<div  class='cs_column_review_1' style='text-align:left;margin-bottom:5px;'>".                        
                                                
                                                    "<div style='overflow: hidden;'><a href='".$p['target_url']."'>".$p['post_content']."</a></div>".
                                                    /*"<div id='bread_crumb_reviews' align='left' style='margin-top:45px;'>".
                                                    "  <i class='fa fa-folder-open' style='font-size:13px;color:silver;' aria-hidden='true'></i> ".
                                                        "<a style='font-size:13px; font-weight:normal;' href='".$p['m_target_url']."'>".$p['mcname']."</a> ".
                                                        "<i class='fa fa-angle-right' style='font-size:12px;color:silver;'aria-hidden='true'></i> ".
                                                        "<a style='font-size:13px; font-weight:normal;' href='".$p['s_target_url']."'>".$p['scname']."</a>".
                                                    "</div>".*/
                                                    
                                                "</div>";
                                                
                                                
                                                //color:".((strlen($_SESSION['cs_title_text_color'])>2) ? $_SESSION['cs_title_text_color'] : 'inherit')
                            $item_list .=      "<div  class='cs_column_review_2' style='text-align:left;border:0px solid red;'>".       
                                                    //"<header class='entry-header'>".
                                                    
                                                       "<h4 ".(strlen($_SESSION['cs_title_class'])>4 ? 'class="'.$_SESSION['cs_title_class']."\"": '').
                                                       " style='margin-top:0px; margin-bottom:5px;  text-transform:capitalize; line-height:1.33em; font-size:1.3em;   '  ><a style='color:#404040; text-decoration:none;' href='".$p['target_url']."'>".str_replace("Review","Review",$p['post_title']).
                                                        (($section==="review-details")? '':'').
                                                        "</a></h4>".  
                                                    //"</header>".
                                                    "<span style='font-size:0.8em;color:#B0B0B0;'><i class='fa fa-user' aria-hidden='true' style='font-size:16px;color:silver;'></i> by admin   ".
                                                    "<i class='fa fa-calendar' aria-hidden='true' style='font-size:16px;color:silver;'></i> ".date('d/F/Y', strtotime($p['pdate'])).'</span>'.
                                                    "<p style='margin-top:12px; margin-bottom:0px; padding-right:3px;'>".substr($p['review_desc'], 0, 150).' [...]</p>'.
             
                                                    "<div style='".($_SESSION['cs_view_more_style']==='button' 
                                                                    ? 'text-align:left; margin-bottom:15px; margin-top:15px;'
                                                                    : 'text-align:right; margin-right:12px; margin-top:7px;').
                                                                "'>".
                                                                    ($_SESSION['cs_view_more_style']==='button' 
                                                                    ? '<a href="'.$p['target_url'].'"   class="'.$_SESSION['cs_button_class'] .'" style="text-decoration:none;">Read Full Review</a>'
                                                                    : '<a href="'.$p['target_url'].'"   style="text-decoration:none;">Read Full Review</a>'
                                                                    ).
                                                     "</div>".
                                                     
                                                     
                                                  "</div><div style='clear:both;'></div>";
                                                
                             $item_list .="</div>". //cs_row
                                            "\n<!-- end of reviews row -->";
                                            
                }else{                  ///********************** stack model layout**********************************
              
                    if($row_count %3==1) { 
                         $item_list .="<div  class='cs_column_review_stack_main' >\n\n\n";  
                    }
                         $item_list.=  "<div class='cs_column_review_stack' style='margin-bottom:30px; padding:5px; border:1px solid #dcdcdc; text-align:left; background:#ffffff; box-shadow:0px 5px 15px rgba(0, 0, 0, 0.14);'>" ; 
                                         $item_list .="<div style='overflow: hidden;'><a href='".$p['target_url']."'>".$p['post_content']."</a></div>\n".  
                                                    "<div style='padding-left:7px; padding-bottom:5px; padding-right:5px;'>".
                                                        "<h4 style='margin-top:10px; margin-bottom:3px; font-weight:normal; text-transforms:capitalize; line-height:1.33em; font-size:1.3em;  ' ".(strlen($_SESSION['cs_title_class'])>2 ? 'class="'.$_SESSION['cs_title_class']."\"": '').
                                                       " ><a style='color:#404040;text-decoration:none;' ".
                                                            "href='".$p['target_url']."'>".
                                                            str_replace("Review","Review",$p['post_title']).
                                                            
                                                            
                                                        (($section==="review-details")? "":"").
                                                        "</a></h4>".
                                                        "<span style='margin-top:0px; font-size:0.85em;color:#B0B0B0;'><i class='fa fa-user' aria-hidden='true' style='font-size:12px;color:silver;'></i> by admin   ".
                                                        "<i class='fa fa-calendar' aria-hidden='true' style='font-size:12px;color:silver;'></i> ".date('d/F/Y', strtotime($p['pdate'])).'</span>';
                                                        if (   $_SESSION['cs_switch_view'] ==='tdli'){ //standard
                                                            $item_list .=  '<p align="left" style="margin-top:15px; margin-bottom:5px; font-size:1em;">'.substr($p['review_desc'], 0, 120).'...</p>';
                                                        }
                                           $item_list .=           "<div style='".($_SESSION['cs_view_more_style']==='button' 
                                                                    ? 'text-align:left; margin-bottom:15px; margin-top:15px;'
                                                                    : 'text-align:right; margin-right:12px; margin-top:7px;').
                                                                "'>".
                                                                    ($_SESSION['cs_view_more_style']==='button' 
                                                                    ? '<a href="'.$p['target_url'].'"   class="'.$_SESSION['cs_button_class'] .'" style="text-decoration:none;">Read Full Review</a>'
                                                                    : '<a href="'.$p['target_url'].'"   style="text-decoration:none;">Read Full Review</a>'
                                                                    ).
                                                                "</div>";
                                                         if (   ($_SESSION['cs_switch_view'] ==='tdli') && ($section==="review-details") ){ //
                                        $item_list .=            "<div id='bread_crumb_reviews' align='left' style='margin-top:10px;'>".
                                                                "  <i class='fa fa-folder-open' style='font-size:13px;color:silver;' aria-hidden='true'></i> ".
                                                                    "<a style='font-size:13px; font-weight:normal;' href='".$p['m_target_url']."'>".$p['mcname']."</a> ".
                                                                    "<i class='fa fa-angle-right' style='font-size:12px;color:silver;'aria-hidden='true'></i> ".
                                                                    "<a style='font-size:13px; font-weight:normal;' href='".$p['s_target_url']."'>".$p['scname']."</a>".
                                                                   "</div>";
                                                         }
                                        $item_list.="</div>".
                                         "</div>\n\n";
                    if($row_count %3==0) { 
                         $item_list .="</div><!-- end of count 2==0 -->\n\n\n";  
                    } 
                } //end iof stack or horizontal
     
     
     
     
            }else{
                //echo '<h1>aadsdsds</h1>';
                   // $title_new="$p[post_title]";
                    $item_list .= "\n";
                    if (in_array($cur_view, array( 'td'), true)) {
                        $item_list .=
                            /*"<span class=\"cs_pr_title_link\" onclick=\"window.open('$p[target_url]')\">"
                            . "$p[post_title]</span><br />\n"*/
                            "$p[post_title]<br />\n"
                            . "$p[post_content]<br />\n"
                            . "<hr />\n";
                    } else {
                       //echo  $p['review_desc'] ;
                        
                        if ((($row_count % $column_limit==1) || ($row_count==1))   ) {
                           $item_list .="<div class=\"cs_row\">\n\n";
                        }
                         
                                $item_list .=cs_product_box("",$p['post_title'],$p['post_content']);        
         
                       if ($row_count % $column_limit ==0) {
                             $item_list .=cs_product_box("dummy",$p['post_title'],$p['post_content']); 
                            $item_list .="</div>\n<!-- end of row -->\n\n";
                       }
                    }
            }//end of section reviews
        }
       
       
    }
    
    
    //related reviews show
    if (strlen($_GET['cs_review_id'])>10) {
        //$p_data = cs_get_items('review-details', $user_id, $criteria,2,        1, false);
        //VAR_DUMP($p_data['posts'][0]['post_title']);
        //print_r($p_data);
            cs_show_external_reviews($p_data['posts'][0]['post_title'], $p_data['posts'][0]['urls']);
            cs_show_related_reviews($user_id, $criteria);
    } //end if related reviews
    
    
    
    
    if (in_array($cur_view, array('tdli','tdi', 'ti'), true)) {
       // $item_list .= "<br /><br />\n";
    }
    
    $cs = '';
    
    if (in_array($section, array('category', 'search'), true)) {
        $cs .= cs_show_paging($section, $user_id, $criteria,
            $p_data['totalp'], $_SESSION['cs_items_per_page'], $get_mcat, $get_scat, $page);
    } elseif (in_array($section, array('review-details'), true)){
      $cs .= cs_show_paging($section, $user_id, $criteria,
            $p_data['totalp'], $_SESSION['cs_items_per_page'], $get_mcat, $get_scat, $page);
    }
   // $cs .= "<hr />\n";
    
    $list_center_align =
        in_array($section, array('category', 'search'), true)
        && in_array($_SESSION['cs_switch_view'], array('ti', 'tdi'), true)
        || !in_array($section, array('category', 'search'), true)
        && in_array($_SESSION['cs_view_other'], array('ti', 'tdi'), true);
    if ($list_center_align) {
        $cs .= "<div style=\"text-align: center\">\n";
    }
    if (in_array($section, array('category', 'search'), true)
        && !empty($p_data['posts']))
    {
        $cur_sortby = (isset($_SESSION['cs_sortby']) ? $_SESSION['cs_sortby'] : 'rank');
       
        
        // Sort criteria
        if ($section === 'category') {
            $cs .= "<div style=\"text-align: right\">";
               // . "<strong>Sort</strong> ";
            $sortby_vals = array(
                'rank' => 'By Higher Rank',
                'gravity' => 'By Higher Gravity');
            if ($_SESSION['cs_show_price'] == '1') {
                $sortby_vals['price_h'] = 'High to Low Price';
                $sortby_vals['price_l'] = 'Low to High Price';
            } elseif (
                isset($_SESSION['cs_sortby'])
                && in_array($_SESSION['cs_sortby'], array('price_h', 'price_l'), true))
            {
                $_SESSION['cs_sortby'] = 'rank';
            }
            $cs .= "<select id=\"cs_sotrby\" "
                . "onchange=\"cs_show_page('$section', '$user_id', '$criteria', "
                . "1, this.value, '$cur_view', '$get_mcat' , '$get_mcat')\" "
                . "style=\"width: 11em\">\n";
            foreach ($sortby_vals as $val => $text) {
                $cs .= "<option value=\"$val\"";
                if ($val === $cur_sortby) $cs .= " selected=\"selected\"";
                $cs .= ">$text</option>\n";
            }
            $cs .= "</select>\n"
                . "</div>\n";
        }
         $cs .= "<br /><br />\n";
    }
    
    $cs .= $item_list;
    if ($list_center_align) {
        $cs .= "</div>\n";
    }
    if (in_array($section, array('category', 'search'), true)) {
        $cs .= cs_show_paging($section, $user_id, $criteria,
            $p_data['totalp'], $_SESSION['cs_items_per_page'], $get_mcat, $get_scat, $page);
    } elseif (in_array($section, array('review-details'), true)){
       
      $cs .= cs_show_paging($section, $user_id, $criteria,
            $p_data['totalp'], $_SESSION['cs_items_per_page'], $get_mcat, $get_scat , $page);
    } elseif (in_array($section, array('reviews'), true)) {
    
    } else {
        $cs .= "<br />\n";
    }
    
    return array('output' => $cs, 'totalp' => $p_data['totalp']);
}

/**
* Return HTML product list to insert into post / page / etc
* 
* @param string $section
* @param string $criteria
* @param string $title
* @param int $product_number
*/
function cs_show_filter_contents($section, $criteria, $title, $product_number = null)
{
   

    $product_list = cs_show($section, $_SESSION['cs_user_id'], $criteria,
        1, $_GET['cs_mcat'],$_GET['cs_scat'],$product_number);
       
    cs_get_css_js($product_list['totalp'], $_SESSION['cs_items_per_page']);
    
    $_SESSION['cs_cur_url'] = get_permalink();
    $_SESSION['cs_site_url'] = site_url();
    if (false === $_SESSION['cs_cur_url']) $_SESSION['cs_cur_url'] = $_SESSION['cs_site_url'];
    if ($section === 'category') {
        $_SESSION['cs_cur_url'] = cs_get_url($_SESSION['cs_cur_url'], array('cs_category' => $criteria));
    } elseif ($section === 'search') {
        $_SESSION['cs_cur_url'] = cs_get_url($_SESSION['cs_cur_url'], array('cs_keywords' => $criteria));
    }
    $_SESSION['cs_cur_url'] = htmlspecialchars($_SESSION['cs_cur_url'], ENT_QUOTES);
    $pad_color=(strlen($_SESSION['cs_primary_color'])>2 ? $_SESSION['cs_primary_color']: '#808080');



    
   if (($section==="bestselling") || ($section==="featured") || ($section==="popular") || ($section==="reviews") ){
        //  $margin_writeup="margin-top:70px;";
          
          if ($section==="bestselling") {
             $tt='<div class="cs_row_banners" >'.
                        '<div class="cs_row_banner_column_1">'.
                        '<a  href="'.str_replace("?cs_category=","",cs_get_products_page('cs_category', '')).'?cs_keywords=forex"><img src="https://cbproads.com/clickbankstorefront/v5/assets/images/Onlinemarketing.png" class="img-responsive"></a></div>'.
                  '</div>';
          }
          if ($section==="popular") {
               $tt='<div class="cs_row_banners" >'.
                        '<div class="cs_row_banner_column_1" >'.
                        '<a href="'.str_replace("?cs_category=","",cs_get_products_page('cs_category', '')).'?cs_keywords=make money online">'.
                            '<img src="https://cbproads.com/clickbankstorefront/v5/assets/images/forex.jpg" class="img-responsive">'.
                        '</a></div>'.
                  '</div>';
                
          }
          
           if ($section==="featured") {
               $tt='<div class="cs_row_banners" >'.
                        //'<div class="cs_row_banner_column_1" >'.
                        //'<a href="'.str_replace("?cs_category=","",cs_get_products_page('cs_category', '')).'?cs_keywords=make money online">'.
                        //    '<img src="https://cbproads.com/clickbankstorefront/v5/assets/images/forex.jpg" class="img-responsive">'.
                        //'</a></div>'.
                  '</div>';
                
          }
          if ($section==="reviews") {
              $tt='<div style="margin-top:45px; ">'.cs_display_title("Popular Categories",$pad_color,"").'</div><div class="cs_row_banners"  >'.
                        
                        '<div class="cs_row_banner_column_3">'.
                            '<a href="'.str_replace("?cs_category=","",cs_get_products_page('cs_category', '')).'?cs_keywords=fat+loss">'.
                            '<img src="https://cbproads.com/clickbankstorefront/v5/assets/images/WeightLoss.png" class="img-responsive"></a>'.
                        '</div>'.
                        
                        '<div class="cs_row_banner_column_3">'.
                            '<a href="'.str_replace("","",cs_get_products_page('cs_category', '')).'116">'.
                            '<img src="https://cbproads.com/clickbankstorefront/v5/assets/images/HomeImprovments.png" class="img-responsive"></a>'.
                        '</div>'.
                        
                        '<div class="cs_row_banner_column_3">'.
                            '<a href="'.str_replace("","",cs_get_products_page('cs_category', '')).'110">'.
                            '<img src="https://cbproads.com/clickbankstorefront/v5/assets/images/PetCare.jpg" class="img-responsive"></a>'.
                        '</div>'.

                  '</div>';
          }
          
     }
 
   if($section != 'review-single'){
    
        
                            
       $review_writeup.= cs_display_title($title,$pad_color,$section);
        //$review_writeup.=$tt.'';
   
		if ($title==="do_not_show_title"){
		    $review_writeup="";
		}
   }
    $res = <<<HD
   
$review_writeup


   

<div id="cs_loading_label" style="display: none; position: fixed; text-align: center">
  <h1 style="font-weight: bold">
    Loading the page...
  </h1>
</div>\n
HD;

    //$product_list[output]="";
        
    $res .= "<div id=\"cs_product_list\" style=\" background:".(strlen($_SESSION['cs_secondary_color'])>2?$_SESSION["cs_secondary_color"]:'#F0F0F0')."; \">\n"
        . "$product_list[output]\n";
            if ($section === 'reviews') {
                //$res .= '<br>';
                //$res .= "<div align='right' style='padding:10px;background:#f5f5f5;font-size:1.1em;letter-spacing: 0.07em;'><a href='".cs_get_review_page('', '')."'>&#8811;View More Product Reviews</a>&nbsp;&nbsp;&nbsp;</div><br \><br \>";
            }
    $res .= "</div>\n".$tt;
   
    if ($section==="review-single"){$res ='';}
    return $res;
}

/**
* Return HTML product list to insert into post / page / etc
* 
* @param array $attrs
* @return string
*/
function cs_show_filter($attrs = array())
{
    
    if (isset($_GET['cs_section'])) {
        $section = $_GET['cs_section'];
        $product_list_criteria = $title = '';
    } elseif (isset($_GET['cs_category'])) {
        $section = 'category';
        $selected_cat = $_GET['cs_category'];
        $category = cs_get_categories($selected_cat);
        //$category = cs_get_categories('247');
       // print_r($category);
        $category = $category['selected_name'];
        $title = "Category: $category";
        $product_list_criteria = $selected_cat;
    } elseif (isset($_GET['cs_keywords'])) {
        $section = 'search';
        $product_list_criteria = $_GET['cs_keywords'];
        $title = "Search Results for \"".htmlspecialchars($product_list_criteria)."\"";
    } elseif (isset($_GET['cs_review_id'])) {
        $section = 'review-single';
    }else{
        $section = 'review-details';
       // $product_list_criteria = $_GET['cs_review_id'];
        if ( (isset($_GET['cs_mcat']))  &&  (isset($_GET['cs_scat']))    ){
            $selected_cat = $_GET['cs_scat'];
            $category = cs_get_categories(11);
            //print_r($category);
            $category = $category['selected_name'];
           // echo 'fff'.$selected_cat;
            $title = "Product Reviews for Sub Category ".htmlspecialchars($category);
            
                $title = "do_not_show_title";
           
        }elseif (isset($_GET['cs_mcat']) || (strlen($_SESSION['cs_reviews_show_cats'])>5 )    ) {
             //echo 'aaa'.$selected_cat;
             $t_cat="";
             
             if (strlen($_SESSION['cs_reviews_show_cats'])>5 ){
                $t_cat=trim(substr ( $_SESSION['cs_reviews_show_cats'],     strpos($_SESSION['cs_reviews_show_cats'],">") +1      ));
             $title= ($t_cat);
             }else{
                     if (    isset($_GET['cs_mcat_name']) && (strlen($_GET['cs_mcat_name'])>5) ){
                        $title = "Category: ".($_GET['cs_mcat_name']);
                    }else{
                        $title = "do_not_show_title";
                    }
             }
             
        }else{
             $title = "ClickBank Product Reviews";
             $title = "do_not_show_title";
        }
        
    }

    
    return cs_show_filter_contents($section, $product_list_criteria, $title);
}


function cs_show_intro(){
    
    
    if( ($_SESSION['cs_home_banner'] == '1') ){
           $banner_home= "<div align='center' style='margin:0px; margin-top:3px; margin-bottom:30px;'><img src='https://cbproads.com/clickbankstorefront/v5/assets/images/slider-wp.png' class='img-responsive' ></div>";
    }    
    return  $banner_home."<div style='text-align:center; padding:0px;'><h2>Browse To<br> Your Hearts Content <br>At Our Full Range Of Products</h2></div>".
        "<div style=' backgrounds:#f3f3f3; margin-top:30px; margin-bottom:50px; '><p style='font-size:1.1em; letter-spacing: inherit; '>Welcome to the world's largest online marketplace for digital information products. ".
        "With over 10,000 information products to choose from, you are sure to find the information that you need! There are books, software and other products on every subject.".
        "</p><!--<p style='font-size:1.1em; letter-spacing: inherit; margin-bottom:0px;'>We hope the store will help you choose the right product you are looking for.</p>--></div>"        ;
     
                        //$review_writeup.= 
                        "<div style='display:flex; justify-content: space-between;  margin-top:40px; margin-bottom:70px; '>".
                    	    
                    	    "<div style='display: flex;    width:30%; border-right:0px solid #dcdcdc;'>".
                        	
                        		"<img src='https://cbproads.com/clickbankstorefront/v5/assets/images/s1.jpg' alt=''>".
                        		
                        		"<h5 class='name'>IMMEDIATE ACCESS</h5>".
                        		"<span class='desc' style='font-size:0.8em; line-height:0.7em;'>Instantly download the products just after the payment.</span>".
                        	
                        	"</div>".
                        	
                        	
                        	"<div style='display: flex;   width:30%; border-right:0px solid #dcdcdc;'>".
                        	    
                        		"<img src='https://cbproads.com/clickbankstorefront/v5/assets/images/s2.jpg' alt=''>".
                        	
                        		"<h5 class='name'>60 DAY REFUND</h5>".
                        	
                        		"<span class='desc' style='font-size:0.8em; line-height:0.7em;'>Hassle free refunds in 60 day period. No questions asked!</span>".
                        		
                        	
                        	"</div>".
                        	
                        	
                        	
                        	
                        	"<div style='display: flex; width:30%;'>".
                        	  
                        		"<img src='https://cbproads.com/clickbankstorefront/v5/assets/images/s3.jpg' alt=''>".
                        
                        		"<h5 class='name'>SAFE SHOPPING</h5>".
                        		"<span class='desc' style='font-size:0.8em; line-height:0.7em;'>ClickBank is the payment processer between you and the product vendor.</span>".
                        		
                        	"</div>".
                        "</div>";    
     
}
/**
* Return BestSelling Products
* 
* @param array $attrs
* @return string
*/
function cs_show_bestselling($attrs = array())
{
   
    return cs_show_filter_contents('bestselling', '', 'Trending Products', $_SESSION['cs_bestselling_num']);
}

/**
* Return Featured Products
* 
* @param array $attrs
* @return string
*/
function cs_show_featured($attrs = array())
{
    if ($_SESSION['cs_featured_ids'] == '') {
     //   return '';
    }
    
    return cs_show_filter_contents(
        'featured',
        trim($_SESSION['cs_featured_ids']),
        'Featured Products',
        $_SESSION['cs_featured_num']);
}

/**
* Return Popular Products
* 
* @param array $attrs
* @return string
*/
function cs_show_popular($attrs = array())
{
   
     return cs_show_filter_contents('popular', '', 'Top Rated Products', $_SESSION['cs_popular_num']);
}


function cs_show_reviews($attrs = array())
{
   
     return cs_show_filter_contents('reviews', '', 'Best Product Reviews', $_SESSION['cs_items_per_page']);
}





/**
* Return CSS style code for pagination buttons
* 
* @return string
*/
function cs_show_paging_css()
{
    wp_register_style('cs_paging', $_SESSION['cs_plugin_url'].'/paging.css');
    wp_enqueue_style('cs_paging');
}

/**
* Return HTML code for pagination buttons
* 
* @param string $section
* @param int $user_id
* @param string $criteria
* @param int $totalp
* @param int $items_per_page
* @param int $page
*/
function cs_show_paging($section, $user_id, $criteria, $totalp, $items_per_page, $mcat, $scat, $page = 1)
{
    if ($totalp <= $items_per_page) {
        $html = '&nbsp;';
    } else {
        $totalp = (int)ceil($totalp / $items_per_page);
        $pages_to_show = array();
        if ($totalp < 3) $loop_end = $totalp+1;
        else $loop_end = 4;
        for ($i = 1; $i < $loop_end; $i++) $pages_to_show[$i] = true;
        $loop_end = $totalp-3;
        if ($loop_end < 0) $loop_end = 0;
        for ($i = $totalp; $i > $loop_end; $i--) $pages_to_show[$i] = true;
        if ($page > 2 && $page < $totalp-1) {
            for ($i = $page-1; $i < $page+2; $i++) {
                $pages_to_show[$i] = true;
            }
        }
        ksort($pages_to_show);
        
        $cur_sortby = (isset($_SESSION['cs_sortby']) ? $_SESSION['cs_sortby'] : 'rank');
        $cur_view = (in_array($section, array('category', 'search'), true)
            ? $_SESSION['cs_switch_view']
            : $_SESSION['cs_view_other']);
        
        $html = '';
        $prev_i = 0;
        foreach (array_keys($pages_to_show) as $i) {
            if ($i - $prev_i > 1) $html .= '... ';
            
            $html .= "<span class=\"cs_page_button";
            if ($page == $i) $html .= " cs_page_button_selected";
            $html .= "\" onclick=\"cs_show_page('$section', '$user_id', '$criteria', $i, "
                . "'$cur_sortby', '$cur_view', '$mcat', '$scat'); return false\">";
            if ($page != $i) {
                $html .= "<a href=\"javascript:#\" >";
            }
            $html .= $i;
            if ($page != $i) $html .= "</a>";
            $html .= "</span> ";
            
            $prev_i = $i;
        }
    }
    
        if (strlen($html)>10 ) {
           //  return "<br />\n"
           // . "<br />\n"
            return "<div style=\"margin-bottom:15px; margin-right:10px; text-align: right\">$html</div>";
        }else{
            return '';
        }
    
    
   
}



?>