<?php
function pp($input){
	echo '<pre>';
	print_r($input);
	echo '</pre>';
}
global $vasq_options;
if ( !class_exists( 'ReduxFramework' ) && file_exists( dirname( __FILE__ ) . '/ReduxFramework/ReduxCore/framework.php' ) ) {
    require_once( dirname( __FILE__ ) . '/ReduxFramework/ReduxCore/framework.php' );
}
require_once (dirname(__FILE__) . '/inc/vasq-config.php');
require_once (dirname(__FILE__) . '/libs/aq_resizer.php');
require_once (dirname(__FILE__) . '/libs/sideload.php');
require_once (dirname(__FILE__) . '/functions/cssjs.php');
require_once (dirname(__FILE__) . '/functions/menu-fallback.php');
require_once (dirname(__FILE__) . '/functions/comment.php');
require_once (dirname(__FILE__) . '/functions/metabox.php');
require_once (dirname(__FILE__) . '/functions/widget.php');
require_once (dirname(__FILE__) . '/functions/breadcrumbs.php');
require_once (dirname(__FILE__) . '/functions/post_view.php');
require_once (dirname(__FILE__) . '/functions/vq-like-dislike.php');
require_once (dirname(__FILE__) . '/functions/sorting.php');
require_once (dirname(__FILE__) . '/functions/contact/vq_contact.php');
require_once (dirname(__FILE__) . '/functions/custom_style.php');
require_once (dirname(__FILE__) . '/plugins/vasq_lightbox/vasq_lightbox.php');
require_once (dirname(__FILE__) . '/functions/check_duplicate_video.php');

load_theme_textdomain('vasq', get_template_directory() . '/languages');
load_theme_textdomain('redux-framework', get_template_directory() . '/ReduxFramework/ReduxCore/languages');

function _filter_wp_title_vasq_title( $title, $sep ) {
	global $paged, $page;

	if ( is_feed() )
		return $title;

	// Add the site name.
	$title .= get_bloginfo( 'name' );

	// Add the site description for the home/front page.
	$site_description = get_bloginfo( 'description', 'display' );
	if ( $site_description && ( is_home() || is_front_page() ) )
		$title = "$title $sep $site_description";

	// Add a page number if necessary.
	if ( $paged >= 2 || $page >= 2 )
		$title = "$title $sep " . sprintf( __( 'Page %s', 'vasq' ), max( $paged, $page ) );

	return $title;
}
//add_filter( 'wp_title', '_filter_wp_title_vasq_title', 10, 2 );




function vq_excerpt_length( $length ) {
	return 100;
}
add_filter( 'excerpt_length', 'vq_excerpt_length', 999 );
/** RTL LAYOUT FUNCTION **/
function vasq_rtl_class($class){
	global $vasq_options;
	if($vasq_options['use-rtl']){
		return $class;
	}
	return;
}
/** GET lAYOUT SETTING CLASS **/
function vasq_get_layout_setting_class($opt){
	global $vasq_options;
	
	$class ='';
	$opt = ($opt == '') ? 'full-width': $opt;
	switch($opt){
		case 'boxed' :
			$class = 'boxed';
			break;
		case 'frame' :
			$class = 'boxed framed';
			break;
		case 'full-width' :
			$class = 'full-width';
			break;
		case 'rounded' :
			$class = 'boxed framed rounded';
			break;
	}
	$class = ($vasq_options['use-rtl']) ? $class .' rtl': $class;
	return $class;
}

function vasq_get_attachment($attachment_id){
	$attachment = get_post( $attachment_id );
	return array(
		'alt' => get_post_meta( $attachment->ID, '_wp_attachment_image_alt', true ),
		'caption' => $attachment->post_excerpt,
		'description' => $attachment->post_content,
		'href' => get_permalink( $attachment->ID ),
		'src' => $attachment->guid,
		'title' => $attachment->post_title
	);
}	

function vasqRegisterMenu()
{
        register_nav_menu('mainmenu','Main Menu');
        register_nav_menu('footer-menu','Footer Menu');
}


add_action('after_setup_theme','vasqRegisterMenu');

if ( function_exists( 'add_theme_support' ) ) { 
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'custom-header' );
	add_theme_support( 'custom-background' );
	add_theme_support(   'automatic-feed-links' );
	add_theme_support(   'title-tag' );
	set_post_thumbnail_size( 300, 300);
}
if ( ! isset( $content_width ) ) {
	$content_width = 600;
}
function vq_postmeta(){
	if(is_singular('post') && !is_admin()):
		global $post;
		$id = get_the_ID();
		$img = '';
		$thumb = get_post_thumbnail_id($id);
		if($thumb == ''){
			$img_url = get_post_meta($post->ID,'video_banner',true);
			$img =  aq_resize( $img_url, 860, 510, true,true,true ); //resize & crop img
			if($img == ''){
				$img = aq_resize(  vasqGetExportAttachment($post->ID), 860, 510, true,true,true ); //resize & crop img
			}
		}else{
			$img_url = wp_get_attachment_url( $thumb,'full'); //get img URL
			$img = aq_resize( $img_url, 860, 510, true,true,true ); //resize & crop img
		}
		$content = get_post($id);
		$content = $content->post_content;
	?>
		<meta name="title" content="<?php echo get_the_title($id);?>" >
		<meta name="description" content="<?php   echo  apply_filters('the_content ', wp_trim_words( $content, 30,'&hellip;'))  ; ?>">
		<link rel="image_src" href="<?php echo $img;?>" >
	<?php
	else:
		 global $vasq_options;
		 $logo_img = $vasq_options['logo-img'];
	?>
	<meta name="title" content="<?php bloginfo('name');?>" >
	<meta name="description" content="<?php bloginfo('description');?>">
	<link rel="image_src" href="<?php echo $logo_img['url'];?>" >
	<?php
	endif;
}

function vasq_footer_script(){
	global $vasq_options;
	echo $vasq_options['vasq-footer-script'];
}
add_action('wp_footer','vasq_footer_script',9999);

function vasq_head_script(){
	global $vasq_options;
	echo $vasq_options['vasq-header-script'];
}
add_action('wp_head','vasq_head_script',9999);

function vasq_register_sidebar(){
	$args = array();
	$args['main']	= array(
		'name' 			=> 'Main',
		'id'					=> 'sidebar',
		'before_widget'	=> '<div id="%1$s" class="widget %2$s">',
		'after_widget'		=> '</div>',
		'before_title'		=> '<h3 class="widget-title">',
		'after_title'		=> '</h3>', 
	);
	
	$args['single-page']				= $args['main'];	
	$args['single-page']['name']		= 'Single Page';
	$args['single-page']['id']			= 'single-page';
	
	
	$args['category-page']			= $args['main'];	
	$args['category-page']['name']	= 'Category Page';
	$args['category-page']['id']		= 'category-page';	
	
	$args['404-page']					= $args['main'];	
	$args['404-page']['name']			= '404 Page';
	$args['404-page']['id']				= '404-page';
	
	$args['search-page']				= $args['main'];	
	$args['search-page']['name']		= 'Search Result';
	$args['search-page']['id']			= 'search-page';
	
	$args['footer-1']				= $args['main'];	
	$args['footer-1']['name']		= 'Footer 1';
	$args['footer-1']['id']			= 'footer-1';
	
	$args['footer-2']				= $args['main'];	
	$args['footer-2']['name']		= 'Footer 2';
	$args['footer-2']['id']			= 'footer-2';	
	
	$args['footer-3']				= $args['main'];	
	$args['footer-3']['name']		= 'Footer 3';
	$args['footer-3']['id']			= 'footer-3';
	
	$args['footer-4']				= $args['main'];	
	$args['footer-4']['name']		= 'Footer 4';
	$args['footer-4']['id']			= 'footer-4';
	

	foreach($args as $arg)register_sidebar($arg);
}
add_action('widgets_init','vasq_register_sidebar');

//fix search result pagination
function _action_template_redirect_vasq_search_redirect() {
	global $wp_rewrite;
	if ( !isset( $wp_rewrite ) || !is_object( $wp_rewrite ) || !$wp_rewrite->using_permalinks() )
		return;

	$search_base = $wp_rewrite->search_base;
	if ( is_search() && !is_admin() && strpos( $_SERVER['REQUEST_URI'], "/{$search_base}/" ) === false ) {
		wp_redirect( home_url( "/{$search_base}/" . urlencode( get_query_var( 's' ) ) ) );
		exit();
	}
}
add_action( 'template_redirect', '_action_template_redirect_vasq_search_redirect' );

function vasq_search_filter($query) {
	if ($query->is_search && !is_admin()) {
		$query->set('post_type', 'post');
	}
	return $query;
}
add_filter('pre_get_posts','vasq_search_filter');

function _remove_query_strings_1( $src ){	
	$rqs = explode( '?ver', $src );
        return $rqs[0];
}
if ( is_admin() ) {
// Remove query strings from static resources disabled in admin
}
else {
	add_filter( 'script_loader_src', '_remove_query_strings_1', 15, 1 );
	add_filter( 'style_loader_src', '_remove_query_strings_1', 15, 1 );
}
function _remove_query_strings_2( $src ){
	$rqs = explode( '&ver', $src );
        return $rqs[0];
}
if ( is_admin() ) {
// Remove query strings from static resources disabled in admin
}
else {
	add_filter( 'script_loader_src', '_remove_query_strings_2', 15, 1 );
	add_filter( 'style_loader_src', '_remove_query_strings_2', 15, 1 );
}
//to add defer to loading of scripts - use defer to keep loading order
function script_tag_defer($tag, $handle) {
    if (is_admin()){
        return $tag;
    }
    if (strpos($tag, '/wp-includes/js/jquery/jquery')) {
        return $tag;
    }
     if (strpos($tag, '/elegant-tubepress/assets/js/video')) {
        return $tag;
    }
    if (strpos($tag, '/elegant-tubepress/assets/js/media')) {
        return $tag;
    }
     if (strpos($tag, '/eleganttubepress/assets/js/video')) {
        return $tag;
    }
    if (strpos($tag, '/eleganttubepress/assets/js/media')) {
        return $tag;
    }
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 9.') !==false) {
    return $tag;
    }
    else {
        return str_replace(' src',' defer="defer" src', $tag);
    }
}
add_filter('script_loader_tag', 'script_tag_defer',10,2);

function vasq_content($count) {
	global $post;
	$permalink = get_permalink($post->ID);
	$excerpt = get_the_content();
	$excerpt = strip_tags($excerpt);
	$excerpt = substr($excerpt, 0, $count);
	$excerpt = $excerpt.' ...';
	return $excerpt;
}
/** FILTERING IN LIST POST **/
add_filter('manage_post_posts_columns', 'vq_util_head');
function vq_util_head( $defaults ) {
	$defaults['vq_post_views_count']  = 'View';
	$defaults['likes']    = 'Like';
	$defaults['dislike']   = 'Dislike';
	return $defaults;
}
add_action( 'manage_post_posts_custom_column', 'vq_util_content', 10, 2 );

function vq_util_content( $column_name, $post_id ) {
	if ($column_name == 'vq_post_views_count') {
	    echo get_post_meta( $post_id, 'vq_post_views_count', true );
	}
	if ($column_name == 'likes') {
	    echo get_post_meta( $post_id, 'likes', true );
	}
	if ($column_name == 'dislike') {
	    echo get_post_meta( $post_id, 'dislike', true );
	}
}

add_filter( 'manage_edit-post_sortable_columns', 'vq_table_sorting' );
function vq_table_sorting( $columns ) {
	$columns['vq_post_views_count'] = 'vq_post_views_count';
       $columns['likes'] = 'likes';
       $columns['dislike'] = 'dislike';
 
  return $columns;
}

add_filter( 'request', 'vq_vq_post_views_count_column_orderby' );
function vq_vq_post_views_count_column_orderby( $vars ) {
	if ( isset( $vars['orderby'] ) && 'vq_post_views_count' == $vars['orderby'] ) {
	    $vars = array_merge( $vars, array(
		'meta_key' => 'vq_post_views_count',
		'orderby' => 'meta_value_num'
	    ) );
	}
    return $vars;
}

add_filter( 'request', 'vq_likes_column_orderby' );
function vq_likes_column_orderby( $vars ) {
	if ( isset( $vars['orderby'] ) && 'likes' == $vars['orderby'] ) {
	       $vars = array_merge( $vars, array(
		   'meta_key' => 'likes',
		   'orderby' => 'meta_value_num'
	       ) );
       }
    return $vars;
}

add_filter( 'request', 'vq_dislike_column_orderby' );
function vq_dislike_column_orderby( $vars ) {
	if ( isset( $vars['orderby'] ) && 'dislike' == $vars['orderby'] ) {
	       $vars = array_merge( $vars, array(
		   'meta_key' => 'dislike',
		   'orderby' => 'meta_value_num'
	       ) );
	   }
    return $vars;
}

function vasqGetExportAttachment($postid){
	$img = '';
	$args = array(
		'post_type' => 'attachment',
		'numberposts' => 1,
		'post_status' => null,
		'post_parent' => $postid,
       );
	$attachments = get_posts( $args );
	if(!empty($attachments)){
		$img = wp_get_attachment_url($attachments[0]->ID, 'full');
	}
	return $img;
}
function generate_optin( $atts ) {
	global $vasq_options;
	$style = 'style="margin:10px auto;display:block;float:none;"';
	if($atts != '' && !empty($atts)){
	    $align = $atts['align'];
	    switch($align){
		case 'left' :
		    $style = 'style="margin:10px 15px 10px 0;display:inline-block;float:left;"';
		    break;
		case 'right' :
		    $style = 'style="margin:10px 0 10px 15px;display:inline-block;float:right;"';
		    break;
		case 'center' :
		    $style = $style;
		    break;
	    }
	}
	$name = $vasq_options['optin-form-name'];
	$email = $vasq_options['optin-form-email'];
	$action = $vasq_options['optin-form-action'];
	$hidden = $vasq_options['optin-form-hidden'];
	
	ob_start();
	?>
	<style type="text/css">.vasq-optin form br{display: none;}</style>
	<div class="form-basic vasq-optin" <?php echo $style;?>>
		<form method="post" target="_blank" action="<?php echo $action;?>">
			<?php if(!empty($name) && $name != ''):?>
				<input required="required" type="text" value="" placeholder="<?php _e('Name','vasq');?>" name="<?php echo $name;?>" />
			<?php endif;?>
			<?php if(!empty($email) && $email != ''):?>
				<input data-email="<?php echo $email;?>" required="required" type="email" value="" placeholder="<?php _e('Email','vasq');?>" name="<?php echo $email;?>" />
			<?php endif;?>
			<?php if(!empty($hidden) && $hidden != ''): echo $hidden; endif;?>
			<input type="submit" value="<?php _e('Submit','vasq');?>" class="vqtheme-btn">
		</form>
	</div>
	<?php
	$output = ob_get_contents();
	ob_end_clean();
	
	return $output;
	
}
add_shortcode( 'optin', 'generate_optin' );

function addBottomOptin(){
	global $vasq_options;
	if($vasq_options['use-slidein-optin'] == 1 && $vasq_options['optin-form-code'] != ''){
		$title = $vasq_options['slidein-optin-title'];
		?>
			<div class="vqtheme-optin-holder">
				<span class="cls"><i class="fa fa-close"></i></span>
				<?php if($title != ''):?>
					<h3 class="title"><?php echo $title;?></h3>
				<?php endif;?>
				<?php echo do_shortcode('[optin]');?>
			</div><!-- end of vqtheme optin holder -->
		<?php
	}
}

add_action('wp_footer','addBottomOptin');

function vasq_get_cta($post_id){
	global $vasq_options;
	$content = '';
	$video_cta = get_post_meta($post_id,'video_cta', true);
	if($vasq_options['use-cta'] == 1 && $vasq_options['cta-default'] != ''){
		$video_cta = ($video_cta == '') ? $vasq_options['cta-default'] : $video_cta;
	}
	if($video_cta != 'none' && $video_cta != ''):
		ob_start();
		$cta = $vasq_options['cta-button'];
		$cta = $cta[$video_cta];
		if($cta['description'] != '' && $cta['url'] != ''):
			?>
				<div class="cta-holder">
					<a href="<?php echo $cta['url'];?>" target="_blank" class="button"><?php echo $cta['description'];?></a>
				</div><!-- end of cta holder -->
			<?php
		endif;
		$content = ob_get_contents();
		ob_end_clean();
	endif;
	return $content;
}


function vasq_theme_updater() {
	require_once( get_template_directory() . '/updater/theme-updater.php' );
}
add_action( 'after_setup_theme', 'vasq_theme_updater' );