<?php

/**
 *
 * REGISTER STYLE AND SCRIPT
 *
 * @package WordPress
 * @subpackage Vasq
 * @since Vasq 1.0.0
 *
 * */

if( ! class_exists('vasqCSSJS')){
	class vasqCSSJS {
		public function vasqCSSJS(){
			add_action('wp_enqueue_scripts'		,array(&$this,'_action_vasq_register_script'));
			add_action('wp_enqueue_scripts'		,array(&$this,'_action_vasq_register_style'));
			add_action( 'admin_enqueue_scripts'	,array(&$this,'_action_vasq_register_admin_style') );
			add_action( 'admin_enqueue_scripts'	,array(&$this,'_action_vasq_register_admin_script'),99999 );
		}
		
		public function  _action_vasq_register_style(){
			global $vasq_options;
			
			//wp_register_style('bootstrap',get_template_directory_uri().'/assets/css/bootstrap.min.css');      
			//wp_register_style('reset',get_template_directory_uri().'/assets/css/reset.css');
			//wp_register_style('superfish',get_template_directory_uri().'/assets/css/jquery.superfish.css');
			//wp_register_style('font-awesome',get_template_directory_uri().'/assets/css/font-awesome.min.css');
			//wp_register_style('slicknav',get_template_directory_uri().'/assets/css/slicknav.css');
			//wp_register_style('video',get_template_directory_uri().'/assets/css/videojs.css');
			//wp_register_style('post-comment',get_template_directory_uri().'/assets/css/post-comment.css');
			//wp_register_style('slick',get_template_directory_uri().'/assets/css/slick.css');
			//wp_register_style('scrollbar',get_template_directory_uri().'/assets/css/perfect-scrollbar.min.css');
			wp_register_style('libs',get_template_directory_uri().'/assets/css/libs.css');
			wp_register_style('style',get_template_directory_uri().'/assets/css/style.css');
			
			//wp_enqueue_style('bootstrap');
			//wp_enqueue_style('reset');
			//wp_enqueue_style('superfish');
			//wp_enqueue_style('font-awesome');
			//wp_enqueue_style('slicknav');
			//wp_enqueue_style('slick');
			//wp_enqueue_style('post-comment');
			wp_enqueue_style('libs');
			
			
			if(is_singular('post')){
				wp_enqueue_style('scrollbar',get_template_directory_uri().'/assets/css/perfect-scrollbar.min.css',array('libs'));
				wp_enqueue_style('video',get_template_directory_uri().'/assets/css/videojs.css',array('libs'));
			}
			
			wp_enqueue_style('style');
			
			if($vasq_options['use-rtl']){
				wp_register_style('rtl',get_template_directory_uri().'/assets/css/rtl.css');
				wp_enqueue_style('rtl');
			}
			wp_deregister_style( 'open-sans' );
			wp_register_style( 'open-sans', false );
		}
		
		public function _action_vasq_register_admin_style(){
			wp_register_style('admin',get_template_directory_uri().'/assets/css/admin.css');
			wp_enqueue_style('admin');
		}
		
		
		public function  _action_vasq_register_script(){
			global $vasq_options;
			wp_register_script('bootstrap',get_template_directory_uri().'/assets/js/bootstrap.min.js',array('jquery'),NULL,true);
			wp_register_script('superfish',get_template_directory_uri().'/assets/js/jquery.superfish.js',array('jquery'),NULL,true);
			wp_register_script('waypoint',get_template_directory_uri().'/assets/js/waypoint.js',array('jquery'),NULL,true);
			wp_register_script('waypoint-sticky',get_template_directory_uri().'/assets/js/waypoint.sticky.js',array('jquery'),NULL,true);
			wp_register_script('slicknav',get_template_directory_uri().'/assets/js/jquery.slicknav.min.js',array('jquery'),NULL,true);
			wp_register_script('cookie',get_template_directory_uri().'/assets/js/jquery.cookie.js',array('jquery'),NULL,true);
			wp_register_script('slick',get_template_directory_uri().'/assets/js/slick.js',array('jquery'),NULL,true);
			wp_register_script('video',get_template_directory_uri().'/assets/js/video.js',array('jquery'),NULL,true);
			wp_register_script('media',get_template_directory_uri().'/assets/js/media.js',array('jquery'),NULL,true);
			wp_register_script('scrollbar',get_template_directory_uri().'/assets/js/scrollbar.js',array('jquery'),NULL,true);
			wp_register_script('wookmark',get_template_directory_uri().'/assets/js/wookmark.min.js',array('jquery'),NULL,true);
			wp_register_script('scripts',get_template_directory_uri().'/assets/js/scripts.js',array('jquery'),NULL,true);
			
			wp_enqueue_script('jquery');
			wp_enqueue_script('bootstrap');
			wp_enqueue_script('superfish');
			wp_enqueue_script('waypoint');
			wp_enqueue_script('waypoint-sticky');
			wp_enqueue_script('slicknav');
			wp_enqueue_script('slick');
			wp_enqueue_script('cookie');
			wp_enqueue_script('wookmark');
			wp_enqueue_script('scripts');
			
			if(is_singular('post')){
				wp_enqueue_script('video');
				wp_enqueue_script('media');
				wp_enqueue_script('scrollbar');
				wp_enqueue_script( 'comment-reply');
			}
			
		}
		
		public function _action_vasq_register_admin_script(){
			$screen = get_current_screen();
			if('toplevel_page__options' == $screen->id){
				wp_register_script('vasq-admin',get_template_directory_uri().'/assets/js/admin.js',array('jquery'),NULL,true);
				wp_enqueue_script('vasq-admin');
			}
		}

	}
}

add_action('init','vasqCSSJS',1);
function vasqCSSJS(){
	$vasqCSSJS = new vasqCSSJS;
}
