<?php
// Custom CSS

function vasq_darker_color($color){
	if(!preg_match('/^#?([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i', $color, $parts)) return;
	
	$out = ""; // Prepare to fill with the results
	for($i = 1; $i <= 3; $i++) {
		$parts[$i] = hexdec($parts[$i]);
		$parts[$i] = round($parts[$i] * 80/100); // 80/100 = 80%, i.e. 20% darker
		$out .= str_pad(dechex($parts[$i]), 2, '0', STR_PAD_LEFT);
	}
	return $out;
}
function vasq_custom_style(){
	global $vasq_options;
	$main_color = $vasq_options['main-color'];
	//$main_color_hover = $vasq_options['main-color-hover'];
	$menuborder = $vasq_options['menu-border'];
	$menucolor = $vasq_options['menu-color'];
	$menucolorhover = $vasq_options['menu-color-hover'];
	$darker_color_main = vasq_darker_color($main_color);
	$darker_color_main = ($darker_color_main == '') ? $main_color : $darker_color_main;
	$logo_height = isset($vasq_options['logo-max-height']) ? $vasq_options['logo-max-height'] : '';
	$logo_height = ($logo_height != '') ? $logo_height : 30;
	$css ='
		<style type="text/css">
			html #topbar #logo img{max-height:'.$logo_height.'px;}
			.layout-sorter .showpost ul a:hover, .page-title h2 span, #wp-calendar tfoot td a, .format-text.the-content a, .tabs-comment .nav-tab a:hover, .tabs-comment .nav-tab a.on, .single-info table a, .single-video .video-feed  a:hover, .vjs-default-skin .vjs-big-play-button:hover::before, .layout-sorter .layout-style a:hover, .layout-sorter .layout-style a.on,.watch-later-control.on, .layout-sorter .ascdesc a:hover, .layout-sorter .ascdesc a.on, .layout-sorter .dropcat ul a:hover, .bread a:hover, .bread span, .slicknav_nav a:hover a, .slicknav_nav a:hover, .main-grid .sorter a.on, .widget_tag_cloud a:hover, .widget ul li a:hover, .page-pagination a:hover, .page-pagination span, .meta a:hover, .title a:hover, .util a.on, .util a:hover{color: '.$main_color.';}
			#wp-calendar tbody td#today a,#wp-calendar caption,.single-video .video-feed span:after,.vjs-default-skin .vjs-volume-level,.vjs-default-skin .vjs-play-progress,.ps-container:hover > .ps-scrollbar-y-rail:hover > .ps-scrollbar-y,.ps-container > .ps-scrollbar-y-rail > .ps-scrollbar-y,.form-basic input[type="submit"],.button,.category-column .head a:link,.category-column .head a:visited,.category-column .head a:active,.category-column .head a:hover,.category-column .head a,.widget-title:after,.watch-later a{background: '.$main_color.';}
			.category-column .head a:hover,
			.watch-later a:hover,
			.form-basic input[type="submit"]:hover,
			.button:hover{
				 background: #'.$darker_color_main.' !important;
			}
			.header-3 .sf-menu > li ul li:first-child > a,.header-3 .sf-menu > li ul a,.header-3 .sf-menu > li,.header-3 #midbar,
			.header-1 .sf-menu > li ul li:first-child > a,.header-1 .sf-menu > li ul a,.header-1 .sf-menu > li,.header-1 #midbar{
				border-color:'.$menuborder.';
			}
			#top .slicknav_menu .slicknav_icon-bar{
				background:'.$menucolor.'
			}
			.sf-menu > li ul > li > a, .sf-menu > li ul a, .sf-menu > li > a,.sf-menu > li > a,.sf-menu > li > a{
				color:'.$menucolor.'
			}
			.sf-menu > li ul > li:hover > a, .sf-menu > li ul a:hover, .sf-menu > li > a:hover,.sf-menu > li:hover > a,.sf-menu > li.current-menu-item > a{
				color:'.$menucolorhover.'
			}
			'.$vasq_options['css_editor'].'
		</style>
	';
	echo $css;
}