<?php

add_action( 'add_meta_boxes', 'vq_add_metabox' );
function vq_add_metabox(){
        add_meta_box( 'vasq-post-metabox', 'Post Options', 'vq_meta_box', 'post', 'normal', 'high' );
}

function vq_check_ads(){
	return is_plugin_active( 'elegant-video-ads/vasq-ads.php' );
}

function vq_meta_box(){
        global $post, $vasq_options;
	$selected = '';
	$post_ads = array();
        $values = get_post_custom( $post->ID );
        $video_link = isset( $values['video_link'] ) ? esc_attr( $values['video_link'][0] ) : '';
	$video_duration = isset( $values['video_duration'] ) ? esc_attr( $values['video_duration'][0] ) : '';
	$video_banner = isset( $values['video_banner'] ) ? esc_attr( $values['video_banner'][0] ) : '';
	$video_featured = isset( $values['video_featured'] ) ? esc_attr( $values['video_featured'][0] ) : '';
	$video_excerpt = isset( $values['video_excerpt'] ) ? esc_attr( $values['video_excerpt'][0] ) : '';
	if(vq_check_ads()) {
		$use_ads = $vasq_options['use-ads'];
		$default_ads = $vasq_options['ads-default'];
		$selected = isset( $values['video_ads'] ) ? esc_attr( $values['video_ads'][0] ) :'';
		if($use_ads == 1 && $default_ads != ''){
			$selected = ($selected == '') ? $default_ads : $selected;
		}
		$args = array(
                        'post_status'      => 'publish',
                        'posts_per_page'   => -1,
                        'post_type'        => 'vasq-ads',
                        'orderby'          => 'name',
                        'order'            => 'ASC',
                );
                $post_ads = get_posts($args);
	}
	$choosed =  isset( $values['video_cta'] ) ? esc_attr( $values['video_cta'][0] ) :'';
	$cta = $vasq_options['cta-button'];
	$default_cta = $vasq_options['cta-default'];
	$use_cta = $vasq_options['use-cta'];
	if($use_cta == 1 && $default_cta != ''){
		$choosed = ($choosed == '') ? $default_cta : $choosed;
	}
        wp_nonce_field( 'vq_meta_box_nonce', 'meta_box_nonce' );
        ?>
	<?php if( vq_check_ads() ) :?>
	<p class="video-ads vq_metabox_wrap">
		<label for="video_ads"><?php _e('Attach Ads to this video','vasq');?> : </label>
		<?php if(is_array($post_ads) && !empty($post_ads)):?>
			<select name="video_ads" id="video_ads">
				<option value="none"  <?php selected( $selected,'none'); ?>><?php _e('None','vasq');?></option>
				<?php foreach($post_ads as $p):?>
				 <option value="<?php echo $p->ID;?>" <?php selected( $selected, $p->ID ); ?>><?php echo $p->post_title;?> <?php if($default_ads != '' && $use_ads == 1 && $default_ads == $p->ID) _e('(default)','vasq');?></option>
				<?php endforeach;?>
			</select>
		<?php else:?>
			<strong><?php _e('Looks like you haven\'t create any Ads','vasq');?></strong>
		<?php endif;?>
	 </p>
	<?php endif;?>
	<p class="video-cta vq_metabox_wrap">
		<label for="video_cta"><?php _e('Attach CTA to this video','vasq');?> : </label>
		<?php if(is_array($cta) && !empty($cta)):?>
		  <select name="video_cta" id="video_cta">
			<option value="none"  <?php selected( $choosed,'none'); ?>><?php _e('None','vasq');?></option>
			<?php foreach($cta as $c => $v):?>
			<option value="<?php echo $c;?>" <?php selected( $choosed, $c ); ?>><?php echo $v['title'];?> <?php if($default_cta != '' && $use_cta == 1 && $default_cta == $c) _e('(default)','vasq');?></option>
		       <?php endforeach;?>
                </select>
		  <?php else:?>
			<strong><?php _e('Looks like you haven\'t create any Call to Action content','vasq');?></strong>
		  <?php endif;?>
	 </p>
	<p class="video-excerpt vq_metabox_wrap">
		<label for="video-excerpt"><?php _e('Input excerpt post here','vasq');?></label>
		<textarea name="video_excerpt" id="video_excerpt" class="widefat"><?php echo $video_excerpt;?></textarea>
	 </p>
	 <p class="video-featured vq_metabox_wrap">
		    <label for="video-featured">
			<input type="checkbox" name="video_featured" id="video_featured" value="yes" <?php if ( isset ( $values['video_featured'] ) ) checked( $values['video_featured'][0], 'yes' ); ?> />
			<?php _e( 'Set as featured ?', 'vasq' )?>
		    </label>
	 </p>
        <p class="video-link vq_metabox_wrap">
                <label for="video_link"><?php _e('Paste YouTube video link here','vasq');?></label>
		<input type="text" class="widefat" name="video_link" id="video_link" value="<?php echo $video_link;?>">
		<a href="#" class="button button-primary button-large <?php if($video_link != '') echo 'clicked';?>" style="margin-top:10px;">
			<?php echo ($video_link == '' ) ? __('Generate video','vasq') : __('Clear Video','vasq');?>
		</a>
        </p>
	<p class="video-banner vq_metabox_wrap">
		<span class="banner-table">
			<span class="banner-cell">
				<img src="<?php echo $video_banner;?>" <?php echo ($video_banner != '') ? 'style="display:inline-block;"' : '';?> >
				<input type="text" class="widefat" name="video_banner" id="video_banner" value="<?php echo $video_banner;?>">
			</span>
		</span>
	</p>
	<p class="video-duration vq_metabox_wrap">
                <label for="video_duration"><?php _e('Video Duration','vasq');?> : </label>
		<strong><?php echo $video_duration;?></strong>
		<input type="hidden" class="widefat" name="video_duration" id="video_duration" value="<?php echo $video_duration;?>">
        </p>
        <?php  
}

add_action( 'save_post', 'vq_meta_box_save' );
function vq_meta_box_save( $post_id ){
	// Autosave, do nothing
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return;
	}
	// AJAX? Not used here
	if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {
		return;
	}
	// Check user permissions
	if ( ! current_user_can( 'edit_post', $post_id ) ){
		return;
	}
	// Return if it's a post revision
	if ( false !== wp_is_post_revision( $post_id ) ){
		return;
	}
		
	 // if our nonce isn't there, or we can't verify it, bail
	 if( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'vq_meta_box_nonce' ) ) {
		 return;
	 }
	 if(vq_check_ads()) {
		if( isset( $_POST['video_ads'] ) ){
			update_post_meta( $post_id, 'video_ads', $_POST['video_ads'] );
		}
	 }
	if( isset( $_POST['video_excerpt'] ) ){
                update_post_meta( $post_id, 'video_excerpt', $_POST['video_excerpt'] );
        }
        if( isset( $_POST['video_link'] ) ){
                update_post_meta( $post_id, 'video_link', $_POST['video_link'] );
        }
	
	if( isset( $_POST['video_duration'] ) ){
                update_post_meta( $post_id, 'video_duration', $_POST['video_duration'] );
        }
	if( isset( $_POST['video_banner'] ) && get_post_meta($post_id,'video_banner',true) != $_POST['video_banner']  ){
		$src = vasq_sideload($_POST['video_banner'],$post_id,'',date('Y-m-d').$post_id);
		$src = wp_get_attachment_url($src);
		update_post_meta( $post_id, 'video_banner', $src );
	}
	
	if( isset( $_POST[ 'video_featured' ] ) ) {
		 update_post_meta( $post_id, 'video_featured', 'yes' );
	} else {
		update_post_meta( $post_id, 'video_featured', 'no' );
	}
        
	if(get_post_meta($post_id,'vq_post_views_count', true) == '' ){
		update_post_meta( $post_id, 'vq_post_views_count', '0' );
	}
	
	if(get_post_meta($post_id,'likes', true) == '' ){
		update_post_meta( $post_id, 'likes', '0' );
	}
	
	if(get_post_meta($post_id,'dislike', true) == '' ){
		update_post_meta( $post_id, 'dislike', '0' );
	}
	
	if( isset( $_POST['video_cta'] ) ){
                update_post_meta( $post_id, 'video_cta', $_POST['video_cta'] );
        }
}

add_action('admin_footer','admin_script_footer',100);
function admin_script_footer(){
        global $pagenow,$vasq_options;
        $page	= array('post.php','post-new.php');
        if(!in_array($pagenow,$page)) {
                return;
        };
		?>
                <script type="text/javascript">
                        (function($){
				function youtubeDuration(input){
					var reptms = /^PT(?:(\d+)H)?(?:(\d+)M)?(?:(\d+)S)?$/,
						hours = 0, minutes = 0, seconds = 0, totalseconds,
						totalseconds = '';
			      
					if (reptms.test(input)) {
						var matches = reptms.exec(input);
						if (matches[1]) hours = Number(matches[1]);
						if (matches[2]) minutes = Number(matches[2]);
						if (matches[3]) seconds = Number(matches[3]);
						hours = ( hours == '0' ) ? '' : hours + ':';
						seconds = (seconds.toString().length == 1 ) ? '0'+ seconds : seconds;
						totalseconds = hours + minutes +':' + seconds;
						return totalseconds;
					}
					return totalseconds;
				}
				// Linkify youtube URLs which are not already links.
				function linkifyYouTubeURLs(text) {
				    var re = /https?:\/\/(?:[0-9A-Z-]+\.)?(?:youtu\.be\/|youtube(?:-nocookie)?\.com\S*[^\w\s-])([\w-]{11})(?=[^\w-]|$)(?![?=&+%\w.-]*(?:['"][^<>]*>|<\/a>))[?=&+%\w.-]*/ig;
				    return text.replace(re, '$1');
				}
				function ytVidId(url) {
					var p = /^(?:https?:\/\/)?(?:www\.)?youtube\.com\/watch\?(?=.*v=((\w|-){11}))(?:\S+)?$/;
					return (url.match(p)) ? RegExp.$1 : false;
				}
				$('.video-link.vq_metabox_wrap a').click(function(e){
					if ($(this).hasClass('clicked')) {
						 $('.video-link.vq_metabox_wrap input').val('');
						$('#title').val('');
						$('.video-duration.vq_metabox_wrap input').val('');
						$('.video-banner img').attr('src','').hide();
						$('.video-banner input').val('');
						tinyMCE.activeEditor.setContent('');
						$(this).removeClass('clicked').text('<?php _e("Generate Video","vasq");?>');
					}else{
						var video_link = $('.video-link.vq_metabox_wrap input').val();
						if ( video_link != '') {
							if (ytVidId(video_link) != false) {
								var video_id = linkifyYouTubeURLs(video_link);
								$.getJSON('https://www.googleapis.com/youtube/v3/videos?id='+video_id+'&key=<?php echo $vasq_options["api-key"];?>&part=snippet,contentDetails,statistics,status',function(data,status,xhr){
									if (typeof(data.items[0]) != "undefined") {
										var maindata = data.items[0],
											banner = (maindata.snippet.thumbnails.high == '' ) ? maindata.snippet.thumbnails.default.url : maindata.snippet.thumbnails.high.url;
										$('#title').val(maindata.snippet.title);

										$('.video-duration.vq_metabox_wrap input').val(youtubeDuration(maindata.contentDetails.duration));
										$('.video-duration.vq_metabox_wrap strong').html(youtubeDuration(maindata.contentDetails.duration));
										if (banner != '' && $('.video-banner img').attr('src') == '') {
											$('.video-banner img').attr('src',banner).show();
											$('.video-banner input').val(banner);
										}
										tinyMCE.activeEditor.setContent('<p>'+ maindata.snippet.description+'</p>');
										$('.video-link.vq_metabox_wrap a').addClass('clicked').text('<?php _e("Clear Video","vasq");?>');
									 }
								});
							}else{
								alert('<?php _e("Input valid YouTube video link !!","vasq");?>');
							}
						}else{
							alert('<?php _e("Input YouTube video link first !!","vasq");?>');
						}	
					}
					e.preventDefault();
				});
                        })(jQuery);
                </script>
        <?php      
}