<?php
	global $vasq_options;
        $pages = get_pages();
        $pair_pages = array();
        if(is_array($pages) && !empty($pages)){
		foreach($pages as $p){
			$pair_pages[$p->ID] = $p->post_title;
		}
	}
        $cats = get_categories();
        $pair_cats = array();
        if(is_array($cats) && !empty($cats)){
		foreach($cats as $c){
			$pair_cats[$c->term_id] = $c->name;
		}
	}
	$pair_cta = array();
	$cta = get_option('vasq_options');
	$cta = isset($cta['cta-button']) ?  $cta['cta-button'] : '';

	if(is_array($cta) && !empty($cta)){
		foreach($cta as $c => $v){
			$pair_cta[$c] = $v['title'];
		}
	}
        $opt = array(
                'title'  => __( 'Content Settings', 'vasq' ),
                'icon'   => 'el-icon-tasks',
                // 'submenu' => false, // Setting submenu to false on a given section will hide it from the WordPress sidebar menu!
                'fields' => array(
			 array(
				'id'       => 'home-latest',
				'type'     => 'text',
				'title'    => __( 'Home Title Text', 'vasq' ),
				'default'  => 'Latest Video',
			),
			array(
				'id'       => 'excerpt-video',
				'type'     => 'switch',
				'title'    => __( 'Display Post Excerpt ?', 'vasq' ),
				'subtitle' => __( 'If yes choosed, the post excerpt will appear', 'vasq' ),
				'default'  => 1,
				'on'       => 'Yes',
				'off'      => 'No',
			),
			array(
				'id'       => 'show-sidebar',
				'type'     => 'switch',
				'title'    => __( 'Display Sidebar at Homepage ?', 'vasq' ),
				'subtitle' => __( 'If yes choosed, the sidebar will appear at homepage', 'vasq' ),
				'default'  => 1,
				'on'       => 'Yes',
				'off'      => 'No',
			),
                      array(
                        'id'       => 'watch-later-pages',
                        'type'     => 'select',
                        'multi'    => false,
                        'title'    => __('Watch Later Page', 'vasq'),
                        'subtitle' => __('Choose page to display watch later results', 'vasq'),
                        'desc'     => __('Create page using "Watch Later" page template then choose it here.', 'vasq'),
                        //Must provide key => value pairs for radio options
                        'options'  => $pair_pages,
                    ),
                      array(
                        'id'       => 'category-homepage',
                        'type'     => 'select',
                        'multi'    => true,
                        'title'    => __('Homepage Category', 'vasq'),
                        'subtitle' => __('Choose multiple categories to show up at homepage', 'vasq'),
                        //Must provide key => value pairs for radio options
                        'options'  => $pair_cats,
                    ),
                      array(
                        'id'               => 'content-404',
                        'type'             => 'editor',
                        'title'            => __('404 Content', 'vasq'), 
                        'subtitle'         => __('Content to display in 404 page', 'vasq'),
                        'default'          => 'Apologize, but we can find what you looking for.You can custom this text at the admin page.',
                        'args'   => array(
                            'teeny'            => false,
                            'textarea_rows'    => 10
                        )
                    ),
		      array(
			'id'       => 'disable-seo',
			'type'     => 'switch',
			'title'    => __( 'Disable Theme SEO Meta ?', 'vasq' ),
			'subtitle' => __( 'If yes choosed, SEO Meta feature from theme will be disabled to prevent duplicate Meta value from third party plugin like YOAST.', 'vasq' ),
			'default'  => 0,
			'on'       => 'Yes',
			'off'      => 'No',
			),
			array(
				'id'       => 'autoplay-video',
				'type'     => 'switch',
				'title'    => __( 'Autoplay', 'vasq' ),
				'subtitle' => __( 'If yes choosed, the video will autoplay in detail post', 'vasq' ),
				'default'  => 1,
				'on'       => 'Yes',
				'off'      => 'No',
			),
			 array(
				'id'       => 'pause-away',
				'type'     => 'switch',
				'title'    => __( 'Pause video when not focus ?', 'vasq' ),
				'subtitle' => __( 'If yes choosed, video will paused when user out of focus video window', 'vasq' ),
				'default'  => 0,
				'on'       => 'Yes',
				'off'      => 'No',
			),
			 array(
				'id'       => 'auto-next',
				'type'     => 'switch',
				'title'    => __( 'Autoplay Next Video?', 'vasq' ),
				'subtitle' => __( 'If yes choosed, autoplay for next video in same category will applied after 5 seconds', 'vasq' ),
				'default'  => 0,
				'on'       => 'Yes',
				'off'      => 'No',
			),
			array(
				'id'       => 'use-cta',
				'type'     => 'switch',
				'title'    => __( 'Use CTA in All Post', 'vasq' ),
				'description'    => __('If yes choosed, all post will automatically have Call to Action Button below video', 'vasq'),
				'default'  => 0,
				'on'       => 'Yes',
				'off'      => 'No',
			),
			 array(
				'id'       => 'cta-default',
				'type'     => 'select',
				'required' => array( 'use-cta', '=', '1' ),
				'multi'    => false,
				'title'    => __('Choose Default CTA', 'vasq'),
				'subtitle' => __('This Default CTA will be used for all video', 'vasq'),
				'desc'     => __('However, you still able to hide or change CTA in each video post', 'vasq'),
				//Must provide key => value pairs for radio options
				'options'  => $pair_cta,
			    ),
			 array(
				'id'          => 'cta-button',
				'type'        => 'slides',
				'title'       => __('Call to Action Button', 'vasq'),
				'subtitle'    => __('Create unlimited CTA that will attached below video', 'vasq'),
				'placeholder' => array(
				    'title'           => __('CTA Title', 'vasq'),
				    'description'     => __('CTA Content', 'vasq'),
				    'url'             => __('CTA Link', 'vasq'),
				),
			),
			
		 
                ),
);

return $opt;