<?php

$opt = array(
        'icon'       => 'el-icon-website',
        'title'      => __( 'Styling Options', 'vasq' ),
        'subsection' => false,
        'fields'     => array(
                array(
                        'id'       => 'opt-layout',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Main Layout', 'vasq' ),
                        'subtitle' => __( 'Select layout style', 'vasq' ),
                        'options'  => array(
                            'boxed' => array(
                                'alt' => 'Boxed',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/site-box-style.png'
                            ),
                             'frame' => array(
                                'alt' => 'Frame',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/site-frame-style.png'
                            ),
                             'full-width' => array(
                                'alt' => 'Full Width',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/site-full-width.png'
                            ),
                             'rounded' => array(
                                'alt' => 'Rounded',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/site-rounded-style.png'
                            ),
                        ),
                        'default'  => 'full-width'
                ),
                array(
                        'id'       => 'header-layout',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Header Style', 'vasq' ),
                        'subtitle' => __( 'Select header style', 'vasq' ),
                        'options'  => array(
                            'header-1' => array(
                                'alt' => 'Header 1',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/head-style-1.png'
                            ),
                             'header-2' => array(
                                'alt' => 'Header 2',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/head-style-2.png'
                            ),
                              'header-3' => array(
                                'alt' => 'Header 3',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/head-style-3.png'
                            ),
                        ),
                        'default'  => 'header-1'
                ),
                array(
                        'id'       => 'footer-layout',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Footer Widget Style', 'vasq' ),
                        'subtitle' => __( 'Select footer widget style', 'vasq' ),
                        'options'  => array(
                            'footer-1' => array(
                                'alt' => 'Footer 1',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/widget-style-1.png'
                            ),
                            'footer-2' => array(
                                'alt' => 'Footer 2',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/widget-style-2.png'
                            ),
                            'footer-3' => array(
                                'alt' => 'Footer 3',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/widget-style-3.png'
                            ),
                            'footer-4' => array(
                                'alt' => 'Footer 4',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/widget-style-4.png'
                            ),
                            'footer-5' => array(
                                'alt' => 'Footer 5',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/widget-style-5.png'
                            ),
                        ),
                        'default'  => 'footer-4'
                ),
                 array(
                        'id'       => 'featured-layout',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Featured Style', 'vasq' ),
                        'subtitle' => __( 'Select featured style', 'vasq' ),
                        'options'  => array(
                            'tile' => array(
                                'alt' => 'Tile',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/featured-layout-1.png'
                            ),
                            'carousel' => array(
                                'alt' => 'Carousel',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/featured-layout-2.png'
                            ),
                             'slideshow' => array(
                                'alt' => 'Slideshow',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/featured-layout-3.png'
                            ),
                        ),
                        'default'  => 'tile'
                ),
                 array(
                        'id'       => 'featured-total',
                        'type'     => 'spinner', 
                        'title'    => __('Featured Item Show', 'vasq'),
                        'subtitle' => __('Input total active item for carousel layout only.','vasq'),
                        'default'  => '3',
                        'min'      => '2',
                        'step'     => '1',
                        'max'      => '5',
                ),
                  array(
                        'id'       => 'content-layout',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Homepage Content Style', 'vasq' ),
                        'subtitle' => __( 'Select homepage content style', 'vasq' ),
                        'options'  => array(
                            'regular-loop' => array(
                                'alt' => 'Regular Loop',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/main-style-1.png'
                            ),
                            'main-grid' => array(
                                'alt' => 'Main Grid',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/main-style-2.png'
                            ),
                            'main-pinterest' => array(
                                'alt' => 'Main Pinterest',
                                'img' => get_template_directory_uri(). '/assets/img/fw-layout/main-style-3.png'
                            ),
                        ),
                        'default'  => 'regular-loop'
                ),
                   array(
                        'id'       => 'default-grid',
                        'type'     => 'switch',
                        'title'    => __( 'Default Column Grid', 'vasq' ),
                         'required' => array( 'content-layout', '=', 'main-grid' ),
                        'subtitle' => __( 'Choose default column for grid style', 'vasq' ),
                        'default'  => 0,
                        'on'       => '2 Column',
                        'off'      => '3 Column',
                    ),
                   array(
                        'id'       => 'grid-sorter',
                        'type'     => 'switch',
                        'title'    => __( 'Grid Changer Icon', 'vasq' ),
                         'required' => array( 'content-layout', '=', 'main-grid' ),
                        'subtitle' => __( 'Show or Hide icon for change column layout style', 'vasq' ),
                        'default'  => 0,
                        'on'       => 'Show',
                        'off'      => 'Hide',
                    ),
                 array(
                        'id'       => 'opt-color-scheme',
                        'type'     => 'image_select',
                        'compiler' => false,
                        'title'    => __( 'Color Preset', 'vasq' ),
                        'subtitle' => __( 'Select color scheme', 'vasq' ),
                        'options'  => array(
                            '#dd4a3b' => array(
                                'alt' => '1',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/1.png'
                            ),
                            '#1abc9c' => array(
                                'alt' => '2',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/2.png'
                            ),
                            '#2ecc71' => array(
                                'alt' => '3',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/3.png'
                            ),
                            '#3498db' => array(
                                'alt' => '4',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/4.png'
                            ),
                            '#8e44ad' => array(
                                'alt' => '5',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/5.png'
                            ),
                            '#d35400' => array(
                                'alt' => '6',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/6.png'
                            ),
                            '#43a39f' => array(
                                'alt' => '8',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/8.png'
                            ),
                            '#2f88a7' => array(
                                'alt' => '9',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/9.png'
                            ),
                            '#20bfe1' => array(
                                'alt' => '10',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/10.png'
                            ),
                            '#5ed89b' => array(
                                'alt' => '11',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/11.png'
                            ),
                            '#755df3' => array(
                                'alt' => '12',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/12.png'
                            ),
                            '#e8c157' => array(
                                'alt' => '13',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/13.png'
                            ),
                             '#e4587a' => array(
                                'alt' => '14',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/14.png'
                            ),
                             '#f1c40f' => array(
                                'alt' => '15',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/19.png'
                            ),
                             '#c972d4' => array(
                                'alt' => '16',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/16.png'
                            ),
                             '#fd904b' => array(
                                'alt' => '17',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/17.png'
                            ),
                             '#2aa4c5' => array(
                                'alt' => '18',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/18.png'
                            ),
                             '#c64c6a' => array(
                                'alt' => '19',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/15.png'
                            ),
                             '#1abc9c' => array(
                                'alt' => '20',
                                'img' => get_template_directory_uri(). '/assets/img/fw-color/20.png'
                            ),
                        ),
                        'default'  => '#dd4a3b'
                ),
                array(
                        'id'       => 'main-color',
                        'type'     => 'color',
                        'title'    => __('Global Color', 'vasq'),
                        'subtitle' => __('Pick a global color', 'vasq'),
                        'default'  => '#dd4a3b',
                        'validate' => 'color',
                ),
                // array(
                //        'id'       => 'main-color-hover',
                //        'type'     => 'color',
                //        'title'    => __('Global Color Hover', 'vasq'),
                //        'subtitle' => __('Pick a global hover color', 'vasq'),
                //        'default'  => '#d33625',
                //        'validate' => 'color',
                //),
                array(
                      'id'       => 'body-background',
                      'type'     => 'background',
                      'output'   => array( 'html body' ),
                      'title'    => __( 'Body Background', 'vasq' ),
                      'subtitle' => __( 'Body background with image, color, etc.', 'vasq' ),
                      'default'   =>array(
                                  'background-color' =>  '#FFFFFF'                
                          ),
                ),
                array(
                        'id'       => 'header-background',
                        'type'     => 'background',
                        'output'   => array( '#topbar,.header-2 #midbar,.header-2 .sf-menu > li ul a'),
                        'title'    => __( 'Header Background', 'vasq' ),
                        'subtitle' => __( 'Header background with image, color, etc.', 'vasq' ),
                        'default'   =>array(
                                    'background-color' =>  '#3b3b3b'                
                            ),
                ),
                 array(
                        'id'       => 'topbar-background',
                        'type'     => 'background',
                        'output'   => array( '#top.header-2 #midbar'),
                        'title'    => __( 'Topbar Background', 'vasq' ),
                        'subtitle' => __( 'Topbar background.Only work if header 2 choosed', 'vasq' ),
                        'default'   =>array(
                                    'background-color' =>  '#3b3b3b'                
                            ),
                ),
                array(
                        'id'       => 'menu-background',
                        'type'     => 'background',
                        'output'   => array( '.header-1 #midbar, .header-1 .sf-menu > li ul a,.header-3 #midbar, .header-3 .sf-menu > li ul a'),
                        'title'    => __( 'Menu Background', 'vasq' ),
                        'subtitle' => __( 'Menu background with image, color, etc.Only affected on Header 1 and Header 3', 'vasq' ),
                        'default'   =>array(
                                    'background-color' =>  '#fbfcfc'                
                            ),
                ),
                array(
                        'id'       => 'menu-color',
                        'type'     => 'color',
                        'title'    => __('Menu Text Color', 'vasq'),
                        'subtitle' => __('Pick a color for menu text', 'vasq'),
                        'default'  => '#222',
                        'validate' => 'color',
                ),
                array(
                        'id'       => 'menu-color-hover',
                        'type'     => 'color',
                        'title'    => __('Menu Text Color Hover', 'vasq'),
                        'subtitle' => __('Pick a color for menu text hover', 'vasq'),
                        'default'  => '#dd4a3b',
                        'validate' => 'color',
                ),
                array(
                        'id'       => 'menu-border',
                        'type'     => 'color',
                        'title'    => __('Menu Border Color', 'vasq'),
                        'subtitle' => __('Pick a color for menu border.Only affected on Header 1 and Header 3', 'vasq'),
                        'default'  => '#e0dddd',
                        'validate' => 'color',
                ),
                 array(
                        'id'       => 'footer-background',
                        'type'     => 'background',
                        'output'   => array('#tribute'),
                        'title'    => __( 'Footer Background', 'vasq' ),
                        'subtitle' => __( 'Footer background with image, color, etc.', 'vasq' ),
                        'default'   =>array(
                                    'background-color' =>  '#3b3b3b'                
                            ),
                ),
                  array(
                        'id'       => 'footer-color',
                        'type'     => 'color',
                        'output'   => array('#tribute p,#tribute a,#tribute'),
                        'title'    => __('Footer Color', 'vasq'),
                        'subtitle' => __('Pick a footer color', 'vasq'),
                        'default'  => '#ffffff',
                        'validate' => 'color',
                ),
                array(
                        'id'       => 'video-title',
                        'type'     => 'switch',
                        'title'    => __( 'Video Title Position', 'vasq' ),
                        'description'    => __( 'If you\'re using CTA, it will be better if you choose title above video', 'vasq' ),
                        'default'  => 0,
                        'on'       => 'Above Video',
                        'off'      => 'Below Video',
                ),
                array(
                    'id'       => 'css_editor',
                    'type'     => 'ace_editor',
                    'title'    => __('Custom CSS Code', 'vasq'),
                    'subtitle' => __('Paste your custom CSS code here.', 'vasq'),
                    'mode'     => 'css',
                    'theme'    => 'monokai',
                    'default'  => "/** WRITE CUSTOM CSS HERE , USE !important TO OVERIDE DEFAULT VALUE **/"
                ),
        )
    );

return $opt;