<?php
/**
 * Easy Digital Downloads Theme Updater
 *
 * @package EDD Sample Theme
 */

// Includes the files needed for the theme updater
if ( !class_exists( 'EDD_Theme_Updater_Admin' ) ) {
	include( dirname( __FILE__ ) . '/theme-updater-admin.php' );
}

global $configs;
$my_theme ='';
if(function_exists('wp_get_theme')){
    $my_theme = wp_get_theme();
    $configs = array(
        'remote_api_url' => 'http://amazehub.net', // Site where EDD is hosted
        'item_name' => 'Elegant TubePress (Personal License)', // Name of theme
        'theme_slug' => 'vasq', // Theme slug
        'version' => $my_theme->get('Version'), // The current version of this theme
        'author' => 'AmazeHub Team', // The author of this theme
        'download_id' => '3583', // Optional, used for generating a license renewal link
        'renew_url' => 'http://amazehub.net/downloads/elegant-tubepress-personal-license/' // Optional, allows for a custom license renewal link
    );
}elseif(function_exists('get_theme_data')){
    $my_theme = get_theme_data();
    $configs = array(
        'remote_api_url' => 'http://amazehub.net', // Site where EDD is hosted
        'item_name' => 'Elegant TubePress (Personal License)', // Name of theme
        'theme_slug' => 'vasq', // Theme slug
        'version' => $my_theme->get('Version'), // The current version of this theme
        'author' => 'AmazeHub Team', // The author of this theme
        'download_id' => '3583', // Optional, used for generating a license renewal link
        'renew_url' => 'http://amazehub.net/downloads/elegant-tubepress-personal-license/' // Optional, allows for a custom license renewal link
    );
}

// Loads the updater classes
$updater = new EDD_Theme_Updater_Admin(

	// Config settings
	$config = $configs,

	// Strings
	$strings = array(
		'theme-license' => __( 'Theme License', 'edd-theme-updater' ),
		'enter-key' => __( 'Enter your theme license key.', 'edd-theme-updater' ),
		'license-key' => __( 'License Key', 'edd-theme-updater' ),
		'license-action' => __( 'License Action', 'edd-theme-updater' ),
		'deactivate-license' => __( 'Deactivate License', 'edd-theme-updater' ),
		'activate-license' => __( 'Activate License', 'edd-theme-updater' ),
		'status-unknown' => __( 'License status is unknown.', 'edd-theme-updater' ),
		'renew' => __( 'Renew?', 'edd-theme-updater' ),
		'unlimited' => __( 'unlimited', 'edd-theme-updater' ),
		'license-key-is-active' => __( 'Product Update License key is ACTIVE.', 'edd-theme-updater' ),
		'expires%s' => __( 'Expires %s.', 'edd-theme-updater' ),
		'%1$s/%2$-sites' => __( 'You have %1$s / %2$s sites activated.', 'edd-theme-updater' ),
		'license-key-expired-%s' => __( 'Product Update License key EXPIRED %s.', 'edd-theme-updater' ),
		'license-key-expired' => __( 'Product Update License key has EXPIRED.', 'edd-theme-updater' ),
		'license-keys-do-not-match' => __( 'License keys do not match.', 'edd-theme-updater' ),
		'license-is-inactive' => __( 'License is INACTIVE.', 'edd-theme-updater' ),
		'license-key-is-disabled' => __( 'License key is DISABLED.', 'edd-theme-updater' ),
		'site-is-inactive' => __( 'Site is INACTIVE.', 'edd-theme-updater' ),
		'license-status-unknown' => __( 'License status is UNKNOWN.', 'edd-theme-updater' ),
		'update-notice' => __( "Updating this theme will lose any customization on the theme code you have made. 'Cancel' to stop, 'OK' to update. Any customization via the Theme Options will still intact at current.", 'edd-theme-updater' ),
		'update-available' => __('<strong>%1$s %2$s</strong> is available. <a href="%3$s" class="thickbox" title="%4s">Check out what\'s new</a> or <a href="%5$s"%6$s>update now</a>.', 'edd-theme-updater' )
	)

);