<?php
        global $vasq_options;
        $default_col = $vasq_options['default-grid'];
        $default_col = ($default_col == 1) ? 'duo' : 'trio';
        $layout = ( get_query_var('layout_val') == '' ) ? $default_col : get_query_var('layout_val');
        $grid_sorter = $vasq_options['grid-sorter'];
        $post_show = get_option( 'posts_per_page' );
        $total_post = wp_count_posts()->publish;
        $pagination = ceil($total_post / $post_show);
        $current = ( get_query_var('current') == '' ) ? '1' : get_query_var('current');
        $current = ($current > $pagination) ? '1' : $current;
        $offset = ($current - 1) * $post_show;
        $title = $vasq_options['home-latest'];
?>
<div class="main-grid">
        <div class="head-grid">
               <?php if($title != ''):?>
                        <h3 class="widget-title"><?php echo $title;?></h3>
                <?php endif;?>
                <?php if($grid_sorter == 1):?>
                        <div class="sorter">
                                <a data-layout="duo" href="#" <?php if($layout == 'duo') echo 'class="on"';?>><i class="fa fa-th-large"></i></a>
                                <a data-layout="trio" href="#" <?php if($layout == 'trio') echo 'class="on"';?>><i class="fa fa-th"></i></a>
                        </div><!-- end of sorter -->
                 <?php endif;?>
                <form style="display: none" name="main_grid" class="main_grid" method="get">
                         <input type="hidden" class="layout_val" name="layout_val" value="<?php echo $layout;?>">
                         <input type="hidden" class="current" name="current" value="<?php echo $current;?>">
                         <input type="submit">
                </form>
               
        </div><!-- end of head grid -->
        <div class="content-wrapper row">
               <?php
                       $args =  array(
                               'post_type' => 'post',
                               'orderby' => 'date',
                               'order' => 'DESC',
                               'posts_per_page' => $post_show,
                               'offset' => $offset,
                       );
                       $loop = new WP_Query($args);
                       $iteration = 0;
                        $ads = 0;
               ?>
               
               <?php if($loop->have_posts()) : while($loop->have_posts()):$loop->the_post();  ?>
                      <?php
                       switch($layout){
                               case 'duo' :
                                       include(locate_template('view/browse-duo.php'));
                                       break;
                               case 'trio' :
                                      include(locate_template('view/browse-trio.php'));
                                       break;
                       }
                      ?>
               <?php endwhile; ?>
               
               <?php else:?>
                       <div class="no-post-found">
                               <div class="format-text the-content">
                                       <p><?php _e('Sorry, no posts matched your criteria. Try something else. ','vasq')?></p>
                               </div>
                       </div>
               <?php endif;?>
               <?php wp_reset_query(); ?>
        </div><!-- end of content wrapper -->
        <?php if($post_show != -1 && $post_show < $total_post):?>
                <div class="page-pagination cat-sort-pagination">
                       <strong><?php _e('Page','vasq');?> <?php echo $current;?> <?php _e('of','vasq');?> <?php echo $pagination;?></strong>
                       <div>
                        <?php
                                for($i=1;$i <= $pagination;$i++):
                                if($i == $current):
                        ?>
                                <span><?php echo $i;?></span>
                                <?php else:?>
                                <a href="#" data-current="<?php echo $i;?>"><?php echo $i;?></a>
                                <?php endif;?>
                               <?php endfor;?>
                       </div>
                       <div class="clear"></div>
               </div><!-- end of page pagination -->
        <?php endif;?>
</div><!-- end of main grid -->