<?php

class Widget_Top extends WP_Widget {

	// constructor
	
	function __construct(){
		parent::__construct(false, $name = __('Video', 'vasq') , array('description' => __('Showing video based on like, dislike and view ','vasq')));
	}

	// widget form creation
        function form($instance) {
        
                // Check values
                if( $instance) {
                     $title = esc_attr($instance['title']);
		     $term = esc_attr($instance['term']);
		     $total = esc_attr($instance['total']);
		     $show_img =  esc_attr($instance['show_img']);
                } else {
                     $title = '';
		     $term = 'vq_post_views_count';
		     $total = 5;
		     $show_img = 1;
                }
		$opts = array(
			'vq_post_views_count' => __('Most Viewed','vasq'),
			'likes' => __('Most Liked','vasq'),
			'dislike' => __('Most Disliked','vasq'),
			'latest' => __('Latest Video','vasq'),
			'rand' => __('Random','vasq'),
		);
                ?>
                
                <p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Widget Title', 'vasq'); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
                </p>
		
		<p>
			<label for="<?php echo $this->get_field_id('term'); ?>"><?php _e('Show Video by :', 'vasq'); ?></label>
			<select name="<?php echo $this->get_field_name('term'); ?>" id="<?php echo $this->get_field_id('term'); ?>" class="widefat">
			<?php
			foreach ($opts as $opt => $val ) {
				echo '<option value="' . $opt . '" id="' . $opt . '"', $term == $opt ? ' selected="selected"' : '', '>', $val, '</option>';
			}
			?>
			</select>
                </p>
		
		<p>
			<label for="<?php echo $this->get_field_id('total'); ?>"><?php _e('Total Video to Show', 'vasq'); ?></label>
			<input class="widefat" id="<?php echo $this->get_field_id('total'); ?>" name="<?php echo $this->get_field_name('total'); ?>" type="text" value="<?php echo $total; ?>" />
                </p>
		<p>
			<input id="<?php echo $this->get_field_id('show_img'); ?>" name="<?php echo $this->get_field_name('show_img'); ?>" type="checkbox" value="1" <?php checked( '1', $show_img ); ?> />
			<label for="<?php echo $this->get_field_id('show_img'); ?>"><?php _e('Show thumbnail image ?', 'vasq'); ?></label>
		</p>
                
                <?php
        }

	// widget update
	function update($new_instance, $old_instance) {
		 $instance = $old_instance;
                // Fields
                $instance['title'] = strip_tags($new_instance['title']);
                $instance['term'] =$new_instance['term'];
		$instance['total'] =$new_instance['total'];
		$instance['show_img'] =$new_instance['show_img'];
               return $instance;
	}

	// widget display
	function widget($args, $instance) {
		extract( $args );
                // these are the widget options
                $title = apply_filters('widget_title', $instance['title']);
                $term = $instance['term'];
		$total =  $instance['total'];
		$show_img =  $instance['show_img'];
                echo $before_widget;
                // Display the widget
             
                // Check if title is set
                if ( $title ) {
                   echo $before_title . $title . $after_title;
                }
                ?>
		<div class="wrap row">
			
		<?php
			$i = 0;
			$args = array(
				'post_type' => 'post',
				'order' => 'DESC',
				'posts_per_page' => $total,
			);
			if($term == 'latest'){
				$args['orderby'] = 'date';
			}else if($term == 'rand'){
				$args['orderby'] = 'rand';
			}else{
				$args['orderby'] = 'meta_value_num';
				$args['meta_key'] = $term;
			}
			$loop = new WP_Query($args);
		?>
		
		<?php if($loop->have_posts()) : while($loop->have_posts()):$loop->the_post();
			global $post;
			$img = '';
			$thumb = get_post_thumbnail_id();
			if($thumb == ''){
				$img_url = get_post_meta($post->ID,'video_banner',true);
				$img =  aq_resize( $img_url, 310, 173, true,true,true ); //resize & crop img
				if($img == ''){
                                        $img = aq_resize(  vasqGetExportAttachment($post->ID), 310, 173, true,true,true ); //resize & crop img
                                }
			}else{
				$img_url = wp_get_attachment_url( $thumb,'full'); //get img URL
				$img = aq_resize( $img_url, 310, 173, true,true,true ); //resize & crop img
			}
			$like = get_post_meta($post->ID,'likes', true);
			$like = ($like == '') ? 0 : $like;
			$dislike = get_post_meta($post->ID,'dislike', true);
			$dislike = ($dislike == '') ? 0 : $dislike;
			$duration = get_post_meta($post->ID,'video_duration', true);
		?>
		 <div class="item col-sm-6  col-md-12">
			<?php if($show_img):?>
				<figure>
				       <a href="<?php the_permalink();?>" class="anchor">
					       <span class="trans-layer"></span>
					       <img src="<?php echo $img;?>" alt="<?php the_title_attribute();?>" width="310" height="173"></a>
				       <div class="hovered">
					       <div class="util">
						       <a title="play" href="<?php the_permalink();?>"><i class="fa fa-play-circle-o"></i></a>
						       <a title="watch later" href="#" class="later-toggle later-toggle-<?php echo $post->ID;?>" data-cookie="<?php echo $post->ID;?>">
								<i class="fa fa-clock-o"></i>
							</a>
					       </div><!-- end of util -->
					       <span class="duration"><?php echo $duration;?></span>
					       
					       <div class="clear"></div>
				       </div><!-- end of caption -->
			       </figure>
			<?php endif;?>
			<div class="meta">
			       <span><i class="fa fa-eye"></i><small><?php echo  vq_get_post_views($post->ID);?></small></span>
			       <span><i class="fa fa-thumbs-o-up"></i><small><?php echo $like;?></small></span>
			       <span><i class="fa fa-thumbs-o-down"></i><small><?php echo $dislike;?></small></span>
		       </div><!-- end of meta -->
		       <h4 class="title"><a href="<?php the_permalink();?>"><?php the_title();?></a></h4>
	       </div><!-- end of item -->
		<?php if($i % 2 == 1):?>
			<div class="clear"></div>
		<?php endif;?>
		<?php
			$i++;
			endwhile;
		?>
		<?php else:?>
		<?php endif;?>
		<?php wp_reset_query(); ?>
		
		</div>
                <?php
                echo $after_widget;
	}
	
}

// register widget
add_action('widgets_init', 'register_top_widget');
function register_top_widget(){
       register_widget("Widget_Top");
}

